#if defined(VL_PLATFORM_WINDOWS)                
    #define VL_WGL_FUNCTION VL_GL_FUNCTION   
#else                                            
    #define VL_WGL_FUNCTION(TYPE, NAME)          
#endif                                           
// For the moment we don't expose GLX functions  
#ifndef VL_GLX_FUNCTION                          
    #define VL_GLX_FUNCTION(TYPE, NAME)          
#endif                                           

// *** GL EXTENSIONS ***

// Extracted from glext.h version GL_GLEXT_VERSION 70

// GL_VERSION_1_2
#ifdef GL_VERSION_1_2
VL_GL_FUNCTION( PFNGLBLENDCOLORPROC, glBlendColor )
VL_GL_FUNCTION( PFNGLBLENDEQUATIONPROC, glBlendEquation )
VL_GL_FUNCTION( PFNGLDRAWRANGEELEMENTSPROC, glDrawRangeElements )
VL_GL_FUNCTION( PFNGLTEXIMAGE3DPROC, glTexImage3D )
VL_GL_FUNCTION( PFNGLTEXSUBIMAGE3DPROC, glTexSubImage3D )
VL_GL_FUNCTION( PFNGLCOPYTEXSUBIMAGE3DPROC, glCopyTexSubImage3D )
#endif

// GL_VERSION_1_2_DEPRECATED
#ifdef GL_VERSION_1_2_DEPRECATED
VL_GL_FUNCTION( PFNGLCOLORTABLEPROC, glColorTable )
VL_GL_FUNCTION( PFNGLCOLORTABLEPARAMETERFVPROC, glColorTableParameterfv )
VL_GL_FUNCTION( PFNGLCOLORTABLEPARAMETERIVPROC, glColorTableParameteriv )
VL_GL_FUNCTION( PFNGLCOPYCOLORTABLEPROC, glCopyColorTable )
VL_GL_FUNCTION( PFNGLGETCOLORTABLEPROC, glGetColorTable )
VL_GL_FUNCTION( PFNGLGETCOLORTABLEPARAMETERFVPROC, glGetColorTableParameterfv )
VL_GL_FUNCTION( PFNGLGETCOLORTABLEPARAMETERIVPROC, glGetColorTableParameteriv )
VL_GL_FUNCTION( PFNGLCOLORSUBTABLEPROC, glColorSubTable )
VL_GL_FUNCTION( PFNGLCOPYCOLORSUBTABLEPROC, glCopyColorSubTable )
VL_GL_FUNCTION( PFNGLCONVOLUTIONFILTER1DPROC, glConvolutionFilter1D )
VL_GL_FUNCTION( PFNGLCONVOLUTIONFILTER2DPROC, glConvolutionFilter2D )
VL_GL_FUNCTION( PFNGLCONVOLUTIONPARAMETERFPROC, glConvolutionParameterf )
VL_GL_FUNCTION( PFNGLCONVOLUTIONPARAMETERFVPROC, glConvolutionParameterfv )
VL_GL_FUNCTION( PFNGLCONVOLUTIONPARAMETERIPROC, glConvolutionParameteri )
VL_GL_FUNCTION( PFNGLCONVOLUTIONPARAMETERIVPROC, glConvolutionParameteriv )
VL_GL_FUNCTION( PFNGLCOPYCONVOLUTIONFILTER1DPROC, glCopyConvolutionFilter1D )
VL_GL_FUNCTION( PFNGLCOPYCONVOLUTIONFILTER2DPROC, glCopyConvolutionFilter2D )
VL_GL_FUNCTION( PFNGLGETCONVOLUTIONFILTERPROC, glGetConvolutionFilter )
VL_GL_FUNCTION( PFNGLGETCONVOLUTIONPARAMETERFVPROC, glGetConvolutionParameterfv )
VL_GL_FUNCTION( PFNGLGETCONVOLUTIONPARAMETERIVPROC, glGetConvolutionParameteriv )
VL_GL_FUNCTION( PFNGLGETSEPARABLEFILTERPROC, glGetSeparableFilter )
VL_GL_FUNCTION( PFNGLSEPARABLEFILTER2DPROC, glSeparableFilter2D )
VL_GL_FUNCTION( PFNGLGETHISTOGRAMPROC, glGetHistogram )
VL_GL_FUNCTION( PFNGLGETHISTOGRAMPARAMETERFVPROC, glGetHistogramParameterfv )
VL_GL_FUNCTION( PFNGLGETHISTOGRAMPARAMETERIVPROC, glGetHistogramParameteriv )
VL_GL_FUNCTION( PFNGLGETMINMAXPROC, glGetMinmax )
VL_GL_FUNCTION( PFNGLGETMINMAXPARAMETERFVPROC, glGetMinmaxParameterfv )
VL_GL_FUNCTION( PFNGLGETMINMAXPARAMETERIVPROC, glGetMinmaxParameteriv )
VL_GL_FUNCTION( PFNGLHISTOGRAMPROC, glHistogram )
VL_GL_FUNCTION( PFNGLMINMAXPROC, glMinmax )
VL_GL_FUNCTION( PFNGLRESETHISTOGRAMPROC, glResetHistogram )
VL_GL_FUNCTION( PFNGLRESETMINMAXPROC, glResetMinmax )
#endif

// GL_VERSION_1_3
#ifdef GL_VERSION_1_3
VL_GL_FUNCTION( PFNGLACTIVETEXTUREPROC, glActiveTexture )
VL_GL_FUNCTION( PFNGLSAMPLECOVERAGEPROC, glSampleCoverage )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXIMAGE3DPROC, glCompressedTexImage3D )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXIMAGE2DPROC, glCompressedTexImage2D )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXIMAGE1DPROC, glCompressedTexImage1D )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC, glCompressedTexSubImage3D )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC, glCompressedTexSubImage2D )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC, glCompressedTexSubImage1D )
VL_GL_FUNCTION( PFNGLGETCOMPRESSEDTEXIMAGEPROC, glGetCompressedTexImage )
#endif

// GL_VERSION_1_3_DEPRECATED
#ifdef GL_VERSION_1_3_DEPRECATED
VL_GL_FUNCTION( PFNGLCLIENTACTIVETEXTUREPROC, glClientActiveTexture )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1DPROC, glMultiTexCoord1d )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1DVPROC, glMultiTexCoord1dv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1FPROC, glMultiTexCoord1f )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1FVPROC, glMultiTexCoord1fv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1IPROC, glMultiTexCoord1i )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1IVPROC, glMultiTexCoord1iv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1SPROC, glMultiTexCoord1s )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1SVPROC, glMultiTexCoord1sv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2DPROC, glMultiTexCoord2d )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2DVPROC, glMultiTexCoord2dv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2FPROC, glMultiTexCoord2f )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2FVPROC, glMultiTexCoord2fv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2IPROC, glMultiTexCoord2i )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2IVPROC, glMultiTexCoord2iv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2SPROC, glMultiTexCoord2s )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2SVPROC, glMultiTexCoord2sv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3DPROC, glMultiTexCoord3d )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3DVPROC, glMultiTexCoord3dv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3FPROC, glMultiTexCoord3f )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3FVPROC, glMultiTexCoord3fv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3IPROC, glMultiTexCoord3i )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3IVPROC, glMultiTexCoord3iv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3SPROC, glMultiTexCoord3s )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3SVPROC, glMultiTexCoord3sv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4DPROC, glMultiTexCoord4d )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4DVPROC, glMultiTexCoord4dv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4FPROC, glMultiTexCoord4f )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4FVPROC, glMultiTexCoord4fv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4IPROC, glMultiTexCoord4i )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4IVPROC, glMultiTexCoord4iv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4SPROC, glMultiTexCoord4s )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4SVPROC, glMultiTexCoord4sv )
VL_GL_FUNCTION( PFNGLLOADTRANSPOSEMATRIXFPROC, glLoadTransposeMatrixf )
VL_GL_FUNCTION( PFNGLLOADTRANSPOSEMATRIXDPROC, glLoadTransposeMatrixd )
VL_GL_FUNCTION( PFNGLMULTTRANSPOSEMATRIXFPROC, glMultTransposeMatrixf )
VL_GL_FUNCTION( PFNGLMULTTRANSPOSEMATRIXDPROC, glMultTransposeMatrixd )
#endif

// GL_VERSION_1_4
#ifdef GL_VERSION_1_4
VL_GL_FUNCTION( PFNGLBLENDFUNCSEPARATEPROC, glBlendFuncSeparate )
VL_GL_FUNCTION( PFNGLMULTIDRAWARRAYSPROC, glMultiDrawArrays )
VL_GL_FUNCTION( PFNGLMULTIDRAWELEMENTSPROC, glMultiDrawElements )
VL_GL_FUNCTION( PFNGLPOINTPARAMETERFPROC, glPointParameterf )
VL_GL_FUNCTION( PFNGLPOINTPARAMETERFVPROC, glPointParameterfv )
VL_GL_FUNCTION( PFNGLPOINTPARAMETERIPROC, glPointParameteri )
VL_GL_FUNCTION( PFNGLPOINTPARAMETERIVPROC, glPointParameteriv )
#endif

// GL_VERSION_1_4_DEPRECATED
#ifdef GL_VERSION_1_4_DEPRECATED
VL_GL_FUNCTION( PFNGLFOGCOORDFPROC, glFogCoordf )
VL_GL_FUNCTION( PFNGLFOGCOORDFVPROC, glFogCoordfv )
VL_GL_FUNCTION( PFNGLFOGCOORDDPROC, glFogCoordd )
VL_GL_FUNCTION( PFNGLFOGCOORDDVPROC, glFogCoorddv )
VL_GL_FUNCTION( PFNGLFOGCOORDPOINTERPROC, glFogCoordPointer )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3BPROC, glSecondaryColor3b )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3BVPROC, glSecondaryColor3bv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3DPROC, glSecondaryColor3d )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3DVPROC, glSecondaryColor3dv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3FPROC, glSecondaryColor3f )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3FVPROC, glSecondaryColor3fv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3IPROC, glSecondaryColor3i )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3IVPROC, glSecondaryColor3iv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3SPROC, glSecondaryColor3s )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3SVPROC, glSecondaryColor3sv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3UBPROC, glSecondaryColor3ub )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3UBVPROC, glSecondaryColor3ubv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3UIPROC, glSecondaryColor3ui )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3UIVPROC, glSecondaryColor3uiv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3USPROC, glSecondaryColor3us )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3USVPROC, glSecondaryColor3usv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLORPOINTERPROC, glSecondaryColorPointer )
VL_GL_FUNCTION( PFNGLWINDOWPOS2DPROC, glWindowPos2d )
VL_GL_FUNCTION( PFNGLWINDOWPOS2DVPROC, glWindowPos2dv )
VL_GL_FUNCTION( PFNGLWINDOWPOS2FPROC, glWindowPos2f )
VL_GL_FUNCTION( PFNGLWINDOWPOS2FVPROC, glWindowPos2fv )
VL_GL_FUNCTION( PFNGLWINDOWPOS2IPROC, glWindowPos2i )
VL_GL_FUNCTION( PFNGLWINDOWPOS2IVPROC, glWindowPos2iv )
VL_GL_FUNCTION( PFNGLWINDOWPOS2SPROC, glWindowPos2s )
VL_GL_FUNCTION( PFNGLWINDOWPOS2SVPROC, glWindowPos2sv )
VL_GL_FUNCTION( PFNGLWINDOWPOS3DPROC, glWindowPos3d )
VL_GL_FUNCTION( PFNGLWINDOWPOS3DVPROC, glWindowPos3dv )
VL_GL_FUNCTION( PFNGLWINDOWPOS3FPROC, glWindowPos3f )
VL_GL_FUNCTION( PFNGLWINDOWPOS3FVPROC, glWindowPos3fv )
VL_GL_FUNCTION( PFNGLWINDOWPOS3IPROC, glWindowPos3i )
VL_GL_FUNCTION( PFNGLWINDOWPOS3IVPROC, glWindowPos3iv )
VL_GL_FUNCTION( PFNGLWINDOWPOS3SPROC, glWindowPos3s )
VL_GL_FUNCTION( PFNGLWINDOWPOS3SVPROC, glWindowPos3sv )
#endif

// GL_VERSION_1_5
#ifdef GL_VERSION_1_5
VL_GL_FUNCTION( PFNGLGENQUERIESPROC, glGenQueries )
VL_GL_FUNCTION( PFNGLDELETEQUERIESPROC, glDeleteQueries )
VL_GL_FUNCTION( PFNGLISQUERYPROC, glIsQuery )
VL_GL_FUNCTION( PFNGLBEGINQUERYPROC, glBeginQuery )
VL_GL_FUNCTION( PFNGLENDQUERYPROC, glEndQuery )
VL_GL_FUNCTION( PFNGLGETQUERYIVPROC, glGetQueryiv )
VL_GL_FUNCTION( PFNGLGETQUERYOBJECTIVPROC, glGetQueryObjectiv )
VL_GL_FUNCTION( PFNGLGETQUERYOBJECTUIVPROC, glGetQueryObjectuiv )
VL_GL_FUNCTION( PFNGLBINDBUFFERPROC, glBindBuffer )
VL_GL_FUNCTION( PFNGLDELETEBUFFERSPROC, glDeleteBuffers )
VL_GL_FUNCTION( PFNGLGENBUFFERSPROC, glGenBuffers )
VL_GL_FUNCTION( PFNGLISBUFFERPROC, glIsBuffer )
VL_GL_FUNCTION( PFNGLBUFFERDATAPROC, glBufferData )
VL_GL_FUNCTION( PFNGLBUFFERSUBDATAPROC, glBufferSubData )
VL_GL_FUNCTION( PFNGLGETBUFFERSUBDATAPROC, glGetBufferSubData )
VL_GL_FUNCTION( PFNGLMAPBUFFERPROC, glMapBuffer )
VL_GL_FUNCTION( PFNGLUNMAPBUFFERPROC, glUnmapBuffer )
VL_GL_FUNCTION( PFNGLGETBUFFERPARAMETERIVPROC, glGetBufferParameteriv )
VL_GL_FUNCTION( PFNGLGETBUFFERPOINTERVPROC, glGetBufferPointerv )
#endif

// GL_VERSION_2_0
#ifdef GL_VERSION_2_0
VL_GL_FUNCTION( PFNGLBLENDEQUATIONSEPARATEPROC, glBlendEquationSeparate )
VL_GL_FUNCTION( PFNGLDRAWBUFFERSPROC, glDrawBuffers )
VL_GL_FUNCTION( PFNGLSTENCILOPSEPARATEPROC, glStencilOpSeparate )
VL_GL_FUNCTION( PFNGLSTENCILFUNCSEPARATEPROC, glStencilFuncSeparate )
VL_GL_FUNCTION( PFNGLSTENCILMASKSEPARATEPROC, glStencilMaskSeparate )
VL_GL_FUNCTION( PFNGLATTACHSHADERPROC, glAttachShader )
VL_GL_FUNCTION( PFNGLBINDATTRIBLOCATIONPROC, glBindAttribLocation )
VL_GL_FUNCTION( PFNGLCOMPILESHADERPROC, glCompileShader )
VL_GL_FUNCTION( PFNGLCREATEPROGRAMPROC, glCreateProgram )
VL_GL_FUNCTION( PFNGLCREATESHADERPROC, glCreateShader )
VL_GL_FUNCTION( PFNGLDELETEPROGRAMPROC, glDeleteProgram )
VL_GL_FUNCTION( PFNGLDELETESHADERPROC, glDeleteShader )
VL_GL_FUNCTION( PFNGLDETACHSHADERPROC, glDetachShader )
VL_GL_FUNCTION( PFNGLDISABLEVERTEXATTRIBARRAYPROC, glDisableVertexAttribArray )
VL_GL_FUNCTION( PFNGLENABLEVERTEXATTRIBARRAYPROC, glEnableVertexAttribArray )
VL_GL_FUNCTION( PFNGLGETACTIVEATTRIBPROC, glGetActiveAttrib )
VL_GL_FUNCTION( PFNGLGETACTIVEUNIFORMPROC, glGetActiveUniform )
VL_GL_FUNCTION( PFNGLGETATTACHEDSHADERSPROC, glGetAttachedShaders )
VL_GL_FUNCTION( PFNGLGETATTRIBLOCATIONPROC, glGetAttribLocation )
VL_GL_FUNCTION( PFNGLGETPROGRAMIVPROC, glGetProgramiv )
VL_GL_FUNCTION( PFNGLGETPROGRAMINFOLOGPROC, glGetProgramInfoLog )
VL_GL_FUNCTION( PFNGLGETSHADERIVPROC, glGetShaderiv )
VL_GL_FUNCTION( PFNGLGETSHADERINFOLOGPROC, glGetShaderInfoLog )
VL_GL_FUNCTION( PFNGLGETSHADERSOURCEPROC, glGetShaderSource )
VL_GL_FUNCTION( PFNGLGETUNIFORMLOCATIONPROC, glGetUniformLocation )
VL_GL_FUNCTION( PFNGLGETUNIFORMFVPROC, glGetUniformfv )
VL_GL_FUNCTION( PFNGLGETUNIFORMIVPROC, glGetUniformiv )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBDVPROC, glGetVertexAttribdv )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBFVPROC, glGetVertexAttribfv )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBIVPROC, glGetVertexAttribiv )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBPOINTERVPROC, glGetVertexAttribPointerv )
VL_GL_FUNCTION( PFNGLISPROGRAMPROC, glIsProgram )
VL_GL_FUNCTION( PFNGLISSHADERPROC, glIsShader )
VL_GL_FUNCTION( PFNGLLINKPROGRAMPROC, glLinkProgram )
VL_GL_FUNCTION( PFNGLSHADERSOURCEPROC, glShaderSource )
VL_GL_FUNCTION( PFNGLUSEPROGRAMPROC, glUseProgram )
VL_GL_FUNCTION( PFNGLUNIFORM1FPROC, glUniform1f )
VL_GL_FUNCTION( PFNGLUNIFORM2FPROC, glUniform2f )
VL_GL_FUNCTION( PFNGLUNIFORM3FPROC, glUniform3f )
VL_GL_FUNCTION( PFNGLUNIFORM4FPROC, glUniform4f )
VL_GL_FUNCTION( PFNGLUNIFORM1IPROC, glUniform1i )
VL_GL_FUNCTION( PFNGLUNIFORM2IPROC, glUniform2i )
VL_GL_FUNCTION( PFNGLUNIFORM3IPROC, glUniform3i )
VL_GL_FUNCTION( PFNGLUNIFORM4IPROC, glUniform4i )
VL_GL_FUNCTION( PFNGLUNIFORM1FVPROC, glUniform1fv )
VL_GL_FUNCTION( PFNGLUNIFORM2FVPROC, glUniform2fv )
VL_GL_FUNCTION( PFNGLUNIFORM3FVPROC, glUniform3fv )
VL_GL_FUNCTION( PFNGLUNIFORM4FVPROC, glUniform4fv )
VL_GL_FUNCTION( PFNGLUNIFORM1IVPROC, glUniform1iv )
VL_GL_FUNCTION( PFNGLUNIFORM2IVPROC, glUniform2iv )
VL_GL_FUNCTION( PFNGLUNIFORM3IVPROC, glUniform3iv )
VL_GL_FUNCTION( PFNGLUNIFORM4IVPROC, glUniform4iv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX2FVPROC, glUniformMatrix2fv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX3FVPROC, glUniformMatrix3fv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX4FVPROC, glUniformMatrix4fv )
VL_GL_FUNCTION( PFNGLVALIDATEPROGRAMPROC, glValidateProgram )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1DPROC, glVertexAttrib1d )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1DVPROC, glVertexAttrib1dv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1FPROC, glVertexAttrib1f )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1FVPROC, glVertexAttrib1fv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1SPROC, glVertexAttrib1s )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1SVPROC, glVertexAttrib1sv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2DPROC, glVertexAttrib2d )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2DVPROC, glVertexAttrib2dv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2FPROC, glVertexAttrib2f )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2FVPROC, glVertexAttrib2fv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2SPROC, glVertexAttrib2s )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2SVPROC, glVertexAttrib2sv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3DPROC, glVertexAttrib3d )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3DVPROC, glVertexAttrib3dv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3FPROC, glVertexAttrib3f )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3FVPROC, glVertexAttrib3fv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3SPROC, glVertexAttrib3s )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3SVPROC, glVertexAttrib3sv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NBVPROC, glVertexAttrib4Nbv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NIVPROC, glVertexAttrib4Niv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NSVPROC, glVertexAttrib4Nsv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NUBPROC, glVertexAttrib4Nub )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NUBVPROC, glVertexAttrib4Nubv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NUIVPROC, glVertexAttrib4Nuiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NUSVPROC, glVertexAttrib4Nusv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4BVPROC, glVertexAttrib4bv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4DPROC, glVertexAttrib4d )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4DVPROC, glVertexAttrib4dv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4FPROC, glVertexAttrib4f )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4FVPROC, glVertexAttrib4fv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4IVPROC, glVertexAttrib4iv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4SPROC, glVertexAttrib4s )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4SVPROC, glVertexAttrib4sv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4UBVPROC, glVertexAttrib4ubv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4UIVPROC, glVertexAttrib4uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4USVPROC, glVertexAttrib4usv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBPOINTERPROC, glVertexAttribPointer )
#endif

// GL_VERSION_2_1
#ifdef GL_VERSION_2_1
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX2X3FVPROC, glUniformMatrix2x3fv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX3X2FVPROC, glUniformMatrix3x2fv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX2X4FVPROC, glUniformMatrix2x4fv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX4X2FVPROC, glUniformMatrix4x2fv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX3X4FVPROC, glUniformMatrix3x4fv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX4X3FVPROC, glUniformMatrix4x3fv )
#endif

// GL_VERSION_3_0
#ifdef GL_VERSION_3_0
VL_GL_FUNCTION( PFNGLCOLORMASKIPROC, glColorMaski )
VL_GL_FUNCTION( PFNGLGETBOOLEANI_VPROC, glGetBooleani_v )
VL_GL_FUNCTION( PFNGLGETINTEGERI_VPROC, glGetIntegeri_v )
VL_GL_FUNCTION( PFNGLENABLEIPROC, glEnablei )
VL_GL_FUNCTION( PFNGLDISABLEIPROC, glDisablei )
VL_GL_FUNCTION( PFNGLISENABLEDIPROC, glIsEnabledi )
VL_GL_FUNCTION( PFNGLBEGINTRANSFORMFEEDBACKPROC, glBeginTransformFeedback )
VL_GL_FUNCTION( PFNGLENDTRANSFORMFEEDBACKPROC, glEndTransformFeedback )
VL_GL_FUNCTION( PFNGLBINDBUFFERRANGEPROC, glBindBufferRange )
VL_GL_FUNCTION( PFNGLBINDBUFFERBASEPROC, glBindBufferBase )
VL_GL_FUNCTION( PFNGLTRANSFORMFEEDBACKVARYINGSPROC, glTransformFeedbackVaryings )
VL_GL_FUNCTION( PFNGLGETTRANSFORMFEEDBACKVARYINGPROC, glGetTransformFeedbackVarying )
VL_GL_FUNCTION( PFNGLCLAMPCOLORPROC, glClampColor )
VL_GL_FUNCTION( PFNGLBEGINCONDITIONALRENDERPROC, glBeginConditionalRender )
VL_GL_FUNCTION( PFNGLENDCONDITIONALRENDERPROC, glEndConditionalRender )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBIPOINTERPROC, glVertexAttribIPointer )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBIIVPROC, glGetVertexAttribIiv )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBIUIVPROC, glGetVertexAttribIuiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI1IPROC, glVertexAttribI1i )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI2IPROC, glVertexAttribI2i )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI3IPROC, glVertexAttribI3i )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4IPROC, glVertexAttribI4i )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI1UIPROC, glVertexAttribI1ui )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI2UIPROC, glVertexAttribI2ui )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI3UIPROC, glVertexAttribI3ui )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4UIPROC, glVertexAttribI4ui )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI1IVPROC, glVertexAttribI1iv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI2IVPROC, glVertexAttribI2iv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI3IVPROC, glVertexAttribI3iv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4IVPROC, glVertexAttribI4iv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI1UIVPROC, glVertexAttribI1uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI2UIVPROC, glVertexAttribI2uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI3UIVPROC, glVertexAttribI3uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4UIVPROC, glVertexAttribI4uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4BVPROC, glVertexAttribI4bv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4SVPROC, glVertexAttribI4sv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4UBVPROC, glVertexAttribI4ubv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4USVPROC, glVertexAttribI4usv )
VL_GL_FUNCTION( PFNGLGETUNIFORMUIVPROC, glGetUniformuiv )
VL_GL_FUNCTION( PFNGLBINDFRAGDATALOCATIONPROC, glBindFragDataLocation )
VL_GL_FUNCTION( PFNGLGETFRAGDATALOCATIONPROC, glGetFragDataLocation )
VL_GL_FUNCTION( PFNGLUNIFORM1UIPROC, glUniform1ui )
VL_GL_FUNCTION( PFNGLUNIFORM2UIPROC, glUniform2ui )
VL_GL_FUNCTION( PFNGLUNIFORM3UIPROC, glUniform3ui )
VL_GL_FUNCTION( PFNGLUNIFORM4UIPROC, glUniform4ui )
VL_GL_FUNCTION( PFNGLUNIFORM1UIVPROC, glUniform1uiv )
VL_GL_FUNCTION( PFNGLUNIFORM2UIVPROC, glUniform2uiv )
VL_GL_FUNCTION( PFNGLUNIFORM3UIVPROC, glUniform3uiv )
VL_GL_FUNCTION( PFNGLUNIFORM4UIVPROC, glUniform4uiv )
VL_GL_FUNCTION( PFNGLTEXPARAMETERIIVPROC, glTexParameterIiv )
VL_GL_FUNCTION( PFNGLTEXPARAMETERIUIVPROC, glTexParameterIuiv )
VL_GL_FUNCTION( PFNGLGETTEXPARAMETERIIVPROC, glGetTexParameterIiv )
VL_GL_FUNCTION( PFNGLGETTEXPARAMETERIUIVPROC, glGetTexParameterIuiv )
VL_GL_FUNCTION( PFNGLCLEARBUFFERIVPROC, glClearBufferiv )
VL_GL_FUNCTION( PFNGLCLEARBUFFERUIVPROC, glClearBufferuiv )
VL_GL_FUNCTION( PFNGLCLEARBUFFERFVPROC, glClearBufferfv )
VL_GL_FUNCTION( PFNGLCLEARBUFFERFIPROC, glClearBufferfi )
VL_GL_FUNCTION( PFNGLGETSTRINGIPROC, glGetStringi )
#endif

// GL_VERSION_3_1
#ifdef GL_VERSION_3_1
VL_GL_FUNCTION( PFNGLDRAWARRAYSINSTANCEDPROC, glDrawArraysInstanced )
VL_GL_FUNCTION( PFNGLDRAWELEMENTSINSTANCEDPROC, glDrawElementsInstanced )
VL_GL_FUNCTION( PFNGLTEXBUFFERPROC, glTexBuffer )
VL_GL_FUNCTION( PFNGLPRIMITIVERESTARTINDEXPROC, glPrimitiveRestartIndex )
#endif

// GL_VERSION_3_2
#ifdef GL_VERSION_3_2
VL_GL_FUNCTION( PFNGLGETINTEGER64I_VPROC, glGetInteger64i_v )
VL_GL_FUNCTION( PFNGLGETBUFFERPARAMETERI64VPROC, glGetBufferParameteri64v )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTUREPROC, glFramebufferTexture )
#endif

// GL_VERSION_3_3
#ifdef GL_VERSION_3_3
VL_GL_FUNCTION( PFNGLVERTEXATTRIBDIVISORPROC, glVertexAttribDivisor )
#endif

// GL_VERSION_4_0
#ifdef GL_VERSION_4_0
VL_GL_FUNCTION( PFNGLMINSAMPLESHADINGPROC, glMinSampleShading )
VL_GL_FUNCTION( PFNGLBLENDEQUATIONIPROC, glBlendEquationi )
VL_GL_FUNCTION( PFNGLBLENDEQUATIONSEPARATEIPROC, glBlendEquationSeparatei )
VL_GL_FUNCTION( PFNGLBLENDFUNCIPROC, glBlendFunci )
VL_GL_FUNCTION( PFNGLBLENDFUNCSEPARATEIPROC, glBlendFuncSeparatei )
#endif

// GL_ARB_multitexture
#ifdef GL_ARB_multitexture
VL_GL_FUNCTION( PFNGLACTIVETEXTUREARBPROC, glActiveTextureARB )
VL_GL_FUNCTION( PFNGLCLIENTACTIVETEXTUREARBPROC, glClientActiveTextureARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1DARBPROC, glMultiTexCoord1dARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1DVARBPROC, glMultiTexCoord1dvARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1FARBPROC, glMultiTexCoord1fARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1FVARBPROC, glMultiTexCoord1fvARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1IARBPROC, glMultiTexCoord1iARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1IVARBPROC, glMultiTexCoord1ivARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1SARBPROC, glMultiTexCoord1sARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1SVARBPROC, glMultiTexCoord1svARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2DARBPROC, glMultiTexCoord2dARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2DVARBPROC, glMultiTexCoord2dvARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2FARBPROC, glMultiTexCoord2fARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2FVARBPROC, glMultiTexCoord2fvARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2IARBPROC, glMultiTexCoord2iARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2IVARBPROC, glMultiTexCoord2ivARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2SARBPROC, glMultiTexCoord2sARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2SVARBPROC, glMultiTexCoord2svARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3DARBPROC, glMultiTexCoord3dARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3DVARBPROC, glMultiTexCoord3dvARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3FARBPROC, glMultiTexCoord3fARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3FVARBPROC, glMultiTexCoord3fvARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3IARBPROC, glMultiTexCoord3iARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3IVARBPROC, glMultiTexCoord3ivARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3SARBPROC, glMultiTexCoord3sARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3SVARBPROC, glMultiTexCoord3svARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4DARBPROC, glMultiTexCoord4dARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4DVARBPROC, glMultiTexCoord4dvARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4FARBPROC, glMultiTexCoord4fARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4FVARBPROC, glMultiTexCoord4fvARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4IARBPROC, glMultiTexCoord4iARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4IVARBPROC, glMultiTexCoord4ivARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4SARBPROC, glMultiTexCoord4sARB )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4SVARBPROC, glMultiTexCoord4svARB )
#endif

// GL_ARB_transpose_matrix
#ifdef GL_ARB_transpose_matrix
VL_GL_FUNCTION( PFNGLLOADTRANSPOSEMATRIXFARBPROC, glLoadTransposeMatrixfARB )
VL_GL_FUNCTION( PFNGLLOADTRANSPOSEMATRIXDARBPROC, glLoadTransposeMatrixdARB )
VL_GL_FUNCTION( PFNGLMULTTRANSPOSEMATRIXFARBPROC, glMultTransposeMatrixfARB )
VL_GL_FUNCTION( PFNGLMULTTRANSPOSEMATRIXDARBPROC, glMultTransposeMatrixdARB )
#endif

// GL_ARB_multisample
#ifdef GL_ARB_multisample
VL_GL_FUNCTION( PFNGLSAMPLECOVERAGEARBPROC, glSampleCoverageARB )
#endif

// GL_ARB_texture_compression
#ifdef GL_ARB_texture_compression
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXIMAGE3DARBPROC, glCompressedTexImage3DARB )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXIMAGE2DARBPROC, glCompressedTexImage2DARB )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXIMAGE1DARBPROC, glCompressedTexImage1DARB )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC, glCompressedTexSubImage3DARB )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC, glCompressedTexSubImage2DARB )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC, glCompressedTexSubImage1DARB )
VL_GL_FUNCTION( PFNGLGETCOMPRESSEDTEXIMAGEARBPROC, glGetCompressedTexImageARB )
#endif

// GL_ARB_point_parameters
#ifdef GL_ARB_point_parameters
VL_GL_FUNCTION( PFNGLPOINTPARAMETERFARBPROC, glPointParameterfARB )
VL_GL_FUNCTION( PFNGLPOINTPARAMETERFVARBPROC, glPointParameterfvARB )
#endif

// GL_ARB_vertex_blend
#ifdef GL_ARB_vertex_blend
VL_GL_FUNCTION( PFNGLWEIGHTBVARBPROC, glWeightbvARB )
VL_GL_FUNCTION( PFNGLWEIGHTSVARBPROC, glWeightsvARB )
VL_GL_FUNCTION( PFNGLWEIGHTIVARBPROC, glWeightivARB )
VL_GL_FUNCTION( PFNGLWEIGHTFVARBPROC, glWeightfvARB )
VL_GL_FUNCTION( PFNGLWEIGHTDVARBPROC, glWeightdvARB )
VL_GL_FUNCTION( PFNGLWEIGHTUBVARBPROC, glWeightubvARB )
VL_GL_FUNCTION( PFNGLWEIGHTUSVARBPROC, glWeightusvARB )
VL_GL_FUNCTION( PFNGLWEIGHTUIVARBPROC, glWeightuivARB )
VL_GL_FUNCTION( PFNGLWEIGHTPOINTERARBPROC, glWeightPointerARB )
VL_GL_FUNCTION( PFNGLVERTEXBLENDARBPROC, glVertexBlendARB )
#endif

// GL_ARB_matrix_palette
#ifdef GL_ARB_matrix_palette
VL_GL_FUNCTION( PFNGLCURRENTPALETTEMATRIXARBPROC, glCurrentPaletteMatrixARB )
VL_GL_FUNCTION( PFNGLMATRIXINDEXUBVARBPROC, glMatrixIndexubvARB )
VL_GL_FUNCTION( PFNGLMATRIXINDEXUSVARBPROC, glMatrixIndexusvARB )
VL_GL_FUNCTION( PFNGLMATRIXINDEXUIVARBPROC, glMatrixIndexuivARB )
VL_GL_FUNCTION( PFNGLMATRIXINDEXPOINTERARBPROC, glMatrixIndexPointerARB )
#endif

// GL_ARB_window_pos
#ifdef GL_ARB_window_pos
VL_GL_FUNCTION( PFNGLWINDOWPOS2DARBPROC, glWindowPos2dARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS2DVARBPROC, glWindowPos2dvARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS2FARBPROC, glWindowPos2fARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS2FVARBPROC, glWindowPos2fvARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS2IARBPROC, glWindowPos2iARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS2IVARBPROC, glWindowPos2ivARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS2SARBPROC, glWindowPos2sARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS2SVARBPROC, glWindowPos2svARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS3DARBPROC, glWindowPos3dARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS3DVARBPROC, glWindowPos3dvARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS3FARBPROC, glWindowPos3fARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS3FVARBPROC, glWindowPos3fvARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS3IARBPROC, glWindowPos3iARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS3IVARBPROC, glWindowPos3ivARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS3SARBPROC, glWindowPos3sARB )
VL_GL_FUNCTION( PFNGLWINDOWPOS3SVARBPROC, glWindowPos3svARB )
#endif

// GL_ARB_vertex_program
#ifdef GL_ARB_vertex_program
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1DARBPROC, glVertexAttrib1dARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1DVARBPROC, glVertexAttrib1dvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1FARBPROC, glVertexAttrib1fARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1FVARBPROC, glVertexAttrib1fvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1SARBPROC, glVertexAttrib1sARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1SVARBPROC, glVertexAttrib1svARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2DARBPROC, glVertexAttrib2dARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2DVARBPROC, glVertexAttrib2dvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2FARBPROC, glVertexAttrib2fARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2FVARBPROC, glVertexAttrib2fvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2SARBPROC, glVertexAttrib2sARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2SVARBPROC, glVertexAttrib2svARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3DARBPROC, glVertexAttrib3dARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3DVARBPROC, glVertexAttrib3dvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3FARBPROC, glVertexAttrib3fARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3FVARBPROC, glVertexAttrib3fvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3SARBPROC, glVertexAttrib3sARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3SVARBPROC, glVertexAttrib3svARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NBVARBPROC, glVertexAttrib4NbvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NIVARBPROC, glVertexAttrib4NivARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NSVARBPROC, glVertexAttrib4NsvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NUBARBPROC, glVertexAttrib4NubARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NUBVARBPROC, glVertexAttrib4NubvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NUIVARBPROC, glVertexAttrib4NuivARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4NUSVARBPROC, glVertexAttrib4NusvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4BVARBPROC, glVertexAttrib4bvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4DARBPROC, glVertexAttrib4dARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4DVARBPROC, glVertexAttrib4dvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4FARBPROC, glVertexAttrib4fARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4FVARBPROC, glVertexAttrib4fvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4IVARBPROC, glVertexAttrib4ivARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4SARBPROC, glVertexAttrib4sARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4SVARBPROC, glVertexAttrib4svARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4UBVARBPROC, glVertexAttrib4ubvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4UIVARBPROC, glVertexAttrib4uivARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4USVARBPROC, glVertexAttrib4usvARB )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBPOINTERARBPROC, glVertexAttribPointerARB )
VL_GL_FUNCTION( PFNGLENABLEVERTEXATTRIBARRAYARBPROC, glEnableVertexAttribArrayARB )
VL_GL_FUNCTION( PFNGLDISABLEVERTEXATTRIBARRAYARBPROC, glDisableVertexAttribArrayARB )
VL_GL_FUNCTION( PFNGLPROGRAMSTRINGARBPROC, glProgramStringARB )
VL_GL_FUNCTION( PFNGLBINDPROGRAMARBPROC, glBindProgramARB )
VL_GL_FUNCTION( PFNGLDELETEPROGRAMSARBPROC, glDeleteProgramsARB )
VL_GL_FUNCTION( PFNGLGENPROGRAMSARBPROC, glGenProgramsARB )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETER4DARBPROC, glProgramEnvParameter4dARB )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETER4DVARBPROC, glProgramEnvParameter4dvARB )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETER4FARBPROC, glProgramEnvParameter4fARB )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETER4FVARBPROC, glProgramEnvParameter4fvARB )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETER4DARBPROC, glProgramLocalParameter4dARB )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETER4DVARBPROC, glProgramLocalParameter4dvARB )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETER4FARBPROC, glProgramLocalParameter4fARB )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETER4FVARBPROC, glProgramLocalParameter4fvARB )
VL_GL_FUNCTION( PFNGLGETPROGRAMENVPARAMETERDVARBPROC, glGetProgramEnvParameterdvARB )
VL_GL_FUNCTION( PFNGLGETPROGRAMENVPARAMETERFVARBPROC, glGetProgramEnvParameterfvARB )
VL_GL_FUNCTION( PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC, glGetProgramLocalParameterdvARB )
VL_GL_FUNCTION( PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC, glGetProgramLocalParameterfvARB )
VL_GL_FUNCTION( PFNGLGETPROGRAMIVARBPROC, glGetProgramivARB )
VL_GL_FUNCTION( PFNGLGETPROGRAMSTRINGARBPROC, glGetProgramStringARB )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBDVARBPROC, glGetVertexAttribdvARB )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBFVARBPROC, glGetVertexAttribfvARB )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBIVARBPROC, glGetVertexAttribivARB )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBPOINTERVARBPROC, glGetVertexAttribPointervARB )
VL_GL_FUNCTION( PFNGLISPROGRAMARBPROC, glIsProgramARB )
#endif

// GL_ARB_vertex_buffer_object
#ifdef GL_ARB_vertex_buffer_object
VL_GL_FUNCTION( PFNGLBINDBUFFERARBPROC, glBindBufferARB )
VL_GL_FUNCTION( PFNGLDELETEBUFFERSARBPROC, glDeleteBuffersARB )
VL_GL_FUNCTION( PFNGLGENBUFFERSARBPROC, glGenBuffersARB )
VL_GL_FUNCTION( PFNGLISBUFFERARBPROC, glIsBufferARB )
VL_GL_FUNCTION( PFNGLBUFFERDATAARBPROC, glBufferDataARB )
VL_GL_FUNCTION( PFNGLBUFFERSUBDATAARBPROC, glBufferSubDataARB )
VL_GL_FUNCTION( PFNGLGETBUFFERSUBDATAARBPROC, glGetBufferSubDataARB )
VL_GL_FUNCTION( PFNGLMAPBUFFERARBPROC, glMapBufferARB )
VL_GL_FUNCTION( PFNGLUNMAPBUFFERARBPROC, glUnmapBufferARB )
VL_GL_FUNCTION( PFNGLGETBUFFERPARAMETERIVARBPROC, glGetBufferParameterivARB )
VL_GL_FUNCTION( PFNGLGETBUFFERPOINTERVARBPROC, glGetBufferPointervARB )
#endif

// GL_ARB_occlusion_query
#ifdef GL_ARB_occlusion_query
VL_GL_FUNCTION( PFNGLGENQUERIESARBPROC, glGenQueriesARB )
VL_GL_FUNCTION( PFNGLDELETEQUERIESARBPROC, glDeleteQueriesARB )
VL_GL_FUNCTION( PFNGLISQUERYARBPROC, glIsQueryARB )
VL_GL_FUNCTION( PFNGLBEGINQUERYARBPROC, glBeginQueryARB )
VL_GL_FUNCTION( PFNGLENDQUERYARBPROC, glEndQueryARB )
VL_GL_FUNCTION( PFNGLGETQUERYIVARBPROC, glGetQueryivARB )
VL_GL_FUNCTION( PFNGLGETQUERYOBJECTIVARBPROC, glGetQueryObjectivARB )
VL_GL_FUNCTION( PFNGLGETQUERYOBJECTUIVARBPROC, glGetQueryObjectuivARB )
#endif

// GL_ARB_shader_objects
#ifdef GL_ARB_shader_objects
VL_GL_FUNCTION( PFNGLDELETEOBJECTARBPROC, glDeleteObjectARB )
VL_GL_FUNCTION( PFNGLGETHANDLEARBPROC, glGetHandleARB )
VL_GL_FUNCTION( PFNGLDETACHOBJECTARBPROC, glDetachObjectARB )
VL_GL_FUNCTION( PFNGLCREATESHADEROBJECTARBPROC, glCreateShaderObjectARB )
VL_GL_FUNCTION( PFNGLSHADERSOURCEARBPROC, glShaderSourceARB )
VL_GL_FUNCTION( PFNGLCOMPILESHADERARBPROC, glCompileShaderARB )
VL_GL_FUNCTION( PFNGLCREATEPROGRAMOBJECTARBPROC, glCreateProgramObjectARB )
VL_GL_FUNCTION( PFNGLATTACHOBJECTARBPROC, glAttachObjectARB )
VL_GL_FUNCTION( PFNGLLINKPROGRAMARBPROC, glLinkProgramARB )
VL_GL_FUNCTION( PFNGLUSEPROGRAMOBJECTARBPROC, glUseProgramObjectARB )
VL_GL_FUNCTION( PFNGLVALIDATEPROGRAMARBPROC, glValidateProgramARB )
VL_GL_FUNCTION( PFNGLUNIFORM1FARBPROC, glUniform1fARB )
VL_GL_FUNCTION( PFNGLUNIFORM2FARBPROC, glUniform2fARB )
VL_GL_FUNCTION( PFNGLUNIFORM3FARBPROC, glUniform3fARB )
VL_GL_FUNCTION( PFNGLUNIFORM4FARBPROC, glUniform4fARB )
VL_GL_FUNCTION( PFNGLUNIFORM1IARBPROC, glUniform1iARB )
VL_GL_FUNCTION( PFNGLUNIFORM2IARBPROC, glUniform2iARB )
VL_GL_FUNCTION( PFNGLUNIFORM3IARBPROC, glUniform3iARB )
VL_GL_FUNCTION( PFNGLUNIFORM4IARBPROC, glUniform4iARB )
VL_GL_FUNCTION( PFNGLUNIFORM1FVARBPROC, glUniform1fvARB )
VL_GL_FUNCTION( PFNGLUNIFORM2FVARBPROC, glUniform2fvARB )
VL_GL_FUNCTION( PFNGLUNIFORM3FVARBPROC, glUniform3fvARB )
VL_GL_FUNCTION( PFNGLUNIFORM4FVARBPROC, glUniform4fvARB )
VL_GL_FUNCTION( PFNGLUNIFORM1IVARBPROC, glUniform1ivARB )
VL_GL_FUNCTION( PFNGLUNIFORM2IVARBPROC, glUniform2ivARB )
VL_GL_FUNCTION( PFNGLUNIFORM3IVARBPROC, glUniform3ivARB )
VL_GL_FUNCTION( PFNGLUNIFORM4IVARBPROC, glUniform4ivARB )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX2FVARBPROC, glUniformMatrix2fvARB )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX3FVARBPROC, glUniformMatrix3fvARB )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX4FVARBPROC, glUniformMatrix4fvARB )
VL_GL_FUNCTION( PFNGLGETOBJECTPARAMETERFVARBPROC, glGetObjectParameterfvARB )
VL_GL_FUNCTION( PFNGLGETOBJECTPARAMETERIVARBPROC, glGetObjectParameterivARB )
VL_GL_FUNCTION( PFNGLGETINFOLOGARBPROC, glGetInfoLogARB )
VL_GL_FUNCTION( PFNGLGETATTACHEDOBJECTSARBPROC, glGetAttachedObjectsARB )
VL_GL_FUNCTION( PFNGLGETUNIFORMLOCATIONARBPROC, glGetUniformLocationARB )
VL_GL_FUNCTION( PFNGLGETACTIVEUNIFORMARBPROC, glGetActiveUniformARB )
VL_GL_FUNCTION( PFNGLGETUNIFORMFVARBPROC, glGetUniformfvARB )
VL_GL_FUNCTION( PFNGLGETUNIFORMIVARBPROC, glGetUniformivARB )
VL_GL_FUNCTION( PFNGLGETSHADERSOURCEARBPROC, glGetShaderSourceARB )
#endif

// GL_ARB_vertex_shader
#ifdef GL_ARB_vertex_shader
VL_GL_FUNCTION( PFNGLBINDATTRIBLOCATIONARBPROC, glBindAttribLocationARB )
VL_GL_FUNCTION( PFNGLGETACTIVEATTRIBARBPROC, glGetActiveAttribARB )
VL_GL_FUNCTION( PFNGLGETATTRIBLOCATIONARBPROC, glGetAttribLocationARB )
#endif

// GL_ARB_draw_buffers
#ifdef GL_ARB_draw_buffers
VL_GL_FUNCTION( PFNGLDRAWBUFFERSARBPROC, glDrawBuffersARB )
#endif

// GL_ARB_color_buffer_float
#ifdef GL_ARB_color_buffer_float
VL_GL_FUNCTION( PFNGLCLAMPCOLORARBPROC, glClampColorARB )
#endif

// GL_ARB_draw_instanced
#ifdef GL_ARB_draw_instanced
VL_GL_FUNCTION( PFNGLDRAWARRAYSINSTANCEDARBPROC, glDrawArraysInstancedARB )
VL_GL_FUNCTION( PFNGLDRAWELEMENTSINSTANCEDARBPROC, glDrawElementsInstancedARB )
#endif

// GL_ARB_framebuffer_object
#ifdef GL_ARB_framebuffer_object
VL_GL_FUNCTION( PFNGLISRENDERBUFFERPROC, glIsRenderbuffer )
VL_GL_FUNCTION( PFNGLBINDRENDERBUFFERPROC, glBindRenderbuffer )
VL_GL_FUNCTION( PFNGLDELETERENDERBUFFERSPROC, glDeleteRenderbuffers )
VL_GL_FUNCTION( PFNGLGENRENDERBUFFERSPROC, glGenRenderbuffers )
VL_GL_FUNCTION( PFNGLRENDERBUFFERSTORAGEPROC, glRenderbufferStorage )
VL_GL_FUNCTION( PFNGLGETRENDERBUFFERPARAMETERIVPROC, glGetRenderbufferParameteriv )
VL_GL_FUNCTION( PFNGLISFRAMEBUFFERPROC, glIsFramebuffer )
VL_GL_FUNCTION( PFNGLBINDFRAMEBUFFERPROC, glBindFramebuffer )
VL_GL_FUNCTION( PFNGLDELETEFRAMEBUFFERSPROC, glDeleteFramebuffers )
VL_GL_FUNCTION( PFNGLGENFRAMEBUFFERSPROC, glGenFramebuffers )
VL_GL_FUNCTION( PFNGLCHECKFRAMEBUFFERSTATUSPROC, glCheckFramebufferStatus )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURE1DPROC, glFramebufferTexture1D )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURE2DPROC, glFramebufferTexture2D )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURE3DPROC, glFramebufferTexture3D )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERRENDERBUFFERPROC, glFramebufferRenderbuffer )
VL_GL_FUNCTION( PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVPROC, glGetFramebufferAttachmentParameteriv )
VL_GL_FUNCTION( PFNGLGENERATEMIPMAPPROC, glGenerateMipmap )
VL_GL_FUNCTION( PFNGLBLITFRAMEBUFFERPROC, glBlitFramebuffer )
VL_GL_FUNCTION( PFNGLRENDERBUFFERSTORAGEMULTISAMPLEPROC, glRenderbufferStorageMultisample )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURELAYERPROC, glFramebufferTextureLayer )
#endif

// GL_ARB_geometry_shader4
#ifdef GL_ARB_geometry_shader4
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETERIARBPROC, glProgramParameteriARB )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTUREARBPROC, glFramebufferTextureARB )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURELAYERARBPROC, glFramebufferTextureLayerARB )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTUREFACEARBPROC, glFramebufferTextureFaceARB )
#endif

// GL_ARB_instanced_arrays
#ifdef GL_ARB_instanced_arrays
VL_GL_FUNCTION( PFNGLVERTEXATTRIBDIVISORARBPROC, glVertexAttribDivisorARB )
#endif

// GL_ARB_map_buffer_range
#ifdef GL_ARB_map_buffer_range
VL_GL_FUNCTION( PFNGLMAPBUFFERRANGEPROC, glMapBufferRange )
VL_GL_FUNCTION( PFNGLFLUSHMAPPEDBUFFERRANGEPROC, glFlushMappedBufferRange )
#endif

// GL_ARB_texture_buffer_object
#ifdef GL_ARB_texture_buffer_object
VL_GL_FUNCTION( PFNGLTEXBUFFERARBPROC, glTexBufferARB )
#endif

// GL_ARB_vertex_array_object
#ifdef GL_ARB_vertex_array_object
VL_GL_FUNCTION( PFNGLBINDVERTEXARRAYPROC, glBindVertexArray )
VL_GL_FUNCTION( PFNGLDELETEVERTEXARRAYSPROC, glDeleteVertexArrays )
VL_GL_FUNCTION( PFNGLGENVERTEXARRAYSPROC, glGenVertexArrays )
VL_GL_FUNCTION( PFNGLISVERTEXARRAYPROC, glIsVertexArray )
#endif

// GL_ARB_uniform_buffer_object
#ifdef GL_ARB_uniform_buffer_object
VL_GL_FUNCTION( PFNGLGETUNIFORMINDICESPROC, glGetUniformIndices )
VL_GL_FUNCTION( PFNGLGETACTIVEUNIFORMSIVPROC, glGetActiveUniformsiv )
VL_GL_FUNCTION( PFNGLGETACTIVEUNIFORMNAMEPROC, glGetActiveUniformName )
VL_GL_FUNCTION( PFNGLGETUNIFORMBLOCKINDEXPROC, glGetUniformBlockIndex )
VL_GL_FUNCTION( PFNGLGETACTIVEUNIFORMBLOCKIVPROC, glGetActiveUniformBlockiv )
VL_GL_FUNCTION( PFNGLGETACTIVEUNIFORMBLOCKNAMEPROC, glGetActiveUniformBlockName )
VL_GL_FUNCTION( PFNGLUNIFORMBLOCKBINDINGPROC, glUniformBlockBinding )
#endif

// GL_ARB_copy_buffer
#ifdef GL_ARB_copy_buffer
VL_GL_FUNCTION( PFNGLCOPYBUFFERSUBDATAPROC, glCopyBufferSubData )
#endif

// GL_ARB_draw_elements_base_vertex
#ifdef GL_ARB_draw_elements_base_vertex
VL_GL_FUNCTION( PFNGLDRAWELEMENTSBASEVERTEXPROC, glDrawElementsBaseVertex )
VL_GL_FUNCTION( PFNGLDRAWRANGEELEMENTSBASEVERTEXPROC, glDrawRangeElementsBaseVertex )
VL_GL_FUNCTION( PFNGLDRAWELEMENTSINSTANCEDBASEVERTEXPROC, glDrawElementsInstancedBaseVertex )
VL_GL_FUNCTION( PFNGLMULTIDRAWELEMENTSBASEVERTEXPROC, glMultiDrawElementsBaseVertex )
#endif

// GL_ARB_provoking_vertex
#ifdef GL_ARB_provoking_vertex
VL_GL_FUNCTION( PFNGLPROVOKINGVERTEXPROC, glProvokingVertex )
#endif

// GL_ARB_sync
#ifdef GL_ARB_sync
VL_GL_FUNCTION( PFNGLFENCESYNCPROC, glFenceSync )
VL_GL_FUNCTION( PFNGLISSYNCPROC, glIsSync )
VL_GL_FUNCTION( PFNGLDELETESYNCPROC, glDeleteSync )
VL_GL_FUNCTION( PFNGLCLIENTWAITSYNCPROC, glClientWaitSync )
VL_GL_FUNCTION( PFNGLWAITSYNCPROC, glWaitSync )
VL_GL_FUNCTION( PFNGLGETINTEGER64VPROC, glGetInteger64v )
VL_GL_FUNCTION( PFNGLGETSYNCIVPROC, glGetSynciv )
#endif

// GL_ARB_texture_multisample
#ifdef GL_ARB_texture_multisample
VL_GL_FUNCTION( PFNGLTEXIMAGE2DMULTISAMPLEPROC, glTexImage2DMultisample )
VL_GL_FUNCTION( PFNGLTEXIMAGE3DMULTISAMPLEPROC, glTexImage3DMultisample )
VL_GL_FUNCTION( PFNGLGETMULTISAMPLEFVPROC, glGetMultisamplefv )
VL_GL_FUNCTION( PFNGLSAMPLEMASKIPROC, glSampleMaski )
#endif

// GL_ARB_draw_buffers_blend
#ifdef GL_ARB_draw_buffers_blend
VL_GL_FUNCTION( PFNGLBLENDEQUATIONIARBPROC, glBlendEquationiARB )
VL_GL_FUNCTION( PFNGLBLENDEQUATIONSEPARATEIARBPROC, glBlendEquationSeparateiARB )
VL_GL_FUNCTION( PFNGLBLENDFUNCIARBPROC, glBlendFunciARB )
VL_GL_FUNCTION( PFNGLBLENDFUNCSEPARATEIARBPROC, glBlendFuncSeparateiARB )
#endif

// GL_ARB_sample_shading
#ifdef GL_ARB_sample_shading
VL_GL_FUNCTION( PFNGLMINSAMPLESHADINGARBPROC, glMinSampleShadingARB )
#endif

// GL_ARB_shading_language_include
#ifdef GL_ARB_shading_language_include
VL_GL_FUNCTION( PFNGLNAMEDSTRINGARBPROC, glNamedStringARB )
VL_GL_FUNCTION( PFNGLDELETENAMEDSTRINGARBPROC, glDeleteNamedStringARB )
VL_GL_FUNCTION( PFNGLCOMPILESHADERINCLUDEARBPROC, glCompileShaderIncludeARB )
VL_GL_FUNCTION( PFNGLISNAMEDSTRINGARBPROC, glIsNamedStringARB )
VL_GL_FUNCTION( PFNGLGETNAMEDSTRINGARBPROC, glGetNamedStringARB )
VL_GL_FUNCTION( PFNGLGETNAMEDSTRINGIVARBPROC, glGetNamedStringivARB )
#endif

// GL_ARB_blend_func_extended
#ifdef GL_ARB_blend_func_extended
VL_GL_FUNCTION( PFNGLBINDFRAGDATALOCATIONINDEXEDPROC, glBindFragDataLocationIndexed )
VL_GL_FUNCTION( PFNGLGETFRAGDATAINDEXPROC, glGetFragDataIndex )
#endif

// GL_ARB_sampler_objects
#ifdef GL_ARB_sampler_objects
VL_GL_FUNCTION( PFNGLGENSAMPLERSPROC, glGenSamplers )
VL_GL_FUNCTION( PFNGLDELETESAMPLERSPROC, glDeleteSamplers )
VL_GL_FUNCTION( PFNGLISSAMPLERPROC, glIsSampler )
VL_GL_FUNCTION( PFNGLBINDSAMPLERPROC, glBindSampler )
VL_GL_FUNCTION( PFNGLSAMPLERPARAMETERIPROC, glSamplerParameteri )
VL_GL_FUNCTION( PFNGLSAMPLERPARAMETERIVPROC, glSamplerParameteriv )
VL_GL_FUNCTION( PFNGLSAMPLERPARAMETERFPROC, glSamplerParameterf )
VL_GL_FUNCTION( PFNGLSAMPLERPARAMETERFVPROC, glSamplerParameterfv )
VL_GL_FUNCTION( PFNGLSAMPLERPARAMETERIIVPROC, glSamplerParameterIiv )
VL_GL_FUNCTION( PFNGLSAMPLERPARAMETERIUIVPROC, glSamplerParameterIuiv )
VL_GL_FUNCTION( PFNGLGETSAMPLERPARAMETERIVPROC, glGetSamplerParameteriv )
VL_GL_FUNCTION( PFNGLGETSAMPLERPARAMETERIIVPROC, glGetSamplerParameterIiv )
VL_GL_FUNCTION( PFNGLGETSAMPLERPARAMETERFVPROC, glGetSamplerParameterfv )
VL_GL_FUNCTION( PFNGLGETSAMPLERPARAMETERIUIVPROC, glGetSamplerParameterIuiv )
#endif

// GL_ARB_timer_query
#ifdef GL_ARB_timer_query
VL_GL_FUNCTION( PFNGLQUERYCOUNTERPROC, glQueryCounter )
VL_GL_FUNCTION( PFNGLGETQUERYOBJECTI64VPROC, glGetQueryObjecti64v )
VL_GL_FUNCTION( PFNGLGETQUERYOBJECTUI64VPROC, glGetQueryObjectui64v )
#endif

// GL_ARB_vertex_type_2_10_10_10_rev
#ifdef GL_ARB_vertex_type_2_10_10_10_rev
VL_GL_FUNCTION( PFNGLVERTEXP2UIPROC, glVertexP2ui )
VL_GL_FUNCTION( PFNGLVERTEXP2UIVPROC, glVertexP2uiv )
VL_GL_FUNCTION( PFNGLVERTEXP3UIPROC, glVertexP3ui )
VL_GL_FUNCTION( PFNGLVERTEXP3UIVPROC, glVertexP3uiv )
VL_GL_FUNCTION( PFNGLVERTEXP4UIPROC, glVertexP4ui )
VL_GL_FUNCTION( PFNGLVERTEXP4UIVPROC, glVertexP4uiv )
VL_GL_FUNCTION( PFNGLTEXCOORDP1UIPROC, glTexCoordP1ui )
VL_GL_FUNCTION( PFNGLTEXCOORDP1UIVPROC, glTexCoordP1uiv )
VL_GL_FUNCTION( PFNGLTEXCOORDP2UIPROC, glTexCoordP2ui )
VL_GL_FUNCTION( PFNGLTEXCOORDP2UIVPROC, glTexCoordP2uiv )
VL_GL_FUNCTION( PFNGLTEXCOORDP3UIPROC, glTexCoordP3ui )
VL_GL_FUNCTION( PFNGLTEXCOORDP3UIVPROC, glTexCoordP3uiv )
VL_GL_FUNCTION( PFNGLTEXCOORDP4UIPROC, glTexCoordP4ui )
VL_GL_FUNCTION( PFNGLTEXCOORDP4UIVPROC, glTexCoordP4uiv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDP1UIPROC, glMultiTexCoordP1ui )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDP1UIVPROC, glMultiTexCoordP1uiv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDP2UIPROC, glMultiTexCoordP2ui )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDP2UIVPROC, glMultiTexCoordP2uiv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDP3UIPROC, glMultiTexCoordP3ui )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDP3UIVPROC, glMultiTexCoordP3uiv )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDP4UIPROC, glMultiTexCoordP4ui )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDP4UIVPROC, glMultiTexCoordP4uiv )
VL_GL_FUNCTION( PFNGLNORMALP3UIPROC, glNormalP3ui )
VL_GL_FUNCTION( PFNGLNORMALP3UIVPROC, glNormalP3uiv )
VL_GL_FUNCTION( PFNGLCOLORP3UIPROC, glColorP3ui )
VL_GL_FUNCTION( PFNGLCOLORP3UIVPROC, glColorP3uiv )
VL_GL_FUNCTION( PFNGLCOLORP4UIPROC, glColorP4ui )
VL_GL_FUNCTION( PFNGLCOLORP4UIVPROC, glColorP4uiv )
VL_GL_FUNCTION( PFNGLSECONDARYCOLORP3UIPROC, glSecondaryColorP3ui )
VL_GL_FUNCTION( PFNGLSECONDARYCOLORP3UIVPROC, glSecondaryColorP3uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBP1UIPROC, glVertexAttribP1ui )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBP1UIVPROC, glVertexAttribP1uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBP2UIPROC, glVertexAttribP2ui )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBP2UIVPROC, glVertexAttribP2uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBP3UIPROC, glVertexAttribP3ui )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBP3UIVPROC, glVertexAttribP3uiv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBP4UIPROC, glVertexAttribP4ui )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBP4UIVPROC, glVertexAttribP4uiv )
#endif

// GL_ARB_draw_indirect
#ifdef GL_ARB_draw_indirect
VL_GL_FUNCTION( PFNGLDRAWARRAYSINDIRECTPROC, glDrawArraysIndirect )
VL_GL_FUNCTION( PFNGLDRAWELEMENTSINDIRECTPROC, glDrawElementsIndirect )
#endif

// GL_ARB_gpu_shader_fp64
#ifdef GL_ARB_gpu_shader_fp64
VL_GL_FUNCTION( PFNGLUNIFORM1DPROC, glUniform1d )
VL_GL_FUNCTION( PFNGLUNIFORM2DPROC, glUniform2d )
VL_GL_FUNCTION( PFNGLUNIFORM3DPROC, glUniform3d )
VL_GL_FUNCTION( PFNGLUNIFORM4DPROC, glUniform4d )
VL_GL_FUNCTION( PFNGLUNIFORM1DVPROC, glUniform1dv )
VL_GL_FUNCTION( PFNGLUNIFORM2DVPROC, glUniform2dv )
VL_GL_FUNCTION( PFNGLUNIFORM3DVPROC, glUniform3dv )
VL_GL_FUNCTION( PFNGLUNIFORM4DVPROC, glUniform4dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX2DVPROC, glUniformMatrix2dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX3DVPROC, glUniformMatrix3dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX4DVPROC, glUniformMatrix4dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX2X3DVPROC, glUniformMatrix2x3dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX2X4DVPROC, glUniformMatrix2x4dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX3X2DVPROC, glUniformMatrix3x2dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX3X4DVPROC, glUniformMatrix3x4dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX4X2DVPROC, glUniformMatrix4x2dv )
VL_GL_FUNCTION( PFNGLUNIFORMMATRIX4X3DVPROC, glUniformMatrix4x3dv )
VL_GL_FUNCTION( PFNGLGETUNIFORMDVPROC, glGetUniformdv )
#endif

// GL_ARB_shader_subroutine
#ifdef GL_ARB_shader_subroutine
VL_GL_FUNCTION( PFNGLGETSUBROUTINEUNIFORMLOCATIONPROC, glGetSubroutineUniformLocation )
VL_GL_FUNCTION( PFNGLGETSUBROUTINEINDEXPROC, glGetSubroutineIndex )
VL_GL_FUNCTION( PFNGLGETACTIVESUBROUTINEUNIFORMIVPROC, glGetActiveSubroutineUniformiv )
VL_GL_FUNCTION( PFNGLGETACTIVESUBROUTINEUNIFORMNAMEPROC, glGetActiveSubroutineUniformName )
VL_GL_FUNCTION( PFNGLGETACTIVESUBROUTINENAMEPROC, glGetActiveSubroutineName )
VL_GL_FUNCTION( PFNGLUNIFORMSUBROUTINESUIVPROC, glUniformSubroutinesuiv )
VL_GL_FUNCTION( PFNGLGETUNIFORMSUBROUTINEUIVPROC, glGetUniformSubroutineuiv )
VL_GL_FUNCTION( PFNGLGETPROGRAMSTAGEIVPROC, glGetProgramStageiv )
#endif

// GL_ARB_tessellation_shader
#ifdef GL_ARB_tessellation_shader
VL_GL_FUNCTION( PFNGLPATCHPARAMETERIPROC, glPatchParameteri )
VL_GL_FUNCTION( PFNGLPATCHPARAMETERFVPROC, glPatchParameterfv )
#endif

// GL_ARB_transform_feedback2
#ifdef GL_ARB_transform_feedback2
VL_GL_FUNCTION( PFNGLBINDTRANSFORMFEEDBACKPROC, glBindTransformFeedback )
VL_GL_FUNCTION( PFNGLDELETETRANSFORMFEEDBACKSPROC, glDeleteTransformFeedbacks )
VL_GL_FUNCTION( PFNGLGENTRANSFORMFEEDBACKSPROC, glGenTransformFeedbacks )
VL_GL_FUNCTION( PFNGLISTRANSFORMFEEDBACKPROC, glIsTransformFeedback )
VL_GL_FUNCTION( PFNGLPAUSETRANSFORMFEEDBACKPROC, glPauseTransformFeedback )
VL_GL_FUNCTION( PFNGLRESUMETRANSFORMFEEDBACKPROC, glResumeTransformFeedback )
VL_GL_FUNCTION( PFNGLDRAWTRANSFORMFEEDBACKPROC, glDrawTransformFeedback )
#endif

// GL_ARB_transform_feedback3
#ifdef GL_ARB_transform_feedback3
VL_GL_FUNCTION( PFNGLDRAWTRANSFORMFEEDBACKSTREAMPROC, glDrawTransformFeedbackStream )
VL_GL_FUNCTION( PFNGLBEGINQUERYINDEXEDPROC, glBeginQueryIndexed )
VL_GL_FUNCTION( PFNGLENDQUERYINDEXEDPROC, glEndQueryIndexed )
VL_GL_FUNCTION( PFNGLGETQUERYINDEXEDIVPROC, glGetQueryIndexediv )
#endif

// GL_ARB_ES2_compatibility
#ifdef GL_ARB_ES2_compatibility
VL_GL_FUNCTION( PFNGLRELEASESHADERCOMPILERPROC, glReleaseShaderCompiler )
VL_GL_FUNCTION( PFNGLSHADERBINARYPROC, glShaderBinary )
VL_GL_FUNCTION( PFNGLGETSHADERPRECISIONFORMATPROC, glGetShaderPrecisionFormat )
VL_GL_FUNCTION( PFNGLDEPTHRANGEFPROC, glDepthRangef )
VL_GL_FUNCTION( PFNGLCLEARDEPTHFPROC, glClearDepthf )
#endif

// GL_ARB_get_program_binary
#ifdef GL_ARB_get_program_binary
VL_GL_FUNCTION( PFNGLGETPROGRAMBINARYPROC, glGetProgramBinary )
VL_GL_FUNCTION( PFNGLPROGRAMBINARYPROC, glProgramBinary )
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETERIPROC, glProgramParameteri )
#endif

// GL_ARB_separate_shader_objects
#ifdef GL_ARB_separate_shader_objects
VL_GL_FUNCTION( PFNGLUSEPROGRAMSTAGESPROC, glUseProgramStages )
VL_GL_FUNCTION( PFNGLACTIVESHADERPROGRAMPROC, glActiveShaderProgram )
VL_GL_FUNCTION( PFNGLCREATESHADERPROGRAMVPROC, glCreateShaderProgramv )
VL_GL_FUNCTION( PFNGLBINDPROGRAMPIPELINEPROC, glBindProgramPipeline )
VL_GL_FUNCTION( PFNGLDELETEPROGRAMPIPELINESPROC, glDeleteProgramPipelines )
VL_GL_FUNCTION( PFNGLGENPROGRAMPIPELINESPROC, glGenProgramPipelines )
VL_GL_FUNCTION( PFNGLISPROGRAMPIPELINEPROC, glIsProgramPipeline )
VL_GL_FUNCTION( PFNGLGETPROGRAMPIPELINEIVPROC, glGetProgramPipelineiv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1IPROC, glProgramUniform1i )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1IVPROC, glProgramUniform1iv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1FPROC, glProgramUniform1f )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1FVPROC, glProgramUniform1fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1DPROC, glProgramUniform1d )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1DVPROC, glProgramUniform1dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1UIPROC, glProgramUniform1ui )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1UIVPROC, glProgramUniform1uiv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2IPROC, glProgramUniform2i )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2IVPROC, glProgramUniform2iv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2FPROC, glProgramUniform2f )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2FVPROC, glProgramUniform2fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2DPROC, glProgramUniform2d )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2DVPROC, glProgramUniform2dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2UIPROC, glProgramUniform2ui )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2UIVPROC, glProgramUniform2uiv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3IPROC, glProgramUniform3i )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3IVPROC, glProgramUniform3iv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3FPROC, glProgramUniform3f )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3FVPROC, glProgramUniform3fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3DPROC, glProgramUniform3d )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3DVPROC, glProgramUniform3dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3UIPROC, glProgramUniform3ui )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3UIVPROC, glProgramUniform3uiv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4IPROC, glProgramUniform4i )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4IVPROC, glProgramUniform4iv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4FPROC, glProgramUniform4f )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4FVPROC, glProgramUniform4fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4DPROC, glProgramUniform4d )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4DVPROC, glProgramUniform4dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4UIPROC, glProgramUniform4ui )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4UIVPROC, glProgramUniform4uiv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2FVPROC, glProgramUniformMatrix2fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3FVPROC, glProgramUniformMatrix3fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4FVPROC, glProgramUniformMatrix4fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2DVPROC, glProgramUniformMatrix2dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3DVPROC, glProgramUniformMatrix3dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4DVPROC, glProgramUniformMatrix4dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2X3FVPROC, glProgramUniformMatrix2x3fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3X2FVPROC, glProgramUniformMatrix3x2fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2X4FVPROC, glProgramUniformMatrix2x4fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4X2FVPROC, glProgramUniformMatrix4x2fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3X4FVPROC, glProgramUniformMatrix3x4fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4X3FVPROC, glProgramUniformMatrix4x3fv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2X3DVPROC, glProgramUniformMatrix2x3dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3X2DVPROC, glProgramUniformMatrix3x2dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2X4DVPROC, glProgramUniformMatrix2x4dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4X2DVPROC, glProgramUniformMatrix4x2dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3X4DVPROC, glProgramUniformMatrix3x4dv )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4X3DVPROC, glProgramUniformMatrix4x3dv )
VL_GL_FUNCTION( PFNGLVALIDATEPROGRAMPIPELINEPROC, glValidateProgramPipeline )
VL_GL_FUNCTION( PFNGLGETPROGRAMPIPELINEINFOLOGPROC, glGetProgramPipelineInfoLog )
#endif

// GL_ARB_vertex_attrib_64bit
#ifdef GL_ARB_vertex_attrib_64bit
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL1DPROC, glVertexAttribL1d )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL2DPROC, glVertexAttribL2d )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL3DPROC, glVertexAttribL3d )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL4DPROC, glVertexAttribL4d )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL1DVPROC, glVertexAttribL1dv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL2DVPROC, glVertexAttribL2dv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL3DVPROC, glVertexAttribL3dv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL4DVPROC, glVertexAttribL4dv )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBLPOINTERPROC, glVertexAttribLPointer )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBLDVPROC, glGetVertexAttribLdv )
#endif

// GL_ARB_viewport_array
#ifdef GL_ARB_viewport_array
VL_GL_FUNCTION( PFNGLVIEWPORTARRAYVPROC, glViewportArrayv )
VL_GL_FUNCTION( PFNGLVIEWPORTINDEXEDFPROC, glViewportIndexedf )
VL_GL_FUNCTION( PFNGLVIEWPORTINDEXEDFVPROC, glViewportIndexedfv )
VL_GL_FUNCTION( PFNGLSCISSORARRAYVPROC, glScissorArrayv )
VL_GL_FUNCTION( PFNGLSCISSORINDEXEDPROC, glScissorIndexed )
VL_GL_FUNCTION( PFNGLSCISSORINDEXEDVPROC, glScissorIndexedv )
VL_GL_FUNCTION( PFNGLDEPTHRANGEARRAYVPROC, glDepthRangeArrayv )
VL_GL_FUNCTION( PFNGLDEPTHRANGEINDEXEDPROC, glDepthRangeIndexed )
VL_GL_FUNCTION( PFNGLGETFLOATI_VPROC, glGetFloati_v )
VL_GL_FUNCTION( PFNGLGETDOUBLEI_VPROC, glGetDoublei_v )
#endif

// GL_ARB_cl_event
#ifdef GL_ARB_cl_event
VL_GL_FUNCTION( PFNGLCREATESYNCFROMCLEVENTARBPROC, glCreateSyncFromCLeventARB )
#endif

// GL_ARB_debug_output
#ifdef GL_ARB_debug_output
VL_GL_FUNCTION( PFNGLDEBUGMESSAGECONTROLARBPROC, glDebugMessageControlARB )
VL_GL_FUNCTION( PFNGLDEBUGMESSAGEINSERTARBPROC, glDebugMessageInsertARB )
VL_GL_FUNCTION( PFNGLDEBUGMESSAGECALLBACKARBPROC, glDebugMessageCallbackARB )
VL_GL_FUNCTION( PFNGLGETDEBUGMESSAGELOGARBPROC, glGetDebugMessageLogARB )
#endif

// GL_ARB_robustness
#ifdef GL_ARB_robustness
VL_GL_FUNCTION( PFNGLGETGRAPHICSRESETSTATUSARBPROC, glGetGraphicsResetStatusARB )
VL_GL_FUNCTION( PFNGLGETNMAPDVARBPROC, glGetnMapdvARB )
VL_GL_FUNCTION( PFNGLGETNMAPFVARBPROC, glGetnMapfvARB )
VL_GL_FUNCTION( PFNGLGETNMAPIVARBPROC, glGetnMapivARB )
VL_GL_FUNCTION( PFNGLGETNPIXELMAPFVARBPROC, glGetnPixelMapfvARB )
VL_GL_FUNCTION( PFNGLGETNPIXELMAPUIVARBPROC, glGetnPixelMapuivARB )
VL_GL_FUNCTION( PFNGLGETNPIXELMAPUSVARBPROC, glGetnPixelMapusvARB )
VL_GL_FUNCTION( PFNGLGETNPOLYGONSTIPPLEARBPROC, glGetnPolygonStippleARB )
VL_GL_FUNCTION( PFNGLGETNCOLORTABLEARBPROC, glGetnColorTableARB )
VL_GL_FUNCTION( PFNGLGETNCONVOLUTIONFILTERARBPROC, glGetnConvolutionFilterARB )
VL_GL_FUNCTION( PFNGLGETNSEPARABLEFILTERARBPROC, glGetnSeparableFilterARB )
VL_GL_FUNCTION( PFNGLGETNHISTOGRAMARBPROC, glGetnHistogramARB )
VL_GL_FUNCTION( PFNGLGETNMINMAXARBPROC, glGetnMinmaxARB )
VL_GL_FUNCTION( PFNGLGETNTEXIMAGEARBPROC, glGetnTexImageARB )
VL_GL_FUNCTION( PFNGLREADNPIXELSARBPROC, glReadnPixelsARB )
VL_GL_FUNCTION( PFNGLGETNCOMPRESSEDTEXIMAGEARBPROC, glGetnCompressedTexImageARB )
VL_GL_FUNCTION( PFNGLGETNUNIFORMFVARBPROC, glGetnUniformfvARB )
VL_GL_FUNCTION( PFNGLGETNUNIFORMIVARBPROC, glGetnUniformivARB )
VL_GL_FUNCTION( PFNGLGETNUNIFORMUIVARBPROC, glGetnUniformuivARB )
VL_GL_FUNCTION( PFNGLGETNUNIFORMDVARBPROC, glGetnUniformdvARB )
#endif

// GL_EXT_blend_color
#ifdef GL_EXT_blend_color
VL_GL_FUNCTION( PFNGLBLENDCOLOREXTPROC, glBlendColorEXT )
#endif

// GL_EXT_polygon_offset
#ifdef GL_EXT_polygon_offset
VL_GL_FUNCTION( PFNGLPOLYGONOFFSETEXTPROC, glPolygonOffsetEXT )
#endif

// GL_EXT_texture3D
#ifdef GL_EXT_texture3D
VL_GL_FUNCTION( PFNGLTEXIMAGE3DEXTPROC, glTexImage3DEXT )
VL_GL_FUNCTION( PFNGLTEXSUBIMAGE3DEXTPROC, glTexSubImage3DEXT )
#endif

// GL_SGIS_texture_filter4
#ifdef GL_SGIS_texture_filter4
VL_GL_FUNCTION( PFNGLGETTEXFILTERFUNCSGISPROC, glGetTexFilterFuncSGIS )
VL_GL_FUNCTION( PFNGLTEXFILTERFUNCSGISPROC, glTexFilterFuncSGIS )
#endif

// GL_EXT_subtexture
#ifdef GL_EXT_subtexture
VL_GL_FUNCTION( PFNGLTEXSUBIMAGE1DEXTPROC, glTexSubImage1DEXT )
VL_GL_FUNCTION( PFNGLTEXSUBIMAGE2DEXTPROC, glTexSubImage2DEXT )
#endif

// GL_EXT_copy_texture
#ifdef GL_EXT_copy_texture
VL_GL_FUNCTION( PFNGLCOPYTEXIMAGE1DEXTPROC, glCopyTexImage1DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXIMAGE2DEXTPROC, glCopyTexImage2DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXSUBIMAGE1DEXTPROC, glCopyTexSubImage1DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXSUBIMAGE2DEXTPROC, glCopyTexSubImage2DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXSUBIMAGE3DEXTPROC, glCopyTexSubImage3DEXT )
#endif

// GL_EXT_histogram
#ifdef GL_EXT_histogram
VL_GL_FUNCTION( PFNGLGETHISTOGRAMEXTPROC, glGetHistogramEXT )
VL_GL_FUNCTION( PFNGLGETHISTOGRAMPARAMETERFVEXTPROC, glGetHistogramParameterfvEXT )
VL_GL_FUNCTION( PFNGLGETHISTOGRAMPARAMETERIVEXTPROC, glGetHistogramParameterivEXT )
VL_GL_FUNCTION( PFNGLGETMINMAXEXTPROC, glGetMinmaxEXT )
VL_GL_FUNCTION( PFNGLGETMINMAXPARAMETERFVEXTPROC, glGetMinmaxParameterfvEXT )
VL_GL_FUNCTION( PFNGLGETMINMAXPARAMETERIVEXTPROC, glGetMinmaxParameterivEXT )
VL_GL_FUNCTION( PFNGLHISTOGRAMEXTPROC, glHistogramEXT )
VL_GL_FUNCTION( PFNGLMINMAXEXTPROC, glMinmaxEXT )
VL_GL_FUNCTION( PFNGLRESETHISTOGRAMEXTPROC, glResetHistogramEXT )
VL_GL_FUNCTION( PFNGLRESETMINMAXEXTPROC, glResetMinmaxEXT )
#endif

// GL_EXT_convolution
#ifdef GL_EXT_convolution
VL_GL_FUNCTION( PFNGLCONVOLUTIONFILTER1DEXTPROC, glConvolutionFilter1DEXT )
VL_GL_FUNCTION( PFNGLCONVOLUTIONFILTER2DEXTPROC, glConvolutionFilter2DEXT )
VL_GL_FUNCTION( PFNGLCONVOLUTIONPARAMETERFEXTPROC, glConvolutionParameterfEXT )
VL_GL_FUNCTION( PFNGLCONVOLUTIONPARAMETERFVEXTPROC, glConvolutionParameterfvEXT )
VL_GL_FUNCTION( PFNGLCONVOLUTIONPARAMETERIEXTPROC, glConvolutionParameteriEXT )
VL_GL_FUNCTION( PFNGLCONVOLUTIONPARAMETERIVEXTPROC, glConvolutionParameterivEXT )
VL_GL_FUNCTION( PFNGLCOPYCONVOLUTIONFILTER1DEXTPROC, glCopyConvolutionFilter1DEXT )
VL_GL_FUNCTION( PFNGLCOPYCONVOLUTIONFILTER2DEXTPROC, glCopyConvolutionFilter2DEXT )
VL_GL_FUNCTION( PFNGLGETCONVOLUTIONFILTEREXTPROC, glGetConvolutionFilterEXT )
VL_GL_FUNCTION( PFNGLGETCONVOLUTIONPARAMETERFVEXTPROC, glGetConvolutionParameterfvEXT )
VL_GL_FUNCTION( PFNGLGETCONVOLUTIONPARAMETERIVEXTPROC, glGetConvolutionParameterivEXT )
VL_GL_FUNCTION( PFNGLGETSEPARABLEFILTEREXTPROC, glGetSeparableFilterEXT )
VL_GL_FUNCTION( PFNGLSEPARABLEFILTER2DEXTPROC, glSeparableFilter2DEXT )
#endif

// GL_SGI_color_table
#ifdef GL_SGI_color_table
VL_GL_FUNCTION( PFNGLCOLORTABLESGIPROC, glColorTableSGI )
VL_GL_FUNCTION( PFNGLCOLORTABLEPARAMETERFVSGIPROC, glColorTableParameterfvSGI )
VL_GL_FUNCTION( PFNGLCOLORTABLEPARAMETERIVSGIPROC, glColorTableParameterivSGI )
VL_GL_FUNCTION( PFNGLCOPYCOLORTABLESGIPROC, glCopyColorTableSGI )
VL_GL_FUNCTION( PFNGLGETCOLORTABLESGIPROC, glGetColorTableSGI )
VL_GL_FUNCTION( PFNGLGETCOLORTABLEPARAMETERFVSGIPROC, glGetColorTableParameterfvSGI )
VL_GL_FUNCTION( PFNGLGETCOLORTABLEPARAMETERIVSGIPROC, glGetColorTableParameterivSGI )
#endif

// GL_SGIX_pixel_texture
#ifdef GL_SGIX_pixel_texture
VL_GL_FUNCTION( PFNGLPIXELTEXGENSGIXPROC, glPixelTexGenSGIX )
#endif

// GL_SGIS_pixel_texture
#ifdef GL_SGIS_pixel_texture
VL_GL_FUNCTION( PFNGLPIXELTEXGENPARAMETERISGISPROC, glPixelTexGenParameteriSGIS )
VL_GL_FUNCTION( PFNGLPIXELTEXGENPARAMETERIVSGISPROC, glPixelTexGenParameterivSGIS )
VL_GL_FUNCTION( PFNGLPIXELTEXGENPARAMETERFSGISPROC, glPixelTexGenParameterfSGIS )
VL_GL_FUNCTION( PFNGLPIXELTEXGENPARAMETERFVSGISPROC, glPixelTexGenParameterfvSGIS )
VL_GL_FUNCTION( PFNGLGETPIXELTEXGENPARAMETERIVSGISPROC, glGetPixelTexGenParameterivSGIS )
VL_GL_FUNCTION( PFNGLGETPIXELTEXGENPARAMETERFVSGISPROC, glGetPixelTexGenParameterfvSGIS )
#endif

// GL_SGIS_texture4D
#ifdef GL_SGIS_texture4D
VL_GL_FUNCTION( PFNGLTEXIMAGE4DSGISPROC, glTexImage4DSGIS )
VL_GL_FUNCTION( PFNGLTEXSUBIMAGE4DSGISPROC, glTexSubImage4DSGIS )
#endif

// GL_EXT_texture_object
#ifdef GL_EXT_texture_object
VL_GL_FUNCTION( PFNGLARETEXTURESRESIDENTEXTPROC, glAreTexturesResidentEXT )
VL_GL_FUNCTION( PFNGLBINDTEXTUREEXTPROC, glBindTextureEXT )
VL_GL_FUNCTION( PFNGLDELETETEXTURESEXTPROC, glDeleteTexturesEXT )
VL_GL_FUNCTION( PFNGLGENTEXTURESEXTPROC, glGenTexturesEXT )
VL_GL_FUNCTION( PFNGLISTEXTUREEXTPROC, glIsTextureEXT )
VL_GL_FUNCTION( PFNGLPRIORITIZETEXTURESEXTPROC, glPrioritizeTexturesEXT )
#endif

// GL_SGIS_detail_texture
#ifdef GL_SGIS_detail_texture
VL_GL_FUNCTION( PFNGLDETAILTEXFUNCSGISPROC, glDetailTexFuncSGIS )
VL_GL_FUNCTION( PFNGLGETDETAILTEXFUNCSGISPROC, glGetDetailTexFuncSGIS )
#endif

// GL_SGIS_sharpen_texture
#ifdef GL_SGIS_sharpen_texture
VL_GL_FUNCTION( PFNGLSHARPENTEXFUNCSGISPROC, glSharpenTexFuncSGIS )
VL_GL_FUNCTION( PFNGLGETSHARPENTEXFUNCSGISPROC, glGetSharpenTexFuncSGIS )
#endif

// GL_SGIS_multisample
#ifdef GL_SGIS_multisample
VL_GL_FUNCTION( PFNGLSAMPLEMASKSGISPROC, glSampleMaskSGIS )
VL_GL_FUNCTION( PFNGLSAMPLEPATTERNSGISPROC, glSamplePatternSGIS )
#endif

// GL_EXT_vertex_array
#ifdef GL_EXT_vertex_array
VL_GL_FUNCTION( PFNGLARRAYELEMENTEXTPROC, glArrayElementEXT )
VL_GL_FUNCTION( PFNGLCOLORPOINTEREXTPROC, glColorPointerEXT )
VL_GL_FUNCTION( PFNGLDRAWARRAYSEXTPROC, glDrawArraysEXT )
VL_GL_FUNCTION( PFNGLEDGEFLAGPOINTEREXTPROC, glEdgeFlagPointerEXT )
VL_GL_FUNCTION( PFNGLGETPOINTERVEXTPROC, glGetPointervEXT )
VL_GL_FUNCTION( PFNGLINDEXPOINTEREXTPROC, glIndexPointerEXT )
VL_GL_FUNCTION( PFNGLNORMALPOINTEREXTPROC, glNormalPointerEXT )
VL_GL_FUNCTION( PFNGLTEXCOORDPOINTEREXTPROC, glTexCoordPointerEXT )
VL_GL_FUNCTION( PFNGLVERTEXPOINTEREXTPROC, glVertexPointerEXT )
#endif

// GL_EXT_blend_minmax
#ifdef GL_EXT_blend_minmax
VL_GL_FUNCTION( PFNGLBLENDEQUATIONEXTPROC, glBlendEquationEXT )
#endif

// GL_SGIX_sprite
#ifdef GL_SGIX_sprite
VL_GL_FUNCTION( PFNGLSPRITEPARAMETERFSGIXPROC, glSpriteParameterfSGIX )
VL_GL_FUNCTION( PFNGLSPRITEPARAMETERFVSGIXPROC, glSpriteParameterfvSGIX )
VL_GL_FUNCTION( PFNGLSPRITEPARAMETERISGIXPROC, glSpriteParameteriSGIX )
VL_GL_FUNCTION( PFNGLSPRITEPARAMETERIVSGIXPROC, glSpriteParameterivSGIX )
#endif

// GL_EXT_point_parameters
#ifdef GL_EXT_point_parameters
VL_GL_FUNCTION( PFNGLPOINTPARAMETERFEXTPROC, glPointParameterfEXT )
VL_GL_FUNCTION( PFNGLPOINTPARAMETERFVEXTPROC, glPointParameterfvEXT )
#endif

// GL_SGIS_point_parameters
#ifdef GL_SGIS_point_parameters
VL_GL_FUNCTION( PFNGLPOINTPARAMETERFSGISPROC, glPointParameterfSGIS )
VL_GL_FUNCTION( PFNGLPOINTPARAMETERFVSGISPROC, glPointParameterfvSGIS )
#endif

// GL_SGIX_instruments
#ifdef GL_SGIX_instruments
VL_GL_FUNCTION( PFNGLGETINSTRUMENTSSGIXPROC, glGetInstrumentsSGIX )
VL_GL_FUNCTION( PFNGLINSTRUMENTSBUFFERSGIXPROC, glInstrumentsBufferSGIX )
VL_GL_FUNCTION( PFNGLPOLLINSTRUMENTSSGIXPROC, glPollInstrumentsSGIX )
VL_GL_FUNCTION( PFNGLREADINSTRUMENTSSGIXPROC, glReadInstrumentsSGIX )
VL_GL_FUNCTION( PFNGLSTARTINSTRUMENTSSGIXPROC, glStartInstrumentsSGIX )
VL_GL_FUNCTION( PFNGLSTOPINSTRUMENTSSGIXPROC, glStopInstrumentsSGIX )
#endif

// GL_SGIX_framezoom
#ifdef GL_SGIX_framezoom
VL_GL_FUNCTION( PFNGLFRAMEZOOMSGIXPROC, glFrameZoomSGIX )
#endif

// GL_SGIX_tag_sample_buffer
#ifdef GL_SGIX_tag_sample_buffer
VL_GL_FUNCTION( PFNGLTAGSAMPLEBUFFERSGIXPROC, glTagSampleBufferSGIX )
#endif

// GL_SGIX_polynomial_ffd
#ifdef GL_SGIX_polynomial_ffd
VL_GL_FUNCTION( PFNGLDEFORMATIONMAP3DSGIXPROC, glDeformationMap3dSGIX )
VL_GL_FUNCTION( PFNGLDEFORMATIONMAP3FSGIXPROC, glDeformationMap3fSGIX )
VL_GL_FUNCTION( PFNGLDEFORMSGIXPROC, glDeformSGIX )
VL_GL_FUNCTION( PFNGLLOADIDENTITYDEFORMATIONMAPSGIXPROC, glLoadIdentityDeformationMapSGIX )
#endif

// GL_SGIX_reference_plane
#ifdef GL_SGIX_reference_plane
VL_GL_FUNCTION( PFNGLREFERENCEPLANESGIXPROC, glReferencePlaneSGIX )
#endif

// GL_SGIX_flush_raster
#ifdef GL_SGIX_flush_raster
VL_GL_FUNCTION( PFNGLFLUSHRASTERSGIXPROC, glFlushRasterSGIX )
#endif

// GL_SGIS_fog_function
#ifdef GL_SGIS_fog_function
VL_GL_FUNCTION( PFNGLFOGFUNCSGISPROC, glFogFuncSGIS )
VL_GL_FUNCTION( PFNGLGETFOGFUNCSGISPROC, glGetFogFuncSGIS )
#endif

// GL_HP_image_transform
#ifdef GL_HP_image_transform
VL_GL_FUNCTION( PFNGLIMAGETRANSFORMPARAMETERIHPPROC, glImageTransformParameteriHP )
VL_GL_FUNCTION( PFNGLIMAGETRANSFORMPARAMETERFHPPROC, glImageTransformParameterfHP )
VL_GL_FUNCTION( PFNGLIMAGETRANSFORMPARAMETERIVHPPROC, glImageTransformParameterivHP )
VL_GL_FUNCTION( PFNGLIMAGETRANSFORMPARAMETERFVHPPROC, glImageTransformParameterfvHP )
VL_GL_FUNCTION( PFNGLGETIMAGETRANSFORMPARAMETERIVHPPROC, glGetImageTransformParameterivHP )
VL_GL_FUNCTION( PFNGLGETIMAGETRANSFORMPARAMETERFVHPPROC, glGetImageTransformParameterfvHP )
#endif

// GL_EXT_color_subtable
#ifdef GL_EXT_color_subtable
VL_GL_FUNCTION( PFNGLCOLORSUBTABLEEXTPROC, glColorSubTableEXT )
VL_GL_FUNCTION( PFNGLCOPYCOLORSUBTABLEEXTPROC, glCopyColorSubTableEXT )
#endif

// GL_PGI_misc_hints
#ifdef GL_PGI_misc_hints
VL_GL_FUNCTION( PFNGLHINTPGIPROC, glHintPGI )
#endif

// GL_EXT_paletted_texture
#ifdef GL_EXT_paletted_texture
VL_GL_FUNCTION( PFNGLCOLORTABLEEXTPROC, glColorTableEXT )
VL_GL_FUNCTION( PFNGLGETCOLORTABLEEXTPROC, glGetColorTableEXT )
VL_GL_FUNCTION( PFNGLGETCOLORTABLEPARAMETERIVEXTPROC, glGetColorTableParameterivEXT )
VL_GL_FUNCTION( PFNGLGETCOLORTABLEPARAMETERFVEXTPROC, glGetColorTableParameterfvEXT )
#endif

// GL_SGIX_list_priority
#ifdef GL_SGIX_list_priority
VL_GL_FUNCTION( PFNGLGETLISTPARAMETERFVSGIXPROC, glGetListParameterfvSGIX )
VL_GL_FUNCTION( PFNGLGETLISTPARAMETERIVSGIXPROC, glGetListParameterivSGIX )
VL_GL_FUNCTION( PFNGLLISTPARAMETERFSGIXPROC, glListParameterfSGIX )
VL_GL_FUNCTION( PFNGLLISTPARAMETERFVSGIXPROC, glListParameterfvSGIX )
VL_GL_FUNCTION( PFNGLLISTPARAMETERISGIXPROC, glListParameteriSGIX )
VL_GL_FUNCTION( PFNGLLISTPARAMETERIVSGIXPROC, glListParameterivSGIX )
#endif

// GL_EXT_index_material
#ifdef GL_EXT_index_material
VL_GL_FUNCTION( PFNGLINDEXMATERIALEXTPROC, glIndexMaterialEXT )
#endif

// GL_EXT_index_func
#ifdef GL_EXT_index_func
VL_GL_FUNCTION( PFNGLINDEXFUNCEXTPROC, glIndexFuncEXT )
#endif

// GL_EXT_compiled_vertex_array
#ifdef GL_EXT_compiled_vertex_array
VL_GL_FUNCTION( PFNGLLOCKARRAYSEXTPROC, glLockArraysEXT )
VL_GL_FUNCTION( PFNGLUNLOCKARRAYSEXTPROC, glUnlockArraysEXT )
#endif

// GL_EXT_cull_vertex
#ifdef GL_EXT_cull_vertex
VL_GL_FUNCTION( PFNGLCULLPARAMETERDVEXTPROC, glCullParameterdvEXT )
VL_GL_FUNCTION( PFNGLCULLPARAMETERFVEXTPROC, glCullParameterfvEXT )
#endif

// GL_SGIX_fragment_lighting
#ifdef GL_SGIX_fragment_lighting
VL_GL_FUNCTION( PFNGLFRAGMENTCOLORMATERIALSGIXPROC, glFragmentColorMaterialSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTLIGHTFSGIXPROC, glFragmentLightfSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTLIGHTFVSGIXPROC, glFragmentLightfvSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTLIGHTISGIXPROC, glFragmentLightiSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTLIGHTIVSGIXPROC, glFragmentLightivSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTLIGHTMODELFSGIXPROC, glFragmentLightModelfSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTLIGHTMODELFVSGIXPROC, glFragmentLightModelfvSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTLIGHTMODELISGIXPROC, glFragmentLightModeliSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTLIGHTMODELIVSGIXPROC, glFragmentLightModelivSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTMATERIALFSGIXPROC, glFragmentMaterialfSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTMATERIALFVSGIXPROC, glFragmentMaterialfvSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTMATERIALISGIXPROC, glFragmentMaterialiSGIX )
VL_GL_FUNCTION( PFNGLFRAGMENTMATERIALIVSGIXPROC, glFragmentMaterialivSGIX )
VL_GL_FUNCTION( PFNGLGETFRAGMENTLIGHTFVSGIXPROC, glGetFragmentLightfvSGIX )
VL_GL_FUNCTION( PFNGLGETFRAGMENTLIGHTIVSGIXPROC, glGetFragmentLightivSGIX )
VL_GL_FUNCTION( PFNGLGETFRAGMENTMATERIALFVSGIXPROC, glGetFragmentMaterialfvSGIX )
VL_GL_FUNCTION( PFNGLGETFRAGMENTMATERIALIVSGIXPROC, glGetFragmentMaterialivSGIX )
VL_GL_FUNCTION( PFNGLLIGHTENVISGIXPROC, glLightEnviSGIX )
#endif

// GL_EXT_draw_range_elements
#ifdef GL_EXT_draw_range_elements
VL_GL_FUNCTION( PFNGLDRAWRANGEELEMENTSEXTPROC, glDrawRangeElementsEXT )
#endif

// GL_EXT_light_texture
#ifdef GL_EXT_light_texture
VL_GL_FUNCTION( PFNGLAPPLYTEXTUREEXTPROC, glApplyTextureEXT )
VL_GL_FUNCTION( PFNGLTEXTURELIGHTEXTPROC, glTextureLightEXT )
VL_GL_FUNCTION( PFNGLTEXTUREMATERIALEXTPROC, glTextureMaterialEXT )
#endif

// GL_SGIX_async
#ifdef GL_SGIX_async
VL_GL_FUNCTION( PFNGLASYNCMARKERSGIXPROC, glAsyncMarkerSGIX )
VL_GL_FUNCTION( PFNGLFINISHASYNCSGIXPROC, glFinishAsyncSGIX )
VL_GL_FUNCTION( PFNGLPOLLASYNCSGIXPROC, glPollAsyncSGIX )
VL_GL_FUNCTION( PFNGLGENASYNCMARKERSSGIXPROC, glGenAsyncMarkersSGIX )
VL_GL_FUNCTION( PFNGLDELETEASYNCMARKERSSGIXPROC, glDeleteAsyncMarkersSGIX )
VL_GL_FUNCTION( PFNGLISASYNCMARKERSGIXPROC, glIsAsyncMarkerSGIX )
#endif

// GL_INTEL_parallel_arrays
#ifdef GL_INTEL_parallel_arrays
VL_GL_FUNCTION( PFNGLVERTEXPOINTERVINTELPROC, glVertexPointervINTEL )
VL_GL_FUNCTION( PFNGLNORMALPOINTERVINTELPROC, glNormalPointervINTEL )
VL_GL_FUNCTION( PFNGLCOLORPOINTERVINTELPROC, glColorPointervINTEL )
VL_GL_FUNCTION( PFNGLTEXCOORDPOINTERVINTELPROC, glTexCoordPointervINTEL )
#endif

// GL_EXT_pixel_transform
#ifdef GL_EXT_pixel_transform
VL_GL_FUNCTION( PFNGLPIXELTRANSFORMPARAMETERIEXTPROC, glPixelTransformParameteriEXT )
VL_GL_FUNCTION( PFNGLPIXELTRANSFORMPARAMETERFEXTPROC, glPixelTransformParameterfEXT )
VL_GL_FUNCTION( PFNGLPIXELTRANSFORMPARAMETERIVEXTPROC, glPixelTransformParameterivEXT )
VL_GL_FUNCTION( PFNGLPIXELTRANSFORMPARAMETERFVEXTPROC, glPixelTransformParameterfvEXT )
#endif

// GL_EXT_secondary_color
#ifdef GL_EXT_secondary_color
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3BEXTPROC, glSecondaryColor3bEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3BVEXTPROC, glSecondaryColor3bvEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3DEXTPROC, glSecondaryColor3dEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3DVEXTPROC, glSecondaryColor3dvEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3FEXTPROC, glSecondaryColor3fEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3FVEXTPROC, glSecondaryColor3fvEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3IEXTPROC, glSecondaryColor3iEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3IVEXTPROC, glSecondaryColor3ivEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3SEXTPROC, glSecondaryColor3sEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3SVEXTPROC, glSecondaryColor3svEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3UBEXTPROC, glSecondaryColor3ubEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3UBVEXTPROC, glSecondaryColor3ubvEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3UIEXTPROC, glSecondaryColor3uiEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3UIVEXTPROC, glSecondaryColor3uivEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3USEXTPROC, glSecondaryColor3usEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3USVEXTPROC, glSecondaryColor3usvEXT )
VL_GL_FUNCTION( PFNGLSECONDARYCOLORPOINTEREXTPROC, glSecondaryColorPointerEXT )
#endif

// GL_EXT_texture_perturb_normal
#ifdef GL_EXT_texture_perturb_normal
VL_GL_FUNCTION( PFNGLTEXTURENORMALEXTPROC, glTextureNormalEXT )
#endif

// GL_EXT_multi_draw_arrays
#ifdef GL_EXT_multi_draw_arrays
VL_GL_FUNCTION( PFNGLMULTIDRAWARRAYSEXTPROC, glMultiDrawArraysEXT )
VL_GL_FUNCTION( PFNGLMULTIDRAWELEMENTSEXTPROC, glMultiDrawElementsEXT )
#endif

// GL_EXT_fog_coord
#ifdef GL_EXT_fog_coord
VL_GL_FUNCTION( PFNGLFOGCOORDFEXTPROC, glFogCoordfEXT )
VL_GL_FUNCTION( PFNGLFOGCOORDFVEXTPROC, glFogCoordfvEXT )
VL_GL_FUNCTION( PFNGLFOGCOORDDEXTPROC, glFogCoorddEXT )
VL_GL_FUNCTION( PFNGLFOGCOORDDVEXTPROC, glFogCoorddvEXT )
VL_GL_FUNCTION( PFNGLFOGCOORDPOINTEREXTPROC, glFogCoordPointerEXT )
#endif

// GL_EXT_coordinate_frame
#ifdef GL_EXT_coordinate_frame
VL_GL_FUNCTION( PFNGLTANGENT3BEXTPROC, glTangent3bEXT )
VL_GL_FUNCTION( PFNGLTANGENT3BVEXTPROC, glTangent3bvEXT )
VL_GL_FUNCTION( PFNGLTANGENT3DEXTPROC, glTangent3dEXT )
VL_GL_FUNCTION( PFNGLTANGENT3DVEXTPROC, glTangent3dvEXT )
VL_GL_FUNCTION( PFNGLTANGENT3FEXTPROC, glTangent3fEXT )
VL_GL_FUNCTION( PFNGLTANGENT3FVEXTPROC, glTangent3fvEXT )
VL_GL_FUNCTION( PFNGLTANGENT3IEXTPROC, glTangent3iEXT )
VL_GL_FUNCTION( PFNGLTANGENT3IVEXTPROC, glTangent3ivEXT )
VL_GL_FUNCTION( PFNGLTANGENT3SEXTPROC, glTangent3sEXT )
VL_GL_FUNCTION( PFNGLTANGENT3SVEXTPROC, glTangent3svEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3BEXTPROC, glBinormal3bEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3BVEXTPROC, glBinormal3bvEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3DEXTPROC, glBinormal3dEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3DVEXTPROC, glBinormal3dvEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3FEXTPROC, glBinormal3fEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3FVEXTPROC, glBinormal3fvEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3IEXTPROC, glBinormal3iEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3IVEXTPROC, glBinormal3ivEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3SEXTPROC, glBinormal3sEXT )
VL_GL_FUNCTION( PFNGLBINORMAL3SVEXTPROC, glBinormal3svEXT )
VL_GL_FUNCTION( PFNGLTANGENTPOINTEREXTPROC, glTangentPointerEXT )
VL_GL_FUNCTION( PFNGLBINORMALPOINTEREXTPROC, glBinormalPointerEXT )
#endif

// GL_SUNX_constant_data
#ifdef GL_SUNX_constant_data
VL_GL_FUNCTION( PFNGLFINISHTEXTURESUNXPROC, glFinishTextureSUNX )
#endif

// GL_SUN_global_alpha
#ifdef GL_SUN_global_alpha
VL_GL_FUNCTION( PFNGLGLOBALALPHAFACTORBSUNPROC, glGlobalAlphaFactorbSUN )
VL_GL_FUNCTION( PFNGLGLOBALALPHAFACTORSSUNPROC, glGlobalAlphaFactorsSUN )
VL_GL_FUNCTION( PFNGLGLOBALALPHAFACTORISUNPROC, glGlobalAlphaFactoriSUN )
VL_GL_FUNCTION( PFNGLGLOBALALPHAFACTORFSUNPROC, glGlobalAlphaFactorfSUN )
VL_GL_FUNCTION( PFNGLGLOBALALPHAFACTORDSUNPROC, glGlobalAlphaFactordSUN )
VL_GL_FUNCTION( PFNGLGLOBALALPHAFACTORUBSUNPROC, glGlobalAlphaFactorubSUN )
VL_GL_FUNCTION( PFNGLGLOBALALPHAFACTORUSSUNPROC, glGlobalAlphaFactorusSUN )
VL_GL_FUNCTION( PFNGLGLOBALALPHAFACTORUISUNPROC, glGlobalAlphaFactoruiSUN )
#endif

// GL_SUN_triangle_list
#ifdef GL_SUN_triangle_list
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUISUNPROC, glReplacementCodeuiSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUSSUNPROC, glReplacementCodeusSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUBSUNPROC, glReplacementCodeubSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUIVSUNPROC, glReplacementCodeuivSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUSVSUNPROC, glReplacementCodeusvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUBVSUNPROC, glReplacementCodeubvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEPOINTERSUNPROC, glReplacementCodePointerSUN )
#endif

// GL_SUN_vertex
#ifdef GL_SUN_vertex
VL_GL_FUNCTION( PFNGLCOLOR4UBVERTEX2FSUNPROC, glColor4ubVertex2fSUN )
VL_GL_FUNCTION( PFNGLCOLOR4UBVERTEX2FVSUNPROC, glColor4ubVertex2fvSUN )
VL_GL_FUNCTION( PFNGLCOLOR4UBVERTEX3FSUNPROC, glColor4ubVertex3fSUN )
VL_GL_FUNCTION( PFNGLCOLOR4UBVERTEX3FVSUNPROC, glColor4ubVertex3fvSUN )
VL_GL_FUNCTION( PFNGLCOLOR3FVERTEX3FSUNPROC, glColor3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLCOLOR3FVERTEX3FVSUNPROC, glColor3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLNORMAL3FVERTEX3FSUNPROC, glNormal3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLNORMAL3FVERTEX3FVSUNPROC, glNormal3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLCOLOR4FNORMAL3FVERTEX3FSUNPROC, glColor4fNormal3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLCOLOR4FNORMAL3FVERTEX3FVSUNPROC, glColor4fNormal3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FVERTEX3FSUNPROC, glTexCoord2fVertex3fSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FVERTEX3FVSUNPROC, glTexCoord2fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD4FVERTEX4FSUNPROC, glTexCoord4fVertex4fSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD4FVERTEX4FVSUNPROC, glTexCoord4fVertex4fvSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FCOLOR4UBVERTEX3FSUNPROC, glTexCoord2fColor4ubVertex3fSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FCOLOR4UBVERTEX3FVSUNPROC, glTexCoord2fColor4ubVertex3fvSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FCOLOR3FVERTEX3FSUNPROC, glTexCoord2fColor3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FCOLOR3FVERTEX3FVSUNPROC, glTexCoord2fColor3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FNORMAL3FVERTEX3FSUNPROC, glTexCoord2fNormal3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FNORMAL3FVERTEX3FVSUNPROC, glTexCoord2fNormal3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FCOLOR4FNORMAL3FVERTEX3FSUNPROC, glTexCoord2fColor4fNormal3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD2FCOLOR4FNORMAL3FVERTEX3FVSUNPROC, glTexCoord2fColor4fNormal3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD4FCOLOR4FNORMAL3FVERTEX4FSUNPROC, glTexCoord4fColor4fNormal3fVertex4fSUN )
VL_GL_FUNCTION( PFNGLTEXCOORD4FCOLOR4FNORMAL3FVERTEX4FVSUNPROC, glTexCoord4fColor4fNormal3fVertex4fvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUIVERTEX3FSUNPROC, glReplacementCodeuiVertex3fSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUIVERTEX3FVSUNPROC, glReplacementCodeuiVertex3fvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUICOLOR4UBVERTEX3FSUNPROC, glReplacementCodeuiColor4ubVertex3fSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUICOLOR4UBVERTEX3FVSUNPROC, glReplacementCodeuiColor4ubVertex3fvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUICOLOR3FVERTEX3FSUNPROC, glReplacementCodeuiColor3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUICOLOR3FVERTEX3FVSUNPROC, glReplacementCodeuiColor3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUINORMAL3FVERTEX3FSUNPROC, glReplacementCodeuiNormal3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUINORMAL3FVERTEX3FVSUNPROC, glReplacementCodeuiNormal3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUICOLOR4FNORMAL3FVERTEX3FSUNPROC, glReplacementCodeuiColor4fNormal3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUICOLOR4FNORMAL3FVERTEX3FVSUNPROC, glReplacementCodeuiColor4fNormal3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUITEXCOORD2FVERTEX3FSUNPROC, glReplacementCodeuiTexCoord2fVertex3fSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUITEXCOORD2FVERTEX3FVSUNPROC, glReplacementCodeuiTexCoord2fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUITEXCOORD2FNORMAL3FVERTEX3FSUNPROC, glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUITEXCOORD2FNORMAL3FVERTEX3FVSUNPROC, glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUITEXCOORD2FCOLOR4FNORMAL3FVERTEX3FSUNPROC, glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN )
VL_GL_FUNCTION( PFNGLREPLACEMENTCODEUITEXCOORD2FCOLOR4FNORMAL3FVERTEX3FVSUNPROC, glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN )
#endif

// GL_EXT_blend_func_separate
#ifdef GL_EXT_blend_func_separate
VL_GL_FUNCTION( PFNGLBLENDFUNCSEPARATEEXTPROC, glBlendFuncSeparateEXT )
#endif

// GL_INGR_blend_func_separate
#ifdef GL_INGR_blend_func_separate
VL_GL_FUNCTION( PFNGLBLENDFUNCSEPARATEINGRPROC, glBlendFuncSeparateINGR )
#endif

// GL_EXT_vertex_weighting
#ifdef GL_EXT_vertex_weighting
VL_GL_FUNCTION( PFNGLVERTEXWEIGHTFEXTPROC, glVertexWeightfEXT )
VL_GL_FUNCTION( PFNGLVERTEXWEIGHTFVEXTPROC, glVertexWeightfvEXT )
VL_GL_FUNCTION( PFNGLVERTEXWEIGHTPOINTEREXTPROC, glVertexWeightPointerEXT )
#endif

// GL_NV_vertex_array_range
#ifdef GL_NV_vertex_array_range
VL_GL_FUNCTION( PFNGLFLUSHVERTEXARRAYRANGENVPROC, glFlushVertexArrayRangeNV )
VL_GL_FUNCTION( PFNGLVERTEXARRAYRANGENVPROC, glVertexArrayRangeNV )
#endif

// GL_NV_register_combiners
#ifdef GL_NV_register_combiners
VL_GL_FUNCTION( PFNGLCOMBINERPARAMETERFVNVPROC, glCombinerParameterfvNV )
VL_GL_FUNCTION( PFNGLCOMBINERPARAMETERFNVPROC, glCombinerParameterfNV )
VL_GL_FUNCTION( PFNGLCOMBINERPARAMETERIVNVPROC, glCombinerParameterivNV )
VL_GL_FUNCTION( PFNGLCOMBINERPARAMETERINVPROC, glCombinerParameteriNV )
VL_GL_FUNCTION( PFNGLCOMBINERINPUTNVPROC, glCombinerInputNV )
VL_GL_FUNCTION( PFNGLCOMBINEROUTPUTNVPROC, glCombinerOutputNV )
VL_GL_FUNCTION( PFNGLFINALCOMBINERINPUTNVPROC, glFinalCombinerInputNV )
VL_GL_FUNCTION( PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC, glGetCombinerInputParameterfvNV )
VL_GL_FUNCTION( PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC, glGetCombinerInputParameterivNV )
VL_GL_FUNCTION( PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC, glGetCombinerOutputParameterfvNV )
VL_GL_FUNCTION( PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC, glGetCombinerOutputParameterivNV )
VL_GL_FUNCTION( PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC, glGetFinalCombinerInputParameterfvNV )
VL_GL_FUNCTION( PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC, glGetFinalCombinerInputParameterivNV )
#endif

// GL_MESA_resize_buffers
#ifdef GL_MESA_resize_buffers
VL_GL_FUNCTION( PFNGLRESIZEBUFFERSMESAPROC, glResizeBuffersMESA )
#endif

// GL_MESA_window_pos
#ifdef GL_MESA_window_pos
VL_GL_FUNCTION( PFNGLWINDOWPOS2DMESAPROC, glWindowPos2dMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS2DVMESAPROC, glWindowPos2dvMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS2FMESAPROC, glWindowPos2fMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS2FVMESAPROC, glWindowPos2fvMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS2IMESAPROC, glWindowPos2iMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS2IVMESAPROC, glWindowPos2ivMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS2SMESAPROC, glWindowPos2sMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS2SVMESAPROC, glWindowPos2svMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS3DMESAPROC, glWindowPos3dMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS3DVMESAPROC, glWindowPos3dvMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS3FMESAPROC, glWindowPos3fMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS3FVMESAPROC, glWindowPos3fvMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS3IMESAPROC, glWindowPos3iMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS3IVMESAPROC, glWindowPos3ivMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS3SMESAPROC, glWindowPos3sMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS3SVMESAPROC, glWindowPos3svMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS4DMESAPROC, glWindowPos4dMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS4DVMESAPROC, glWindowPos4dvMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS4FMESAPROC, glWindowPos4fMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS4FVMESAPROC, glWindowPos4fvMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS4IMESAPROC, glWindowPos4iMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS4IVMESAPROC, glWindowPos4ivMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS4SMESAPROC, glWindowPos4sMESA )
VL_GL_FUNCTION( PFNGLWINDOWPOS4SVMESAPROC, glWindowPos4svMESA )
#endif

// GL_IBM_multimode_draw_arrays
#ifdef GL_IBM_multimode_draw_arrays
VL_GL_FUNCTION( PFNGLMULTIMODEDRAWARRAYSIBMPROC, glMultiModeDrawArraysIBM )
VL_GL_FUNCTION( PFNGLMULTIMODEDRAWELEMENTSIBMPROC, glMultiModeDrawElementsIBM )
#endif

// GL_IBM_vertex_array_lists
#ifdef GL_IBM_vertex_array_lists
VL_GL_FUNCTION( PFNGLCOLORPOINTERLISTIBMPROC, glColorPointerListIBM )
VL_GL_FUNCTION( PFNGLSECONDARYCOLORPOINTERLISTIBMPROC, glSecondaryColorPointerListIBM )
VL_GL_FUNCTION( PFNGLEDGEFLAGPOINTERLISTIBMPROC, glEdgeFlagPointerListIBM )
VL_GL_FUNCTION( PFNGLFOGCOORDPOINTERLISTIBMPROC, glFogCoordPointerListIBM )
VL_GL_FUNCTION( PFNGLINDEXPOINTERLISTIBMPROC, glIndexPointerListIBM )
VL_GL_FUNCTION( PFNGLNORMALPOINTERLISTIBMPROC, glNormalPointerListIBM )
VL_GL_FUNCTION( PFNGLTEXCOORDPOINTERLISTIBMPROC, glTexCoordPointerListIBM )
VL_GL_FUNCTION( PFNGLVERTEXPOINTERLISTIBMPROC, glVertexPointerListIBM )
#endif

// GL_3DFX_tbuffer
#ifdef GL_3DFX_tbuffer
VL_GL_FUNCTION( PFNGLTBUFFERMASK3DFXPROC, glTbufferMask3DFX )
#endif

// GL_EXT_multisample
#ifdef GL_EXT_multisample
VL_GL_FUNCTION( PFNGLSAMPLEMASKEXTPROC, glSampleMaskEXT )
VL_GL_FUNCTION( PFNGLSAMPLEPATTERNEXTPROC, glSamplePatternEXT )
#endif

// GL_SGIS_texture_color_mask
#ifdef GL_SGIS_texture_color_mask
VL_GL_FUNCTION( PFNGLTEXTURECOLORMASKSGISPROC, glTextureColorMaskSGIS )
#endif

// GL_SGIX_igloo_interface
#ifdef GL_SGIX_igloo_interface
VL_GL_FUNCTION( PFNGLIGLOOINTERFACESGIXPROC, glIglooInterfaceSGIX )
#endif

// GL_NV_fence
#ifdef GL_NV_fence
VL_GL_FUNCTION( PFNGLDELETEFENCESNVPROC, glDeleteFencesNV )
VL_GL_FUNCTION( PFNGLGENFENCESNVPROC, glGenFencesNV )
VL_GL_FUNCTION( PFNGLISFENCENVPROC, glIsFenceNV )
VL_GL_FUNCTION( PFNGLTESTFENCENVPROC, glTestFenceNV )
VL_GL_FUNCTION( PFNGLGETFENCEIVNVPROC, glGetFenceivNV )
VL_GL_FUNCTION( PFNGLFINISHFENCENVPROC, glFinishFenceNV )
VL_GL_FUNCTION( PFNGLSETFENCENVPROC, glSetFenceNV )
#endif

// GL_NV_evaluators
#ifdef GL_NV_evaluators
VL_GL_FUNCTION( PFNGLMAPCONTROLPOINTSNVPROC, glMapControlPointsNV )
VL_GL_FUNCTION( PFNGLMAPPARAMETERIVNVPROC, glMapParameterivNV )
VL_GL_FUNCTION( PFNGLMAPPARAMETERFVNVPROC, glMapParameterfvNV )
VL_GL_FUNCTION( PFNGLGETMAPCONTROLPOINTSNVPROC, glGetMapControlPointsNV )
VL_GL_FUNCTION( PFNGLGETMAPPARAMETERIVNVPROC, glGetMapParameterivNV )
VL_GL_FUNCTION( PFNGLGETMAPPARAMETERFVNVPROC, glGetMapParameterfvNV )
VL_GL_FUNCTION( PFNGLGETMAPATTRIBPARAMETERIVNVPROC, glGetMapAttribParameterivNV )
VL_GL_FUNCTION( PFNGLGETMAPATTRIBPARAMETERFVNVPROC, glGetMapAttribParameterfvNV )
VL_GL_FUNCTION( PFNGLEVALMAPSNVPROC, glEvalMapsNV )
#endif

// GL_NV_register_combiners2
#ifdef GL_NV_register_combiners2
VL_GL_FUNCTION( PFNGLCOMBINERSTAGEPARAMETERFVNVPROC, glCombinerStageParameterfvNV )
VL_GL_FUNCTION( PFNGLGETCOMBINERSTAGEPARAMETERFVNVPROC, glGetCombinerStageParameterfvNV )
#endif

// GL_NV_vertex_program
#ifdef GL_NV_vertex_program
VL_GL_FUNCTION( PFNGLAREPROGRAMSRESIDENTNVPROC, glAreProgramsResidentNV )
VL_GL_FUNCTION( PFNGLBINDPROGRAMNVPROC, glBindProgramNV )
VL_GL_FUNCTION( PFNGLDELETEPROGRAMSNVPROC, glDeleteProgramsNV )
VL_GL_FUNCTION( PFNGLEXECUTEPROGRAMNVPROC, glExecuteProgramNV )
VL_GL_FUNCTION( PFNGLGENPROGRAMSNVPROC, glGenProgramsNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMPARAMETERDVNVPROC, glGetProgramParameterdvNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMPARAMETERFVNVPROC, glGetProgramParameterfvNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMIVNVPROC, glGetProgramivNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMSTRINGNVPROC, glGetProgramStringNV )
VL_GL_FUNCTION( PFNGLGETTRACKMATRIXIVNVPROC, glGetTrackMatrixivNV )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBDVNVPROC, glGetVertexAttribdvNV )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBFVNVPROC, glGetVertexAttribfvNV )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBIVNVPROC, glGetVertexAttribivNV )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBPOINTERVNVPROC, glGetVertexAttribPointervNV )
VL_GL_FUNCTION( PFNGLISPROGRAMNVPROC, glIsProgramNV )
VL_GL_FUNCTION( PFNGLLOADPROGRAMNVPROC, glLoadProgramNV )
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETER4DNVPROC, glProgramParameter4dNV )
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETER4DVNVPROC, glProgramParameter4dvNV )
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETER4FNVPROC, glProgramParameter4fNV )
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETER4FVNVPROC, glProgramParameter4fvNV )
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETERS4DVNVPROC, glProgramParameters4dvNV )
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETERS4FVNVPROC, glProgramParameters4fvNV )
VL_GL_FUNCTION( PFNGLREQUESTRESIDENTPROGRAMSNVPROC, glRequestResidentProgramsNV )
VL_GL_FUNCTION( PFNGLTRACKMATRIXNVPROC, glTrackMatrixNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBPOINTERNVPROC, glVertexAttribPointerNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1DNVPROC, glVertexAttrib1dNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1DVNVPROC, glVertexAttrib1dvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1FNVPROC, glVertexAttrib1fNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1FVNVPROC, glVertexAttrib1fvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1SNVPROC, glVertexAttrib1sNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1SVNVPROC, glVertexAttrib1svNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2DNVPROC, glVertexAttrib2dNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2DVNVPROC, glVertexAttrib2dvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2FNVPROC, glVertexAttrib2fNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2FVNVPROC, glVertexAttrib2fvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2SNVPROC, glVertexAttrib2sNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2SVNVPROC, glVertexAttrib2svNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3DNVPROC, glVertexAttrib3dNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3DVNVPROC, glVertexAttrib3dvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3FNVPROC, glVertexAttrib3fNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3FVNVPROC, glVertexAttrib3fvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3SNVPROC, glVertexAttrib3sNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3SVNVPROC, glVertexAttrib3svNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4DNVPROC, glVertexAttrib4dNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4DVNVPROC, glVertexAttrib4dvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4FNVPROC, glVertexAttrib4fNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4FVNVPROC, glVertexAttrib4fvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4SNVPROC, glVertexAttrib4sNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4SVNVPROC, glVertexAttrib4svNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4UBNVPROC, glVertexAttrib4ubNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4UBVNVPROC, glVertexAttrib4ubvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS1DVNVPROC, glVertexAttribs1dvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS1FVNVPROC, glVertexAttribs1fvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS1SVNVPROC, glVertexAttribs1svNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS2DVNVPROC, glVertexAttribs2dvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS2FVNVPROC, glVertexAttribs2fvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS2SVNVPROC, glVertexAttribs2svNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS3DVNVPROC, glVertexAttribs3dvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS3FVNVPROC, glVertexAttribs3fvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS3SVNVPROC, glVertexAttribs3svNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS4DVNVPROC, glVertexAttribs4dvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS4FVNVPROC, glVertexAttribs4fvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS4SVNVPROC, glVertexAttribs4svNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS4UBVNVPROC, glVertexAttribs4ubvNV )
#endif

// GL_ATI_envmap_bumpmap
#ifdef GL_ATI_envmap_bumpmap
VL_GL_FUNCTION( PFNGLTEXBUMPPARAMETERIVATIPROC, glTexBumpParameterivATI )
VL_GL_FUNCTION( PFNGLTEXBUMPPARAMETERFVATIPROC, glTexBumpParameterfvATI )
VL_GL_FUNCTION( PFNGLGETTEXBUMPPARAMETERIVATIPROC, glGetTexBumpParameterivATI )
VL_GL_FUNCTION( PFNGLGETTEXBUMPPARAMETERFVATIPROC, glGetTexBumpParameterfvATI )
#endif

// GL_ATI_fragment_shader
#ifdef GL_ATI_fragment_shader
VL_GL_FUNCTION( PFNGLGENFRAGMENTSHADERSATIPROC, glGenFragmentShadersATI )
VL_GL_FUNCTION( PFNGLBINDFRAGMENTSHADERATIPROC, glBindFragmentShaderATI )
VL_GL_FUNCTION( PFNGLDELETEFRAGMENTSHADERATIPROC, glDeleteFragmentShaderATI )
VL_GL_FUNCTION( PFNGLBEGINFRAGMENTSHADERATIPROC, glBeginFragmentShaderATI )
VL_GL_FUNCTION( PFNGLENDFRAGMENTSHADERATIPROC, glEndFragmentShaderATI )
VL_GL_FUNCTION( PFNGLPASSTEXCOORDATIPROC, glPassTexCoordATI )
VL_GL_FUNCTION( PFNGLSAMPLEMAPATIPROC, glSampleMapATI )
VL_GL_FUNCTION( PFNGLCOLORFRAGMENTOP1ATIPROC, glColorFragmentOp1ATI )
VL_GL_FUNCTION( PFNGLCOLORFRAGMENTOP2ATIPROC, glColorFragmentOp2ATI )
VL_GL_FUNCTION( PFNGLCOLORFRAGMENTOP3ATIPROC, glColorFragmentOp3ATI )
VL_GL_FUNCTION( PFNGLALPHAFRAGMENTOP1ATIPROC, glAlphaFragmentOp1ATI )
VL_GL_FUNCTION( PFNGLALPHAFRAGMENTOP2ATIPROC, glAlphaFragmentOp2ATI )
VL_GL_FUNCTION( PFNGLALPHAFRAGMENTOP3ATIPROC, glAlphaFragmentOp3ATI )
VL_GL_FUNCTION( PFNGLSETFRAGMENTSHADERCONSTANTATIPROC, glSetFragmentShaderConstantATI )
#endif

// GL_ATI_pn_triangles
#ifdef GL_ATI_pn_triangles
VL_GL_FUNCTION( PFNGLPNTRIANGLESIATIPROC, glPNTrianglesiATI )
VL_GL_FUNCTION( PFNGLPNTRIANGLESFATIPROC, glPNTrianglesfATI )
#endif

// GL_ATI_vertex_array_object
#ifdef GL_ATI_vertex_array_object
VL_GL_FUNCTION( PFNGLNEWOBJECTBUFFERATIPROC, glNewObjectBufferATI )
VL_GL_FUNCTION( PFNGLISOBJECTBUFFERATIPROC, glIsObjectBufferATI )
VL_GL_FUNCTION( PFNGLUPDATEOBJECTBUFFERATIPROC, glUpdateObjectBufferATI )
VL_GL_FUNCTION( PFNGLGETOBJECTBUFFERFVATIPROC, glGetObjectBufferfvATI )
VL_GL_FUNCTION( PFNGLGETOBJECTBUFFERIVATIPROC, glGetObjectBufferivATI )
VL_GL_FUNCTION( PFNGLFREEOBJECTBUFFERATIPROC, glFreeObjectBufferATI )
VL_GL_FUNCTION( PFNGLARRAYOBJECTATIPROC, glArrayObjectATI )
VL_GL_FUNCTION( PFNGLGETARRAYOBJECTFVATIPROC, glGetArrayObjectfvATI )
VL_GL_FUNCTION( PFNGLGETARRAYOBJECTIVATIPROC, glGetArrayObjectivATI )
VL_GL_FUNCTION( PFNGLVARIANTARRAYOBJECTATIPROC, glVariantArrayObjectATI )
VL_GL_FUNCTION( PFNGLGETVARIANTARRAYOBJECTFVATIPROC, glGetVariantArrayObjectfvATI )
VL_GL_FUNCTION( PFNGLGETVARIANTARRAYOBJECTIVATIPROC, glGetVariantArrayObjectivATI )
#endif

// GL_EXT_vertex_shader
#ifdef GL_EXT_vertex_shader
VL_GL_FUNCTION( PFNGLBEGINVERTEXSHADEREXTPROC, glBeginVertexShaderEXT )
VL_GL_FUNCTION( PFNGLENDVERTEXSHADEREXTPROC, glEndVertexShaderEXT )
VL_GL_FUNCTION( PFNGLBINDVERTEXSHADEREXTPROC, glBindVertexShaderEXT )
VL_GL_FUNCTION( PFNGLGENVERTEXSHADERSEXTPROC, glGenVertexShadersEXT )
VL_GL_FUNCTION( PFNGLDELETEVERTEXSHADEREXTPROC, glDeleteVertexShaderEXT )
VL_GL_FUNCTION( PFNGLSHADEROP1EXTPROC, glShaderOp1EXT )
VL_GL_FUNCTION( PFNGLSHADEROP2EXTPROC, glShaderOp2EXT )
VL_GL_FUNCTION( PFNGLSHADEROP3EXTPROC, glShaderOp3EXT )
VL_GL_FUNCTION( PFNGLSWIZZLEEXTPROC, glSwizzleEXT )
VL_GL_FUNCTION( PFNGLWRITEMASKEXTPROC, glWriteMaskEXT )
VL_GL_FUNCTION( PFNGLINSERTCOMPONENTEXTPROC, glInsertComponentEXT )
VL_GL_FUNCTION( PFNGLEXTRACTCOMPONENTEXTPROC, glExtractComponentEXT )
VL_GL_FUNCTION( PFNGLGENSYMBOLSEXTPROC, glGenSymbolsEXT )
VL_GL_FUNCTION( PFNGLSETINVARIANTEXTPROC, glSetInvariantEXT )
VL_GL_FUNCTION( PFNGLSETLOCALCONSTANTEXTPROC, glSetLocalConstantEXT )
VL_GL_FUNCTION( PFNGLVARIANTBVEXTPROC, glVariantbvEXT )
VL_GL_FUNCTION( PFNGLVARIANTSVEXTPROC, glVariantsvEXT )
VL_GL_FUNCTION( PFNGLVARIANTIVEXTPROC, glVariantivEXT )
VL_GL_FUNCTION( PFNGLVARIANTFVEXTPROC, glVariantfvEXT )
VL_GL_FUNCTION( PFNGLVARIANTDVEXTPROC, glVariantdvEXT )
VL_GL_FUNCTION( PFNGLVARIANTUBVEXTPROC, glVariantubvEXT )
VL_GL_FUNCTION( PFNGLVARIANTUSVEXTPROC, glVariantusvEXT )
VL_GL_FUNCTION( PFNGLVARIANTUIVEXTPROC, glVariantuivEXT )
VL_GL_FUNCTION( PFNGLVARIANTPOINTEREXTPROC, glVariantPointerEXT )
VL_GL_FUNCTION( PFNGLENABLEVARIANTCLIENTSTATEEXTPROC, glEnableVariantClientStateEXT )
VL_GL_FUNCTION( PFNGLDISABLEVARIANTCLIENTSTATEEXTPROC, glDisableVariantClientStateEXT )
VL_GL_FUNCTION( PFNGLBINDLIGHTPARAMETEREXTPROC, glBindLightParameterEXT )
VL_GL_FUNCTION( PFNGLBINDMATERIALPARAMETEREXTPROC, glBindMaterialParameterEXT )
VL_GL_FUNCTION( PFNGLBINDTEXGENPARAMETEREXTPROC, glBindTexGenParameterEXT )
VL_GL_FUNCTION( PFNGLBINDTEXTUREUNITPARAMETEREXTPROC, glBindTextureSamplerParameterEXT )
VL_GL_FUNCTION( PFNGLBINDPARAMETEREXTPROC, glBindParameterEXT )
VL_GL_FUNCTION( PFNGLISVARIANTENABLEDEXTPROC, glIsVariantEnabledEXT )
VL_GL_FUNCTION( PFNGLGETVARIANTBOOLEANVEXTPROC, glGetVariantBooleanvEXT )
VL_GL_FUNCTION( PFNGLGETVARIANTINTEGERVEXTPROC, glGetVariantIntegervEXT )
VL_GL_FUNCTION( PFNGLGETVARIANTFLOATVEXTPROC, glGetVariantFloatvEXT )
VL_GL_FUNCTION( PFNGLGETVARIANTPOINTERVEXTPROC, glGetVariantPointervEXT )
VL_GL_FUNCTION( PFNGLGETINVARIANTBOOLEANVEXTPROC, glGetInvariantBooleanvEXT )
VL_GL_FUNCTION( PFNGLGETINVARIANTINTEGERVEXTPROC, glGetInvariantIntegervEXT )
VL_GL_FUNCTION( PFNGLGETINVARIANTFLOATVEXTPROC, glGetInvariantFloatvEXT )
VL_GL_FUNCTION( PFNGLGETLOCALCONSTANTBOOLEANVEXTPROC, glGetLocalConstantBooleanvEXT )
VL_GL_FUNCTION( PFNGLGETLOCALCONSTANTINTEGERVEXTPROC, glGetLocalConstantIntegervEXT )
VL_GL_FUNCTION( PFNGLGETLOCALCONSTANTFLOATVEXTPROC, glGetLocalConstantFloatvEXT )
#endif

// GL_ATI_vertex_streams
#ifdef GL_ATI_vertex_streams
VL_GL_FUNCTION( PFNGLVERTEXSTREAM1SATIPROC, glVertexStream1sATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM1SVATIPROC, glVertexStream1svATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM1IATIPROC, glVertexStream1iATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM1IVATIPROC, glVertexStream1ivATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM1FATIPROC, glVertexStream1fATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM1FVATIPROC, glVertexStream1fvATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM1DATIPROC, glVertexStream1dATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM1DVATIPROC, glVertexStream1dvATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM2SATIPROC, glVertexStream2sATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM2SVATIPROC, glVertexStream2svATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM2IATIPROC, glVertexStream2iATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM2IVATIPROC, glVertexStream2ivATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM2FATIPROC, glVertexStream2fATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM2FVATIPROC, glVertexStream2fvATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM2DATIPROC, glVertexStream2dATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM2DVATIPROC, glVertexStream2dvATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM3SATIPROC, glVertexStream3sATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM3SVATIPROC, glVertexStream3svATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM3IATIPROC, glVertexStream3iATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM3IVATIPROC, glVertexStream3ivATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM3FATIPROC, glVertexStream3fATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM3FVATIPROC, glVertexStream3fvATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM3DATIPROC, glVertexStream3dATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM3DVATIPROC, glVertexStream3dvATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM4SATIPROC, glVertexStream4sATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM4SVATIPROC, glVertexStream4svATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM4IATIPROC, glVertexStream4iATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM4IVATIPROC, glVertexStream4ivATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM4FATIPROC, glVertexStream4fATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM4FVATIPROC, glVertexStream4fvATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM4DATIPROC, glVertexStream4dATI )
VL_GL_FUNCTION( PFNGLVERTEXSTREAM4DVATIPROC, glVertexStream4dvATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3BATIPROC, glNormalStream3bATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3BVATIPROC, glNormalStream3bvATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3SATIPROC, glNormalStream3sATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3SVATIPROC, glNormalStream3svATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3IATIPROC, glNormalStream3iATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3IVATIPROC, glNormalStream3ivATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3FATIPROC, glNormalStream3fATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3FVATIPROC, glNormalStream3fvATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3DATIPROC, glNormalStream3dATI )
VL_GL_FUNCTION( PFNGLNORMALSTREAM3DVATIPROC, glNormalStream3dvATI )
VL_GL_FUNCTION( PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC, glClientActiveVertexStreamATI )
VL_GL_FUNCTION( PFNGLVERTEXBLENDENVIATIPROC, glVertexBlendEnviATI )
VL_GL_FUNCTION( PFNGLVERTEXBLENDENVFATIPROC, glVertexBlendEnvfATI )
#endif

// GL_ATI_element_array
#ifdef GL_ATI_element_array
VL_GL_FUNCTION( PFNGLELEMENTPOINTERATIPROC, glElementPointerATI )
VL_GL_FUNCTION( PFNGLDRAWELEMENTARRAYATIPROC, glDrawElementArrayATI )
VL_GL_FUNCTION( PFNGLDRAWRANGEELEMENTARRAYATIPROC, glDrawRangeElementArrayATI )
#endif

// GL_SUN_mesh_array
#ifdef GL_SUN_mesh_array
VL_GL_FUNCTION( PFNGLDRAWMESHARRAYSSUNPROC, glDrawMeshArraysSUN )
#endif

// GL_NV_occlusion_query
#ifdef GL_NV_occlusion_query
VL_GL_FUNCTION( PFNGLGENOCCLUSIONQUERIESNVPROC, glGenOcclusionQueriesNV )
VL_GL_FUNCTION( PFNGLDELETEOCCLUSIONQUERIESNVPROC, glDeleteOcclusionQueriesNV )
VL_GL_FUNCTION( PFNGLISOCCLUSIONQUERYNVPROC, glIsOcclusionQueryNV )
VL_GL_FUNCTION( PFNGLBEGINOCCLUSIONQUERYNVPROC, glBeginOcclusionQueryNV )
VL_GL_FUNCTION( PFNGLENDOCCLUSIONQUERYNVPROC, glEndOcclusionQueryNV )
VL_GL_FUNCTION( PFNGLGETOCCLUSIONQUERYIVNVPROC, glGetOcclusionQueryivNV )
VL_GL_FUNCTION( PFNGLGETOCCLUSIONQUERYUIVNVPROC, glGetOcclusionQueryuivNV )
#endif

// GL_NV_point_sprite
#ifdef GL_NV_point_sprite
VL_GL_FUNCTION( PFNGLPOINTPARAMETERINVPROC, glPointParameteriNV )
VL_GL_FUNCTION( PFNGLPOINTPARAMETERIVNVPROC, glPointParameterivNV )
#endif

// GL_EXT_stencil_two_side
#ifdef GL_EXT_stencil_two_side
VL_GL_FUNCTION( PFNGLACTIVESTENCILFACEEXTPROC, glActiveStencilFaceEXT )
#endif

// GL_APPLE_element_array
#ifdef GL_APPLE_element_array
VL_GL_FUNCTION( PFNGLELEMENTPOINTERAPPLEPROC, glElementPointerAPPLE )
VL_GL_FUNCTION( PFNGLDRAWELEMENTARRAYAPPLEPROC, glDrawElementArrayAPPLE )
VL_GL_FUNCTION( PFNGLDRAWRANGEELEMENTARRAYAPPLEPROC, glDrawRangeElementArrayAPPLE )
VL_GL_FUNCTION( PFNGLMULTIDRAWELEMENTARRAYAPPLEPROC, glMultiDrawElementArrayAPPLE )
VL_GL_FUNCTION( PFNGLMULTIDRAWRANGEELEMENTARRAYAPPLEPROC, glMultiDrawRangeElementArrayAPPLE )
#endif

// GL_APPLE_fence
#ifdef GL_APPLE_fence
VL_GL_FUNCTION( PFNGLGENFENCESAPPLEPROC, glGenFencesAPPLE )
VL_GL_FUNCTION( PFNGLDELETEFENCESAPPLEPROC, glDeleteFencesAPPLE )
VL_GL_FUNCTION( PFNGLSETFENCEAPPLEPROC, glSetFenceAPPLE )
VL_GL_FUNCTION( PFNGLISFENCEAPPLEPROC, glIsFenceAPPLE )
VL_GL_FUNCTION( PFNGLTESTFENCEAPPLEPROC, glTestFenceAPPLE )
VL_GL_FUNCTION( PFNGLFINISHFENCEAPPLEPROC, glFinishFenceAPPLE )
VL_GL_FUNCTION( PFNGLTESTOBJECTAPPLEPROC, glTestObjectAPPLE )
VL_GL_FUNCTION( PFNGLFINISHOBJECTAPPLEPROC, glFinishObjectAPPLE )
#endif

// GL_APPLE_vertex_array_object
#ifdef GL_APPLE_vertex_array_object
VL_GL_FUNCTION( PFNGLBINDVERTEXARRAYAPPLEPROC, glBindVertexArrayAPPLE )
VL_GL_FUNCTION( PFNGLDELETEVERTEXARRAYSAPPLEPROC, glDeleteVertexArraysAPPLE )
VL_GL_FUNCTION( PFNGLGENVERTEXARRAYSAPPLEPROC, glGenVertexArraysAPPLE )
VL_GL_FUNCTION( PFNGLISVERTEXARRAYAPPLEPROC, glIsVertexArrayAPPLE )
#endif

// GL_APPLE_vertex_array_range
#ifdef GL_APPLE_vertex_array_range
VL_GL_FUNCTION( PFNGLVERTEXARRAYRANGEAPPLEPROC, glVertexArrayRangeAPPLE )
VL_GL_FUNCTION( PFNGLFLUSHVERTEXARRAYRANGEAPPLEPROC, glFlushVertexArrayRangeAPPLE )
VL_GL_FUNCTION( PFNGLVERTEXARRAYPARAMETERIAPPLEPROC, glVertexArrayParameteriAPPLE )
#endif

// GL_ATI_draw_buffers
#ifdef GL_ATI_draw_buffers
VL_GL_FUNCTION( PFNGLDRAWBUFFERSATIPROC, glDrawBuffersATI )
#endif

// GL_NV_fragment_program
#ifdef GL_NV_fragment_program
VL_GL_FUNCTION( PFNGLPROGRAMNAMEDPARAMETER4FNVPROC, glProgramNamedParameter4fNV )
VL_GL_FUNCTION( PFNGLPROGRAMNAMEDPARAMETER4DNVPROC, glProgramNamedParameter4dNV )
VL_GL_FUNCTION( PFNGLPROGRAMNAMEDPARAMETER4FVNVPROC, glProgramNamedParameter4fvNV )
VL_GL_FUNCTION( PFNGLPROGRAMNAMEDPARAMETER4DVNVPROC, glProgramNamedParameter4dvNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMNAMEDPARAMETERFVNVPROC, glGetProgramNamedParameterfvNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMNAMEDPARAMETERDVNVPROC, glGetProgramNamedParameterdvNV )
#endif

// GL_NV_half_float
#ifdef GL_NV_half_float
VL_GL_FUNCTION( PFNGLVERTEX2HNVPROC, glVertex2hNV )
VL_GL_FUNCTION( PFNGLVERTEX2HVNVPROC, glVertex2hvNV )
VL_GL_FUNCTION( PFNGLVERTEX3HNVPROC, glVertex3hNV )
VL_GL_FUNCTION( PFNGLVERTEX3HVNVPROC, glVertex3hvNV )
VL_GL_FUNCTION( PFNGLVERTEX4HNVPROC, glVertex4hNV )
VL_GL_FUNCTION( PFNGLVERTEX4HVNVPROC, glVertex4hvNV )
VL_GL_FUNCTION( PFNGLNORMAL3HNVPROC, glNormal3hNV )
VL_GL_FUNCTION( PFNGLNORMAL3HVNVPROC, glNormal3hvNV )
VL_GL_FUNCTION( PFNGLCOLOR3HNVPROC, glColor3hNV )
VL_GL_FUNCTION( PFNGLCOLOR3HVNVPROC, glColor3hvNV )
VL_GL_FUNCTION( PFNGLCOLOR4HNVPROC, glColor4hNV )
VL_GL_FUNCTION( PFNGLCOLOR4HVNVPROC, glColor4hvNV )
VL_GL_FUNCTION( PFNGLTEXCOORD1HNVPROC, glTexCoord1hNV )
VL_GL_FUNCTION( PFNGLTEXCOORD1HVNVPROC, glTexCoord1hvNV )
VL_GL_FUNCTION( PFNGLTEXCOORD2HNVPROC, glTexCoord2hNV )
VL_GL_FUNCTION( PFNGLTEXCOORD2HVNVPROC, glTexCoord2hvNV )
VL_GL_FUNCTION( PFNGLTEXCOORD3HNVPROC, glTexCoord3hNV )
VL_GL_FUNCTION( PFNGLTEXCOORD3HVNVPROC, glTexCoord3hvNV )
VL_GL_FUNCTION( PFNGLTEXCOORD4HNVPROC, glTexCoord4hNV )
VL_GL_FUNCTION( PFNGLTEXCOORD4HVNVPROC, glTexCoord4hvNV )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1HNVPROC, glMultiTexCoord1hNV )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD1HVNVPROC, glMultiTexCoord1hvNV )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2HNVPROC, glMultiTexCoord2hNV )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD2HVNVPROC, glMultiTexCoord2hvNV )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3HNVPROC, glMultiTexCoord3hNV )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD3HVNVPROC, glMultiTexCoord3hvNV )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4HNVPROC, glMultiTexCoord4hNV )
VL_GL_FUNCTION( PFNGLMULTITEXCOORD4HVNVPROC, glMultiTexCoord4hvNV )
VL_GL_FUNCTION( PFNGLFOGCOORDHNVPROC, glFogCoordhNV )
VL_GL_FUNCTION( PFNGLFOGCOORDHVNVPROC, glFogCoordhvNV )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3HNVPROC, glSecondaryColor3hNV )
VL_GL_FUNCTION( PFNGLSECONDARYCOLOR3HVNVPROC, glSecondaryColor3hvNV )
VL_GL_FUNCTION( PFNGLVERTEXWEIGHTHNVPROC, glVertexWeighthNV )
VL_GL_FUNCTION( PFNGLVERTEXWEIGHTHVNVPROC, glVertexWeighthvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1HNVPROC, glVertexAttrib1hNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB1HVNVPROC, glVertexAttrib1hvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2HNVPROC, glVertexAttrib2hNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB2HVNVPROC, glVertexAttrib2hvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3HNVPROC, glVertexAttrib3hNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB3HVNVPROC, glVertexAttrib3hvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4HNVPROC, glVertexAttrib4hNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIB4HVNVPROC, glVertexAttrib4hvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS1HVNVPROC, glVertexAttribs1hvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS2HVNVPROC, glVertexAttribs2hvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS3HVNVPROC, glVertexAttribs3hvNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBS4HVNVPROC, glVertexAttribs4hvNV )
#endif

// GL_NV_pixel_data_range
#ifdef GL_NV_pixel_data_range
VL_GL_FUNCTION( PFNGLPIXELDATARANGENVPROC, glPixelDataRangeNV )
VL_GL_FUNCTION( PFNGLFLUSHPIXELDATARANGENVPROC, glFlushPixelDataRangeNV )
#endif

// GL_NV_primitive_restart
#ifdef GL_NV_primitive_restart
VL_GL_FUNCTION( PFNGLPRIMITIVERESTARTNVPROC, glPrimitiveRestartNV )
VL_GL_FUNCTION( PFNGLPRIMITIVERESTARTINDEXNVPROC, glPrimitiveRestartIndexNV )
#endif

// GL_ATI_map_object_buffer
#ifdef GL_ATI_map_object_buffer
VL_GL_FUNCTION( PFNGLMAPOBJECTBUFFERATIPROC, glMapObjectBufferATI )
VL_GL_FUNCTION( PFNGLUNMAPOBJECTBUFFERATIPROC, glUnmapObjectBufferATI )
#endif

// GL_ATI_separate_stencil
#ifdef GL_ATI_separate_stencil
VL_GL_FUNCTION( PFNGLSTENCILOPSEPARATEATIPROC, glStencilOpSeparateATI )
VL_GL_FUNCTION( PFNGLSTENCILFUNCSEPARATEATIPROC, glStencilFuncSeparateATI )
#endif

// GL_ATI_vertex_attrib_array_object
#ifdef GL_ATI_vertex_attrib_array_object
VL_GL_FUNCTION( PFNGLVERTEXATTRIBARRAYOBJECTATIPROC, glVertexAttribArrayObjectATI )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBARRAYOBJECTFVATIPROC, glGetVertexAttribArrayObjectfvATI )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBARRAYOBJECTIVATIPROC, glGetVertexAttribArrayObjectivATI )
#endif

// GL_EXT_depth_bounds_test
#ifdef GL_EXT_depth_bounds_test
VL_GL_FUNCTION( PFNGLDEPTHBOUNDSEXTPROC, glDepthBoundsEXT )
#endif

// GL_EXT_blend_equation_separate
#ifdef GL_EXT_blend_equation_separate
VL_GL_FUNCTION( PFNGLBLENDEQUATIONSEPARATEEXTPROC, glBlendEquationSeparateEXT )
#endif

// GL_EXT_framebuffer_object
#ifdef GL_EXT_framebuffer_object
VL_GL_FUNCTION( PFNGLISRENDERBUFFEREXTPROC, glIsRenderbufferEXT )
VL_GL_FUNCTION( PFNGLBINDRENDERBUFFEREXTPROC, glBindRenderbufferEXT )
VL_GL_FUNCTION( PFNGLDELETERENDERBUFFERSEXTPROC, glDeleteRenderbuffersEXT )
VL_GL_FUNCTION( PFNGLGENRENDERBUFFERSEXTPROC, glGenRenderbuffersEXT )
VL_GL_FUNCTION( PFNGLRENDERBUFFERSTORAGEEXTPROC, glRenderbufferStorageEXT )
VL_GL_FUNCTION( PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC, glGetRenderbufferParameterivEXT )
VL_GL_FUNCTION( PFNGLISFRAMEBUFFEREXTPROC, glIsFramebufferEXT )
VL_GL_FUNCTION( PFNGLBINDFRAMEBUFFEREXTPROC, glBindFramebufferEXT )
VL_GL_FUNCTION( PFNGLDELETEFRAMEBUFFERSEXTPROC, glDeleteFramebuffersEXT )
VL_GL_FUNCTION( PFNGLGENFRAMEBUFFERSEXTPROC, glGenFramebuffersEXT )
VL_GL_FUNCTION( PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC, glCheckFramebufferStatusEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURE1DEXTPROC, glFramebufferTexture1DEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURE2DEXTPROC, glFramebufferTexture2DEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURE3DEXTPROC, glFramebufferTexture3DEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC, glFramebufferRenderbufferEXT )
VL_GL_FUNCTION( PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC, glGetFramebufferAttachmentParameterivEXT )
VL_GL_FUNCTION( PFNGLGENERATEMIPMAPEXTPROC, glGenerateMipmapEXT )
#endif

// GL_GREMEDY_string_marker
#ifdef GL_GREMEDY_string_marker
VL_GL_FUNCTION( PFNGLSTRINGMARKERGREMEDYPROC, glStringMarkerGREMEDY )
#endif

// GL_EXT_stencil_clear_tag
#ifdef GL_EXT_stencil_clear_tag
VL_GL_FUNCTION( PFNGLSTENCILCLEARTAGEXTPROC, glStencilClearTagEXT )
#endif

// GL_EXT_framebuffer_blit
#ifdef GL_EXT_framebuffer_blit
VL_GL_FUNCTION( PFNGLBLITFRAMEBUFFEREXTPROC, glBlitFramebufferEXT )
#endif

// GL_EXT_framebuffer_multisample
#ifdef GL_EXT_framebuffer_multisample
VL_GL_FUNCTION( PFNGLRENDERBUFFERSTORAGEMULTISAMPLEEXTPROC, glRenderbufferStorageMultisampleEXT )
#endif

// GL_EXT_timer_query
#ifdef GL_EXT_timer_query
VL_GL_FUNCTION( PFNGLGETQUERYOBJECTI64VEXTPROC, glGetQueryObjecti64vEXT )
VL_GL_FUNCTION( PFNGLGETQUERYOBJECTUI64VEXTPROC, glGetQueryObjectui64vEXT )
#endif

// GL_EXT_gpu_program_parameters
#ifdef GL_EXT_gpu_program_parameters
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETERS4FVEXTPROC, glProgramEnvParameters4fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETERS4FVEXTPROC, glProgramLocalParameters4fvEXT )
#endif

// GL_APPLE_flush_buffer_range
#ifdef GL_APPLE_flush_buffer_range
VL_GL_FUNCTION( PFNGLBUFFERPARAMETERIAPPLEPROC, glBufferParameteriAPPLE )
VL_GL_FUNCTION( PFNGLFLUSHMAPPEDBUFFERRANGEAPPLEPROC, glFlushMappedBufferRangeAPPLE )
#endif

// GL_NV_gpu_program4
#ifdef GL_NV_gpu_program4
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETERI4INVPROC, glProgramLocalParameterI4iNV )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETERI4IVNVPROC, glProgramLocalParameterI4ivNV )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETERSI4IVNVPROC, glProgramLocalParametersI4ivNV )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETERI4UINVPROC, glProgramLocalParameterI4uiNV )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETERI4UIVNVPROC, glProgramLocalParameterI4uivNV )
VL_GL_FUNCTION( PFNGLPROGRAMLOCALPARAMETERSI4UIVNVPROC, glProgramLocalParametersI4uivNV )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETERI4INVPROC, glProgramEnvParameterI4iNV )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETERI4IVNVPROC, glProgramEnvParameterI4ivNV )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETERSI4IVNVPROC, glProgramEnvParametersI4ivNV )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETERI4UINVPROC, glProgramEnvParameterI4uiNV )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETERI4UIVNVPROC, glProgramEnvParameterI4uivNV )
VL_GL_FUNCTION( PFNGLPROGRAMENVPARAMETERSI4UIVNVPROC, glProgramEnvParametersI4uivNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMLOCALPARAMETERIIVNVPROC, glGetProgramLocalParameterIivNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMLOCALPARAMETERIUIVNVPROC, glGetProgramLocalParameterIuivNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMENVPARAMETERIIVNVPROC, glGetProgramEnvParameterIivNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMENVPARAMETERIUIVNVPROC, glGetProgramEnvParameterIuivNV )
#endif

// GL_NV_geometry_program4
#ifdef GL_NV_geometry_program4
VL_GL_FUNCTION( PFNGLPROGRAMVERTEXLIMITNVPROC, glProgramVertexLimitNV )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTUREEXTPROC, glFramebufferTextureEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTURELAYEREXTPROC, glFramebufferTextureLayerEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERTEXTUREFACEEXTPROC, glFramebufferTextureFaceEXT )
#endif

// GL_EXT_geometry_shader4
#ifdef GL_EXT_geometry_shader4
VL_GL_FUNCTION( PFNGLPROGRAMPARAMETERIEXTPROC, glProgramParameteriEXT )
#endif

// GL_NV_vertex_program4
#ifdef GL_NV_vertex_program4
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI1IEXTPROC, glVertexAttribI1iEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI2IEXTPROC, glVertexAttribI2iEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI3IEXTPROC, glVertexAttribI3iEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4IEXTPROC, glVertexAttribI4iEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI1UIEXTPROC, glVertexAttribI1uiEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI2UIEXTPROC, glVertexAttribI2uiEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI3UIEXTPROC, glVertexAttribI3uiEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4UIEXTPROC, glVertexAttribI4uiEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI1IVEXTPROC, glVertexAttribI1ivEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI2IVEXTPROC, glVertexAttribI2ivEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI3IVEXTPROC, glVertexAttribI3ivEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4IVEXTPROC, glVertexAttribI4ivEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI1UIVEXTPROC, glVertexAttribI1uivEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI2UIVEXTPROC, glVertexAttribI2uivEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI3UIVEXTPROC, glVertexAttribI3uivEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4UIVEXTPROC, glVertexAttribI4uivEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4BVEXTPROC, glVertexAttribI4bvEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4SVEXTPROC, glVertexAttribI4svEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4UBVEXTPROC, glVertexAttribI4ubvEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBI4USVEXTPROC, glVertexAttribI4usvEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBIPOINTEREXTPROC, glVertexAttribIPointerEXT )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBIIVEXTPROC, glGetVertexAttribIivEXT )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBIUIVEXTPROC, glGetVertexAttribIuivEXT )
#endif

// GL_EXT_gpu_shader4
#ifdef GL_EXT_gpu_shader4
VL_GL_FUNCTION( PFNGLGETUNIFORMUIVEXTPROC, glGetUniformuivEXT )
VL_GL_FUNCTION( PFNGLBINDFRAGDATALOCATIONEXTPROC, glBindFragDataLocationEXT )
VL_GL_FUNCTION( PFNGLGETFRAGDATALOCATIONEXTPROC, glGetFragDataLocationEXT )
VL_GL_FUNCTION( PFNGLUNIFORM1UIEXTPROC, glUniform1uiEXT )
VL_GL_FUNCTION( PFNGLUNIFORM2UIEXTPROC, glUniform2uiEXT )
VL_GL_FUNCTION( PFNGLUNIFORM3UIEXTPROC, glUniform3uiEXT )
VL_GL_FUNCTION( PFNGLUNIFORM4UIEXTPROC, glUniform4uiEXT )
VL_GL_FUNCTION( PFNGLUNIFORM1UIVEXTPROC, glUniform1uivEXT )
VL_GL_FUNCTION( PFNGLUNIFORM2UIVEXTPROC, glUniform2uivEXT )
VL_GL_FUNCTION( PFNGLUNIFORM3UIVEXTPROC, glUniform3uivEXT )
VL_GL_FUNCTION( PFNGLUNIFORM4UIVEXTPROC, glUniform4uivEXT )
#endif

// GL_EXT_draw_instanced
#ifdef GL_EXT_draw_instanced
VL_GL_FUNCTION( PFNGLDRAWARRAYSINSTANCEDEXTPROC, glDrawArraysInstancedEXT )
VL_GL_FUNCTION( PFNGLDRAWELEMENTSINSTANCEDEXTPROC, glDrawElementsInstancedEXT )
#endif

// GL_EXT_texture_buffer_object
#ifdef GL_EXT_texture_buffer_object
VL_GL_FUNCTION( PFNGLTEXBUFFEREXTPROC, glTexBufferEXT )
#endif

// GL_NV_depth_buffer_float
#ifdef GL_NV_depth_buffer_float
VL_GL_FUNCTION( PFNGLDEPTHRANGEDNVPROC, glDepthRangedNV )
VL_GL_FUNCTION( PFNGLCLEARDEPTHDNVPROC, glClearDepthdNV )
VL_GL_FUNCTION( PFNGLDEPTHBOUNDSDNVPROC, glDepthBoundsdNV )
#endif

// GL_NV_framebuffer_multisample_coverage
#ifdef GL_NV_framebuffer_multisample_coverage
VL_GL_FUNCTION( PFNGLRENDERBUFFERSTORAGEMULTISAMPLECOVERAGENVPROC, glRenderbufferStorageMultisampleCoverageNV )
#endif

// GL_NV_parameter_buffer_object
#ifdef GL_NV_parameter_buffer_object
VL_GL_FUNCTION( PFNGLPROGRAMBUFFERPARAMETERSFVNVPROC, glProgramBufferParametersfvNV )
VL_GL_FUNCTION( PFNGLPROGRAMBUFFERPARAMETERSIIVNVPROC, glProgramBufferParametersIivNV )
VL_GL_FUNCTION( PFNGLPROGRAMBUFFERPARAMETERSIUIVNVPROC, glProgramBufferParametersIuivNV )
#endif

// GL_EXT_draw_buffers2
#ifdef GL_EXT_draw_buffers2
VL_GL_FUNCTION( PFNGLCOLORMASKINDEXEDEXTPROC, glColorMaskIndexedEXT )
VL_GL_FUNCTION( PFNGLGETBOOLEANINDEXEDVEXTPROC, glGetBooleanIndexedvEXT )
VL_GL_FUNCTION( PFNGLGETINTEGERINDEXEDVEXTPROC, glGetIntegerIndexedvEXT )
VL_GL_FUNCTION( PFNGLENABLEINDEXEDEXTPROC, glEnableIndexedEXT )
VL_GL_FUNCTION( PFNGLDISABLEINDEXEDEXTPROC, glDisableIndexedEXT )
VL_GL_FUNCTION( PFNGLISENABLEDINDEXEDEXTPROC, glIsEnabledIndexedEXT )
#endif

// GL_NV_transform_feedback
#ifdef GL_NV_transform_feedback
VL_GL_FUNCTION( PFNGLBEGINTRANSFORMFEEDBACKNVPROC, glBeginTransformFeedbackNV )
VL_GL_FUNCTION( PFNGLENDTRANSFORMFEEDBACKNVPROC, glEndTransformFeedbackNV )
VL_GL_FUNCTION( PFNGLTRANSFORMFEEDBACKATTRIBSNVPROC, glTransformFeedbackAttribsNV )
VL_GL_FUNCTION( PFNGLBINDBUFFERRANGENVPROC, glBindBufferRangeNV )
VL_GL_FUNCTION( PFNGLBINDBUFFEROFFSETNVPROC, glBindBufferOffsetNV )
VL_GL_FUNCTION( PFNGLBINDBUFFERBASENVPROC, glBindBufferBaseNV )
VL_GL_FUNCTION( PFNGLTRANSFORMFEEDBACKVARYINGSNVPROC, glTransformFeedbackVaryingsNV )
VL_GL_FUNCTION( PFNGLACTIVEVARYINGNVPROC, glActiveVaryingNV )
VL_GL_FUNCTION( PFNGLGETVARYINGLOCATIONNVPROC, glGetVaryingLocationNV )
VL_GL_FUNCTION( PFNGLGETACTIVEVARYINGNVPROC, glGetActiveVaryingNV )
VL_GL_FUNCTION( PFNGLGETTRANSFORMFEEDBACKVARYINGNVPROC, glGetTransformFeedbackVaryingNV )
VL_GL_FUNCTION( PFNGLTRANSFORMFEEDBACKSTREAMATTRIBSNVPROC, glTransformFeedbackStreamAttribsNV )
#endif

// GL_EXT_bindable_uniform
#ifdef GL_EXT_bindable_uniform
VL_GL_FUNCTION( PFNGLUNIFORMBUFFEREXTPROC, glUniformBufferEXT )
VL_GL_FUNCTION( PFNGLGETUNIFORMBUFFERSIZEEXTPROC, glGetUniformBufferSizeEXT )
VL_GL_FUNCTION( PFNGLGETUNIFORMOFFSETEXTPROC, glGetUniformOffsetEXT )
#endif

// GL_EXT_texture_integer
#ifdef GL_EXT_texture_integer
VL_GL_FUNCTION( PFNGLTEXPARAMETERIIVEXTPROC, glTexParameterIivEXT )
VL_GL_FUNCTION( PFNGLTEXPARAMETERIUIVEXTPROC, glTexParameterIuivEXT )
VL_GL_FUNCTION( PFNGLGETTEXPARAMETERIIVEXTPROC, glGetTexParameterIivEXT )
VL_GL_FUNCTION( PFNGLGETTEXPARAMETERIUIVEXTPROC, glGetTexParameterIuivEXT )
VL_GL_FUNCTION( PFNGLCLEARCOLORIIEXTPROC, glClearColorIiEXT )
VL_GL_FUNCTION( PFNGLCLEARCOLORIUIEXTPROC, glClearColorIuiEXT )
#endif

// GL_GREMEDY_frame_terminator
#ifdef GL_GREMEDY_frame_terminator
VL_GL_FUNCTION( PFNGLFRAMETERMINATORGREMEDYPROC, glFrameTerminatorGREMEDY )
#endif

// GL_NV_conditional_render
#ifdef GL_NV_conditional_render
VL_GL_FUNCTION( PFNGLBEGINCONDITIONALRENDERNVPROC, glBeginConditionalRenderNV )
VL_GL_FUNCTION( PFNGLENDCONDITIONALRENDERNVPROC, glEndConditionalRenderNV )
#endif

// GL_NV_present_video
#ifdef GL_NV_present_video
VL_GL_FUNCTION( PFNGLPRESENTFRAMEKEYEDNVPROC, glPresentFrameKeyedNV )
VL_GL_FUNCTION( PFNGLPRESENTFRAMEDUALFILLNVPROC, glPresentFrameDualFillNV )
VL_GL_FUNCTION( PFNGLGETVIDEOIVNVPROC, glGetVideoivNV )
VL_GL_FUNCTION( PFNGLGETVIDEOUIVNVPROC, glGetVideouivNV )
VL_GL_FUNCTION( PFNGLGETVIDEOI64VNVPROC, glGetVideoi64vNV )
VL_GL_FUNCTION( PFNGLGETVIDEOUI64VNVPROC, glGetVideoui64vNV )
#endif

// GL_EXT_transform_feedback
#ifdef GL_EXT_transform_feedback
VL_GL_FUNCTION( PFNGLBEGINTRANSFORMFEEDBACKEXTPROC, glBeginTransformFeedbackEXT )
VL_GL_FUNCTION( PFNGLENDTRANSFORMFEEDBACKEXTPROC, glEndTransformFeedbackEXT )
VL_GL_FUNCTION( PFNGLBINDBUFFERRANGEEXTPROC, glBindBufferRangeEXT )
VL_GL_FUNCTION( PFNGLBINDBUFFEROFFSETEXTPROC, glBindBufferOffsetEXT )
VL_GL_FUNCTION( PFNGLBINDBUFFERBASEEXTPROC, glBindBufferBaseEXT )
VL_GL_FUNCTION( PFNGLTRANSFORMFEEDBACKVARYINGSEXTPROC, glTransformFeedbackVaryingsEXT )
VL_GL_FUNCTION( PFNGLGETTRANSFORMFEEDBACKVARYINGEXTPROC, glGetTransformFeedbackVaryingEXT )
#endif

// GL_EXT_direct_state_access
#ifdef GL_EXT_direct_state_access
VL_GL_FUNCTION( PFNGLCLIENTATTRIBDEFAULTEXTPROC, glClientAttribDefaultEXT )
VL_GL_FUNCTION( PFNGLPUSHCLIENTATTRIBDEFAULTEXTPROC, glPushClientAttribDefaultEXT )
VL_GL_FUNCTION( PFNGLMATRIXLOADFEXTPROC, glMatrixLoadfEXT )
VL_GL_FUNCTION( PFNGLMATRIXLOADDEXTPROC, glMatrixLoaddEXT )
VL_GL_FUNCTION( PFNGLMATRIXMULTFEXTPROC, glMatrixMultfEXT )
VL_GL_FUNCTION( PFNGLMATRIXMULTDEXTPROC, glMatrixMultdEXT )
VL_GL_FUNCTION( PFNGLMATRIXLOADIDENTITYEXTPROC, glMatrixLoadIdentityEXT )
VL_GL_FUNCTION( PFNGLMATRIXROTATEFEXTPROC, glMatrixRotatefEXT )
VL_GL_FUNCTION( PFNGLMATRIXROTATEDEXTPROC, glMatrixRotatedEXT )
VL_GL_FUNCTION( PFNGLMATRIXSCALEFEXTPROC, glMatrixScalefEXT )
VL_GL_FUNCTION( PFNGLMATRIXSCALEDEXTPROC, glMatrixScaledEXT )
VL_GL_FUNCTION( PFNGLMATRIXTRANSLATEFEXTPROC, glMatrixTranslatefEXT )
VL_GL_FUNCTION( PFNGLMATRIXTRANSLATEDEXTPROC, glMatrixTranslatedEXT )
VL_GL_FUNCTION( PFNGLMATRIXFRUSTUMEXTPROC, glMatrixFrustumEXT )
VL_GL_FUNCTION( PFNGLMATRIXORTHOEXTPROC, glMatrixOrthoEXT )
VL_GL_FUNCTION( PFNGLMATRIXPOPEXTPROC, glMatrixPopEXT )
VL_GL_FUNCTION( PFNGLMATRIXPUSHEXTPROC, glMatrixPushEXT )
VL_GL_FUNCTION( PFNGLMATRIXLOADTRANSPOSEFEXTPROC, glMatrixLoadTransposefEXT )
VL_GL_FUNCTION( PFNGLMATRIXLOADTRANSPOSEDEXTPROC, glMatrixLoadTransposedEXT )
VL_GL_FUNCTION( PFNGLMATRIXMULTTRANSPOSEFEXTPROC, glMatrixMultTransposefEXT )
VL_GL_FUNCTION( PFNGLMATRIXMULTTRANSPOSEDEXTPROC, glMatrixMultTransposedEXT )
VL_GL_FUNCTION( PFNGLTEXTUREPARAMETERFEXTPROC, glTextureParameterfEXT )
VL_GL_FUNCTION( PFNGLTEXTUREPARAMETERFVEXTPROC, glTextureParameterfvEXT )
VL_GL_FUNCTION( PFNGLTEXTUREPARAMETERIEXTPROC, glTextureParameteriEXT )
VL_GL_FUNCTION( PFNGLTEXTUREPARAMETERIVEXTPROC, glTextureParameterivEXT )
VL_GL_FUNCTION( PFNGLTEXTUREIMAGE1DEXTPROC, glTextureImage1DEXT )
VL_GL_FUNCTION( PFNGLTEXTUREIMAGE2DEXTPROC, glTextureImage2DEXT )
VL_GL_FUNCTION( PFNGLTEXTURESUBIMAGE1DEXTPROC, glTextureSubImage1DEXT )
VL_GL_FUNCTION( PFNGLTEXTURESUBIMAGE2DEXTPROC, glTextureSubImage2DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXTUREIMAGE1DEXTPROC, glCopyTextureImage1DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXTUREIMAGE2DEXTPROC, glCopyTextureImage2DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXTURESUBIMAGE1DEXTPROC, glCopyTextureSubImage1DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXTURESUBIMAGE2DEXTPROC, glCopyTextureSubImage2DEXT )
VL_GL_FUNCTION( PFNGLGETTEXTUREIMAGEEXTPROC, glGetTextureImageEXT )
VL_GL_FUNCTION( PFNGLGETTEXTUREPARAMETERFVEXTPROC, glGetTextureParameterfvEXT )
VL_GL_FUNCTION( PFNGLGETTEXTUREPARAMETERIVEXTPROC, glGetTextureParameterivEXT )
VL_GL_FUNCTION( PFNGLGETTEXTURELEVELPARAMETERFVEXTPROC, glGetTextureLevelParameterfvEXT )
VL_GL_FUNCTION( PFNGLGETTEXTURELEVELPARAMETERIVEXTPROC, glGetTextureLevelParameterivEXT )
VL_GL_FUNCTION( PFNGLTEXTUREIMAGE3DEXTPROC, glTextureImage3DEXT )
VL_GL_FUNCTION( PFNGLTEXTURESUBIMAGE3DEXTPROC, glTextureSubImage3DEXT )
VL_GL_FUNCTION( PFNGLCOPYTEXTURESUBIMAGE3DEXTPROC, glCopyTextureSubImage3DEXT )
VL_GL_FUNCTION( PFNGLMULTITEXPARAMETERFEXTPROC, glMultiTexParameterfEXT )
VL_GL_FUNCTION( PFNGLMULTITEXPARAMETERFVEXTPROC, glMultiTexParameterfvEXT )
VL_GL_FUNCTION( PFNGLMULTITEXPARAMETERIEXTPROC, glMultiTexParameteriEXT )
VL_GL_FUNCTION( PFNGLMULTITEXPARAMETERIVEXTPROC, glMultiTexParameterivEXT )
VL_GL_FUNCTION( PFNGLMULTITEXIMAGE1DEXTPROC, glMultiTexImage1DEXT )
VL_GL_FUNCTION( PFNGLMULTITEXIMAGE2DEXTPROC, glMultiTexImage2DEXT )
VL_GL_FUNCTION( PFNGLMULTITEXSUBIMAGE1DEXTPROC, glMultiTexSubImage1DEXT )
VL_GL_FUNCTION( PFNGLMULTITEXSUBIMAGE2DEXTPROC, glMultiTexSubImage2DEXT )
VL_GL_FUNCTION( PFNGLCOPYMULTITEXIMAGE1DEXTPROC, glCopyMultiTexImage1DEXT )
VL_GL_FUNCTION( PFNGLCOPYMULTITEXIMAGE2DEXTPROC, glCopyMultiTexImage2DEXT )
VL_GL_FUNCTION( PFNGLCOPYMULTITEXSUBIMAGE1DEXTPROC, glCopyMultiTexSubImage1DEXT )
VL_GL_FUNCTION( PFNGLCOPYMULTITEXSUBIMAGE2DEXTPROC, glCopyMultiTexSubImage2DEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXIMAGEEXTPROC, glGetMultiTexImageEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXPARAMETERFVEXTPROC, glGetMultiTexParameterfvEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXPARAMETERIVEXTPROC, glGetMultiTexParameterivEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXLEVELPARAMETERFVEXTPROC, glGetMultiTexLevelParameterfvEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXLEVELPARAMETERIVEXTPROC, glGetMultiTexLevelParameterivEXT )
VL_GL_FUNCTION( PFNGLMULTITEXIMAGE3DEXTPROC, glMultiTexImage3DEXT )
VL_GL_FUNCTION( PFNGLMULTITEXSUBIMAGE3DEXTPROC, glMultiTexSubImage3DEXT )
VL_GL_FUNCTION( PFNGLCOPYMULTITEXSUBIMAGE3DEXTPROC, glCopyMultiTexSubImage3DEXT )
VL_GL_FUNCTION( PFNGLBINDMULTITEXTUREEXTPROC, glBindMultiTextureEXT )
VL_GL_FUNCTION( PFNGLENABLECLIENTSTATEINDEXEDEXTPROC, glEnableClientStateIndexedEXT )
VL_GL_FUNCTION( PFNGLDISABLECLIENTSTATEINDEXEDEXTPROC, glDisableClientStateIndexedEXT )
VL_GL_FUNCTION( PFNGLMULTITEXCOORDPOINTEREXTPROC, glMultiTexCoordPointerEXT )
VL_GL_FUNCTION( PFNGLMULTITEXENVFEXTPROC, glMultiTexEnvfEXT )
VL_GL_FUNCTION( PFNGLMULTITEXENVFVEXTPROC, glMultiTexEnvfvEXT )
VL_GL_FUNCTION( PFNGLMULTITEXENVIEXTPROC, glMultiTexEnviEXT )
VL_GL_FUNCTION( PFNGLMULTITEXENVIVEXTPROC, glMultiTexEnvivEXT )
VL_GL_FUNCTION( PFNGLMULTITEXGENDEXTPROC, glMultiTexGendEXT )
VL_GL_FUNCTION( PFNGLMULTITEXGENDVEXTPROC, glMultiTexGendvEXT )
VL_GL_FUNCTION( PFNGLMULTITEXGENFEXTPROC, glMultiTexGenfEXT )
VL_GL_FUNCTION( PFNGLMULTITEXGENFVEXTPROC, glMultiTexGenfvEXT )
VL_GL_FUNCTION( PFNGLMULTITEXGENIEXTPROC, glMultiTexGeniEXT )
VL_GL_FUNCTION( PFNGLMULTITEXGENIVEXTPROC, glMultiTexGenivEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXENVFVEXTPROC, glGetMultiTexEnvfvEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXENVIVEXTPROC, glGetMultiTexEnvivEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXGENDVEXTPROC, glGetMultiTexGendvEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXGENFVEXTPROC, glGetMultiTexGenfvEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXGENIVEXTPROC, glGetMultiTexGenivEXT )
VL_GL_FUNCTION( PFNGLGETFLOATINDEXEDVEXTPROC, glGetFloatIndexedvEXT )
VL_GL_FUNCTION( PFNGLGETDOUBLEINDEXEDVEXTPROC, glGetDoubleIndexedvEXT )
VL_GL_FUNCTION( PFNGLGETPOINTERINDEXEDVEXTPROC, glGetPointerIndexedvEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXTUREIMAGE3DEXTPROC, glCompressedTextureImage3DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXTUREIMAGE2DEXTPROC, glCompressedTextureImage2DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXTUREIMAGE1DEXTPROC, glCompressedTextureImage1DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXTURESUBIMAGE3DEXTPROC, glCompressedTextureSubImage3DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXTURESUBIMAGE2DEXTPROC, glCompressedTextureSubImage2DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDTEXTURESUBIMAGE1DEXTPROC, glCompressedTextureSubImage1DEXT )
VL_GL_FUNCTION( PFNGLGETCOMPRESSEDTEXTUREIMAGEEXTPROC, glGetCompressedTextureImageEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDMULTITEXIMAGE3DEXTPROC, glCompressedMultiTexImage3DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDMULTITEXIMAGE2DEXTPROC, glCompressedMultiTexImage2DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDMULTITEXIMAGE1DEXTPROC, glCompressedMultiTexImage1DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDMULTITEXSUBIMAGE3DEXTPROC, glCompressedMultiTexSubImage3DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDMULTITEXSUBIMAGE2DEXTPROC, glCompressedMultiTexSubImage2DEXT )
VL_GL_FUNCTION( PFNGLCOMPRESSEDMULTITEXSUBIMAGE1DEXTPROC, glCompressedMultiTexSubImage1DEXT )
VL_GL_FUNCTION( PFNGLGETCOMPRESSEDMULTITEXIMAGEEXTPROC, glGetCompressedMultiTexImageEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMSTRINGEXTPROC, glNamedProgramStringEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETER4DEXTPROC, glNamedProgramLocalParameter4dEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETER4DVEXTPROC, glNamedProgramLocalParameter4dvEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETER4FEXTPROC, glNamedProgramLocalParameter4fEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETER4FVEXTPROC, glNamedProgramLocalParameter4fvEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDPROGRAMLOCALPARAMETERDVEXTPROC, glGetNamedProgramLocalParameterdvEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDPROGRAMLOCALPARAMETERFVEXTPROC, glGetNamedProgramLocalParameterfvEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDPROGRAMIVEXTPROC, glGetNamedProgramivEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDPROGRAMSTRINGEXTPROC, glGetNamedProgramStringEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETERS4FVEXTPROC, glNamedProgramLocalParameters4fvEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETERI4IEXTPROC, glNamedProgramLocalParameterI4iEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETERI4IVEXTPROC, glNamedProgramLocalParameterI4ivEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETERSI4IVEXTPROC, glNamedProgramLocalParametersI4ivEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETERI4UIEXTPROC, glNamedProgramLocalParameterI4uiEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETERI4UIVEXTPROC, glNamedProgramLocalParameterI4uivEXT )
VL_GL_FUNCTION( PFNGLNAMEDPROGRAMLOCALPARAMETERSI4UIVEXTPROC, glNamedProgramLocalParametersI4uivEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDPROGRAMLOCALPARAMETERIIVEXTPROC, glGetNamedProgramLocalParameterIivEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDPROGRAMLOCALPARAMETERIUIVEXTPROC, glGetNamedProgramLocalParameterIuivEXT )
VL_GL_FUNCTION( PFNGLTEXTUREPARAMETERIIVEXTPROC, glTextureParameterIivEXT )
VL_GL_FUNCTION( PFNGLTEXTUREPARAMETERIUIVEXTPROC, glTextureParameterIuivEXT )
VL_GL_FUNCTION( PFNGLGETTEXTUREPARAMETERIIVEXTPROC, glGetTextureParameterIivEXT )
VL_GL_FUNCTION( PFNGLGETTEXTUREPARAMETERIUIVEXTPROC, glGetTextureParameterIuivEXT )
VL_GL_FUNCTION( PFNGLMULTITEXPARAMETERIIVEXTPROC, glMultiTexParameterIivEXT )
VL_GL_FUNCTION( PFNGLMULTITEXPARAMETERIUIVEXTPROC, glMultiTexParameterIuivEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXPARAMETERIIVEXTPROC, glGetMultiTexParameterIivEXT )
VL_GL_FUNCTION( PFNGLGETMULTITEXPARAMETERIUIVEXTPROC, glGetMultiTexParameterIuivEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1FEXTPROC, glProgramUniform1fEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2FEXTPROC, glProgramUniform2fEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3FEXTPROC, glProgramUniform3fEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4FEXTPROC, glProgramUniform4fEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1IEXTPROC, glProgramUniform1iEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2IEXTPROC, glProgramUniform2iEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3IEXTPROC, glProgramUniform3iEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4IEXTPROC, glProgramUniform4iEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1FVEXTPROC, glProgramUniform1fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2FVEXTPROC, glProgramUniform2fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3FVEXTPROC, glProgramUniform3fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4FVEXTPROC, glProgramUniform4fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1IVEXTPROC, glProgramUniform1ivEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2IVEXTPROC, glProgramUniform2ivEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3IVEXTPROC, glProgramUniform3ivEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4IVEXTPROC, glProgramUniform4ivEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2FVEXTPROC, glProgramUniformMatrix2fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3FVEXTPROC, glProgramUniformMatrix3fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4FVEXTPROC, glProgramUniformMatrix4fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2X3FVEXTPROC, glProgramUniformMatrix2x3fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3X2FVEXTPROC, glProgramUniformMatrix3x2fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2X4FVEXTPROC, glProgramUniformMatrix2x4fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4X2FVEXTPROC, glProgramUniformMatrix4x2fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3X4FVEXTPROC, glProgramUniformMatrix3x4fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4X3FVEXTPROC, glProgramUniformMatrix4x3fvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1UIEXTPROC, glProgramUniform1uiEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2UIEXTPROC, glProgramUniform2uiEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3UIEXTPROC, glProgramUniform3uiEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4UIEXTPROC, glProgramUniform4uiEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1UIVEXTPROC, glProgramUniform1uivEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2UIVEXTPROC, glProgramUniform2uivEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3UIVEXTPROC, glProgramUniform3uivEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4UIVEXTPROC, glProgramUniform4uivEXT )
VL_GL_FUNCTION( PFNGLNAMEDBUFFERDATAEXTPROC, glNamedBufferDataEXT )
VL_GL_FUNCTION( PFNGLNAMEDBUFFERSUBDATAEXTPROC, glNamedBufferSubDataEXT )
VL_GL_FUNCTION( PFNGLMAPNAMEDBUFFEREXTPROC, glMapNamedBufferEXT )
VL_GL_FUNCTION( PFNGLUNMAPNAMEDBUFFEREXTPROC, glUnmapNamedBufferEXT )
VL_GL_FUNCTION( PFNGLMAPNAMEDBUFFERRANGEEXTPROC, glMapNamedBufferRangeEXT )
VL_GL_FUNCTION( PFNGLFLUSHMAPPEDNAMEDBUFFERRANGEEXTPROC, glFlushMappedNamedBufferRangeEXT )
VL_GL_FUNCTION( PFNGLNAMEDCOPYBUFFERSUBDATAEXTPROC, glNamedCopyBufferSubDataEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDBUFFERPARAMETERIVEXTPROC, glGetNamedBufferParameterivEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDBUFFERPOINTERVEXTPROC, glGetNamedBufferPointervEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDBUFFERSUBDATAEXTPROC, glGetNamedBufferSubDataEXT )
VL_GL_FUNCTION( PFNGLTEXTUREBUFFEREXTPROC, glTextureBufferEXT )
VL_GL_FUNCTION( PFNGLMULTITEXBUFFEREXTPROC, glMultiTexBufferEXT )
VL_GL_FUNCTION( PFNGLNAMEDRENDERBUFFERSTORAGEEXTPROC, glNamedRenderbufferStorageEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDRENDERBUFFERPARAMETERIVEXTPROC, glGetNamedRenderbufferParameterivEXT )
VL_GL_FUNCTION( PFNGLCHECKNAMEDFRAMEBUFFERSTATUSEXTPROC, glCheckNamedFramebufferStatusEXT )
VL_GL_FUNCTION( PFNGLNAMEDFRAMEBUFFERTEXTURE1DEXTPROC, glNamedFramebufferTexture1DEXT )
VL_GL_FUNCTION( PFNGLNAMEDFRAMEBUFFERTEXTURE2DEXTPROC, glNamedFramebufferTexture2DEXT )
VL_GL_FUNCTION( PFNGLNAMEDFRAMEBUFFERTEXTURE3DEXTPROC, glNamedFramebufferTexture3DEXT )
VL_GL_FUNCTION( PFNGLNAMEDFRAMEBUFFERRENDERBUFFEREXTPROC, glNamedFramebufferRenderbufferEXT )
VL_GL_FUNCTION( PFNGLGETNAMEDFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC, glGetNamedFramebufferAttachmentParameterivEXT )
VL_GL_FUNCTION( PFNGLGENERATETEXTUREMIPMAPEXTPROC, glGenerateTextureMipmapEXT )
VL_GL_FUNCTION( PFNGLGENERATEMULTITEXMIPMAPEXTPROC, glGenerateMultiTexMipmapEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERDRAWBUFFEREXTPROC, glFramebufferDrawBufferEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERDRAWBUFFERSEXTPROC, glFramebufferDrawBuffersEXT )
VL_GL_FUNCTION( PFNGLFRAMEBUFFERREADBUFFEREXTPROC, glFramebufferReadBufferEXT )
VL_GL_FUNCTION( PFNGLGETFRAMEBUFFERPARAMETERIVEXTPROC, glGetFramebufferParameterivEXT )
VL_GL_FUNCTION( PFNGLNAMEDRENDERBUFFERSTORAGEMULTISAMPLEEXTPROC, glNamedRenderbufferStorageMultisampleEXT )
VL_GL_FUNCTION( PFNGLNAMEDRENDERBUFFERSTORAGEMULTISAMPLECOVERAGEEXTPROC, glNamedRenderbufferStorageMultisampleCoverageEXT )
VL_GL_FUNCTION( PFNGLNAMEDFRAMEBUFFERTEXTUREEXTPROC, glNamedFramebufferTextureEXT )
VL_GL_FUNCTION( PFNGLNAMEDFRAMEBUFFERTEXTURELAYEREXTPROC, glNamedFramebufferTextureLayerEXT )
VL_GL_FUNCTION( PFNGLNAMEDFRAMEBUFFERTEXTUREFACEEXTPROC, glNamedFramebufferTextureFaceEXT )
VL_GL_FUNCTION( PFNGLTEXTURERENDERBUFFEREXTPROC, glTextureRenderbufferEXT )
VL_GL_FUNCTION( PFNGLMULTITEXRENDERBUFFEREXTPROC, glMultiTexRenderbufferEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1DEXTPROC, glProgramUniform1dEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2DEXTPROC, glProgramUniform2dEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3DEXTPROC, glProgramUniform3dEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4DEXTPROC, glProgramUniform4dEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1DVEXTPROC, glProgramUniform1dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2DVEXTPROC, glProgramUniform2dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3DVEXTPROC, glProgramUniform3dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4DVEXTPROC, glProgramUniform4dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2DVEXTPROC, glProgramUniformMatrix2dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3DVEXTPROC, glProgramUniformMatrix3dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4DVEXTPROC, glProgramUniformMatrix4dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2X3DVEXTPROC, glProgramUniformMatrix2x3dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX2X4DVEXTPROC, glProgramUniformMatrix2x4dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3X2DVEXTPROC, glProgramUniformMatrix3x2dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX3X4DVEXTPROC, glProgramUniformMatrix3x4dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4X2DVEXTPROC, glProgramUniformMatrix4x2dvEXT )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMMATRIX4X3DVEXTPROC, glProgramUniformMatrix4x3dvEXT )
#endif

// GL_NV_explicit_multisample
#ifdef GL_NV_explicit_multisample
VL_GL_FUNCTION( PFNGLGETMULTISAMPLEFVNVPROC, glGetMultisamplefvNV )
VL_GL_FUNCTION( PFNGLSAMPLEMASKINDEXEDNVPROC, glSampleMaskIndexedNV )
VL_GL_FUNCTION( PFNGLTEXRENDERBUFFERNVPROC, glTexRenderbufferNV )
#endif

// GL_NV_transform_feedback2
#ifdef GL_NV_transform_feedback2
VL_GL_FUNCTION( PFNGLBINDTRANSFORMFEEDBACKNVPROC, glBindTransformFeedbackNV )
VL_GL_FUNCTION( PFNGLDELETETRANSFORMFEEDBACKSNVPROC, glDeleteTransformFeedbacksNV )
VL_GL_FUNCTION( PFNGLGENTRANSFORMFEEDBACKSNVPROC, glGenTransformFeedbacksNV )
VL_GL_FUNCTION( PFNGLISTRANSFORMFEEDBACKNVPROC, glIsTransformFeedbackNV )
VL_GL_FUNCTION( PFNGLPAUSETRANSFORMFEEDBACKNVPROC, glPauseTransformFeedbackNV )
VL_GL_FUNCTION( PFNGLRESUMETRANSFORMFEEDBACKNVPROC, glResumeTransformFeedbackNV )
VL_GL_FUNCTION( PFNGLDRAWTRANSFORMFEEDBACKNVPROC, glDrawTransformFeedbackNV )
#endif

// GL_AMD_performance_monitor
#ifdef GL_AMD_performance_monitor
VL_GL_FUNCTION( PFNGLGETPERFMONITORGROUPSAMDPROC, glGetPerfMonitorGroupsAMD )
VL_GL_FUNCTION( PFNGLGETPERFMONITORCOUNTERSAMDPROC, glGetPerfMonitorCountersAMD )
VL_GL_FUNCTION( PFNGLGETPERFMONITORGROUPSTRINGAMDPROC, glGetPerfMonitorGroupStringAMD )
VL_GL_FUNCTION( PFNGLGETPERFMONITORCOUNTERSTRINGAMDPROC, glGetPerfMonitorCounterStringAMD )
VL_GL_FUNCTION( PFNGLGETPERFMONITORCOUNTERINFOAMDPROC, glGetPerfMonitorCounterInfoAMD )
VL_GL_FUNCTION( PFNGLGENPERFMONITORSAMDPROC, glGenPerfMonitorsAMD )
VL_GL_FUNCTION( PFNGLDELETEPERFMONITORSAMDPROC, glDeletePerfMonitorsAMD )
VL_GL_FUNCTION( PFNGLSELECTPERFMONITORCOUNTERSAMDPROC, glSelectPerfMonitorCountersAMD )
VL_GL_FUNCTION( PFNGLBEGINPERFMONITORAMDPROC, glBeginPerfMonitorAMD )
VL_GL_FUNCTION( PFNGLENDPERFMONITORAMDPROC, glEndPerfMonitorAMD )
VL_GL_FUNCTION( PFNGLGETPERFMONITORCOUNTERDATAAMDPROC, glGetPerfMonitorCounterDataAMD )
#endif

// GL_AMD_vertex_shader_tesselator
#ifdef GL_AMD_vertex_shader_tesselator
VL_GL_FUNCTION( PFNGLTESSELLATIONFACTORAMDPROC, glTessellationFactorAMD )
VL_GL_FUNCTION( PFNGLTESSELLATIONMODEAMDPROC, glTessellationModeAMD )
#endif

// GL_EXT_provoking_vertex
#ifdef GL_EXT_provoking_vertex
VL_GL_FUNCTION( PFNGLPROVOKINGVERTEXEXTPROC, glProvokingVertexEXT )
#endif

// GL_AMD_draw_buffers_blend
#ifdef GL_AMD_draw_buffers_blend
VL_GL_FUNCTION( PFNGLBLENDFUNCINDEXEDAMDPROC, glBlendFuncIndexedAMD )
VL_GL_FUNCTION( PFNGLBLENDFUNCSEPARATEINDEXEDAMDPROC, glBlendFuncSeparateIndexedAMD )
VL_GL_FUNCTION( PFNGLBLENDEQUATIONINDEXEDAMDPROC, glBlendEquationIndexedAMD )
VL_GL_FUNCTION( PFNGLBLENDEQUATIONSEPARATEINDEXEDAMDPROC, glBlendEquationSeparateIndexedAMD )
#endif

// GL_APPLE_texture_range
#ifdef GL_APPLE_texture_range
VL_GL_FUNCTION( PFNGLTEXTURERANGEAPPLEPROC, glTextureRangeAPPLE )
VL_GL_FUNCTION( PFNGLGETTEXPARAMETERPOINTERVAPPLEPROC, glGetTexParameterPointervAPPLE )
#endif

// GL_APPLE_vertex_program_evaluators
#ifdef GL_APPLE_vertex_program_evaluators
VL_GL_FUNCTION( PFNGLENABLEVERTEXATTRIBAPPLEPROC, glEnableVertexAttribAPPLE )
VL_GL_FUNCTION( PFNGLDISABLEVERTEXATTRIBAPPLEPROC, glDisableVertexAttribAPPLE )
VL_GL_FUNCTION( PFNGLISVERTEXATTRIBENABLEDAPPLEPROC, glIsVertexAttribEnabledAPPLE )
VL_GL_FUNCTION( PFNGLMAPVERTEXATTRIB1DAPPLEPROC, glMapVertexAttrib1dAPPLE )
VL_GL_FUNCTION( PFNGLMAPVERTEXATTRIB1FAPPLEPROC, glMapVertexAttrib1fAPPLE )
VL_GL_FUNCTION( PFNGLMAPVERTEXATTRIB2DAPPLEPROC, glMapVertexAttrib2dAPPLE )
VL_GL_FUNCTION( PFNGLMAPVERTEXATTRIB2FAPPLEPROC, glMapVertexAttrib2fAPPLE )
#endif

// GL_APPLE_object_purgeable
#ifdef GL_APPLE_object_purgeable
VL_GL_FUNCTION( PFNGLOBJECTPURGEABLEAPPLEPROC, glObjectPurgeableAPPLE )
VL_GL_FUNCTION( PFNGLOBJECTUNPURGEABLEAPPLEPROC, glObjectUnpurgeableAPPLE )
VL_GL_FUNCTION( PFNGLGETOBJECTPARAMETERIVAPPLEPROC, glGetObjectParameterivAPPLE )
#endif

// GL_NV_video_capture
#ifdef GL_NV_video_capture
VL_GL_FUNCTION( PFNGLBEGINVIDEOCAPTURENVPROC, glBeginVideoCaptureNV )
VL_GL_FUNCTION( PFNGLBINDVIDEOCAPTURESTREAMBUFFERNVPROC, glBindVideoCaptureStreamBufferNV )
VL_GL_FUNCTION( PFNGLBINDVIDEOCAPTURESTREAMTEXTURENVPROC, glBindVideoCaptureStreamTextureNV )
VL_GL_FUNCTION( PFNGLENDVIDEOCAPTURENVPROC, glEndVideoCaptureNV )
VL_GL_FUNCTION( PFNGLGETVIDEOCAPTUREIVNVPROC, glGetVideoCaptureivNV )
VL_GL_FUNCTION( PFNGLGETVIDEOCAPTURESTREAMIVNVPROC, glGetVideoCaptureStreamivNV )
VL_GL_FUNCTION( PFNGLGETVIDEOCAPTURESTREAMFVNVPROC, glGetVideoCaptureStreamfvNV )
VL_GL_FUNCTION( PFNGLGETVIDEOCAPTURESTREAMDVNVPROC, glGetVideoCaptureStreamdvNV )
VL_GL_FUNCTION( PFNGLVIDEOCAPTURENVPROC, glVideoCaptureNV )
VL_GL_FUNCTION( PFNGLVIDEOCAPTURESTREAMPARAMETERIVNVPROC, glVideoCaptureStreamParameterivNV )
VL_GL_FUNCTION( PFNGLVIDEOCAPTURESTREAMPARAMETERFVNVPROC, glVideoCaptureStreamParameterfvNV )
VL_GL_FUNCTION( PFNGLVIDEOCAPTURESTREAMPARAMETERDVNVPROC, glVideoCaptureStreamParameterdvNV )
#endif

// GL_NV_copy_image
#ifdef GL_NV_copy_image
VL_GL_FUNCTION( PFNGLCOPYIMAGESUBDATANVPROC, glCopyImageSubDataNV )
#endif

// GL_EXT_separate_shader_objects
#ifdef GL_EXT_separate_shader_objects
VL_GL_FUNCTION( PFNGLUSESHADERPROGRAMEXTPROC, glUseShaderProgramEXT )
VL_GL_FUNCTION( PFNGLACTIVEPROGRAMEXTPROC, glActiveProgramEXT )
VL_GL_FUNCTION( PFNGLCREATESHADERPROGRAMEXTPROC, glCreateShaderProgramEXT )
#endif

// GL_NV_shader_buffer_load
#ifdef GL_NV_shader_buffer_load
VL_GL_FUNCTION( PFNGLMAKEBUFFERRESIDENTNVPROC, glMakeBufferResidentNV )
VL_GL_FUNCTION( PFNGLMAKEBUFFERNONRESIDENTNVPROC, glMakeBufferNonResidentNV )
VL_GL_FUNCTION( PFNGLISBUFFERRESIDENTNVPROC, glIsBufferResidentNV )
VL_GL_FUNCTION( PFNGLMAKENAMEDBUFFERRESIDENTNVPROC, glMakeNamedBufferResidentNV )
VL_GL_FUNCTION( PFNGLMAKENAMEDBUFFERNONRESIDENTNVPROC, glMakeNamedBufferNonResidentNV )
VL_GL_FUNCTION( PFNGLISNAMEDBUFFERRESIDENTNVPROC, glIsNamedBufferResidentNV )
VL_GL_FUNCTION( PFNGLGETBUFFERPARAMETERUI64VNVPROC, glGetBufferParameterui64vNV )
VL_GL_FUNCTION( PFNGLGETNAMEDBUFFERPARAMETERUI64VNVPROC, glGetNamedBufferParameterui64vNV )
VL_GL_FUNCTION( PFNGLGETINTEGERUI64VNVPROC, glGetIntegerui64vNV )
VL_GL_FUNCTION( PFNGLUNIFORMUI64NVPROC, glUniformui64NV )
VL_GL_FUNCTION( PFNGLUNIFORMUI64VNVPROC, glUniformui64vNV )
VL_GL_FUNCTION( PFNGLGETUNIFORMUI64VNVPROC, glGetUniformui64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMUI64NVPROC, glProgramUniformui64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORMUI64VNVPROC, glProgramUniformui64vNV )
#endif

// GL_NV_vertex_buffer_unified_memory
#ifdef GL_NV_vertex_buffer_unified_memory
VL_GL_FUNCTION( PFNGLBUFFERADDRESSRANGENVPROC, glBufferAddressRangeNV )
VL_GL_FUNCTION( PFNGLVERTEXFORMATNVPROC, glVertexFormatNV )
VL_GL_FUNCTION( PFNGLNORMALFORMATNVPROC, glNormalFormatNV )
VL_GL_FUNCTION( PFNGLCOLORFORMATNVPROC, glColorFormatNV )
VL_GL_FUNCTION( PFNGLINDEXFORMATNVPROC, glIndexFormatNV )
VL_GL_FUNCTION( PFNGLTEXCOORDFORMATNVPROC, glTexCoordFormatNV )
VL_GL_FUNCTION( PFNGLEDGEFLAGFORMATNVPROC, glEdgeFlagFormatNV )
VL_GL_FUNCTION( PFNGLSECONDARYCOLORFORMATNVPROC, glSecondaryColorFormatNV )
VL_GL_FUNCTION( PFNGLFOGCOORDFORMATNVPROC, glFogCoordFormatNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBFORMATNVPROC, glVertexAttribFormatNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBIFORMATNVPROC, glVertexAttribIFormatNV )
VL_GL_FUNCTION( PFNGLGETINTEGERUI64I_VNVPROC, glGetIntegerui64i_vNV )
#endif

// GL_NV_texture_barrier
#ifdef GL_NV_texture_barrier
VL_GL_FUNCTION( PFNGLTEXTUREBARRIERNVPROC, glTextureBarrierNV )
#endif

// GL_EXT_shader_image_load_store
#ifdef GL_EXT_shader_image_load_store
VL_GL_FUNCTION( PFNGLBINDIMAGETEXTUREEXTPROC, glBindImageTextureEXT )
VL_GL_FUNCTION( PFNGLMEMORYBARRIEREXTPROC, glMemoryBarrierEXT )
#endif

// GL_EXT_vertex_attrib_64bit
#ifdef GL_EXT_vertex_attrib_64bit
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL1DEXTPROC, glVertexAttribL1dEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL2DEXTPROC, glVertexAttribL2dEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL3DEXTPROC, glVertexAttribL3dEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL4DEXTPROC, glVertexAttribL4dEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL1DVEXTPROC, glVertexAttribL1dvEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL2DVEXTPROC, glVertexAttribL2dvEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL3DVEXTPROC, glVertexAttribL3dvEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL4DVEXTPROC, glVertexAttribL4dvEXT )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBLPOINTEREXTPROC, glVertexAttribLPointerEXT )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBLDVEXTPROC, glGetVertexAttribLdvEXT )
VL_GL_FUNCTION( PFNGLVERTEXARRAYVERTEXATTRIBLOFFSETEXTPROC, glVertexArrayVertexAttribLOffsetEXT )
#endif

// GL_NV_gpu_program5
#ifdef GL_NV_gpu_program5
VL_GL_FUNCTION( PFNGLPROGRAMSUBROUTINEPARAMETERSUIVNVPROC, glProgramSubroutineParametersuivNV )
VL_GL_FUNCTION( PFNGLGETPROGRAMSUBROUTINEPARAMETERUIVNVPROC, glGetProgramSubroutineParameteruivNV )
#endif

// GL_NV_gpu_shader5
#ifdef GL_NV_gpu_shader5
VL_GL_FUNCTION( PFNGLUNIFORM1I64NVPROC, glUniform1i64NV )
VL_GL_FUNCTION( PFNGLUNIFORM2I64NVPROC, glUniform2i64NV )
VL_GL_FUNCTION( PFNGLUNIFORM3I64NVPROC, glUniform3i64NV )
VL_GL_FUNCTION( PFNGLUNIFORM4I64NVPROC, glUniform4i64NV )
VL_GL_FUNCTION( PFNGLUNIFORM1I64VNVPROC, glUniform1i64vNV )
VL_GL_FUNCTION( PFNGLUNIFORM2I64VNVPROC, glUniform2i64vNV )
VL_GL_FUNCTION( PFNGLUNIFORM3I64VNVPROC, glUniform3i64vNV )
VL_GL_FUNCTION( PFNGLUNIFORM4I64VNVPROC, glUniform4i64vNV )
VL_GL_FUNCTION( PFNGLUNIFORM1UI64NVPROC, glUniform1ui64NV )
VL_GL_FUNCTION( PFNGLUNIFORM2UI64NVPROC, glUniform2ui64NV )
VL_GL_FUNCTION( PFNGLUNIFORM3UI64NVPROC, glUniform3ui64NV )
VL_GL_FUNCTION( PFNGLUNIFORM4UI64NVPROC, glUniform4ui64NV )
VL_GL_FUNCTION( PFNGLUNIFORM1UI64VNVPROC, glUniform1ui64vNV )
VL_GL_FUNCTION( PFNGLUNIFORM2UI64VNVPROC, glUniform2ui64vNV )
VL_GL_FUNCTION( PFNGLUNIFORM3UI64VNVPROC, glUniform3ui64vNV )
VL_GL_FUNCTION( PFNGLUNIFORM4UI64VNVPROC, glUniform4ui64vNV )
VL_GL_FUNCTION( PFNGLGETUNIFORMI64VNVPROC, glGetUniformi64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1I64NVPROC, glProgramUniform1i64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2I64NVPROC, glProgramUniform2i64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3I64NVPROC, glProgramUniform3i64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4I64NVPROC, glProgramUniform4i64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1I64VNVPROC, glProgramUniform1i64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2I64VNVPROC, glProgramUniform2i64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3I64VNVPROC, glProgramUniform3i64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4I64VNVPROC, glProgramUniform4i64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1UI64NVPROC, glProgramUniform1ui64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2UI64NVPROC, glProgramUniform2ui64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3UI64NVPROC, glProgramUniform3ui64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4UI64NVPROC, glProgramUniform4ui64NV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM1UI64VNVPROC, glProgramUniform1ui64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM2UI64VNVPROC, glProgramUniform2ui64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM3UI64VNVPROC, glProgramUniform3ui64vNV )
VL_GL_FUNCTION( PFNGLPROGRAMUNIFORM4UI64VNVPROC, glProgramUniform4ui64vNV )
#endif

// GL_NV_vertex_attrib_integer_64bit
#ifdef GL_NV_vertex_attrib_integer_64bit
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL1I64NVPROC, glVertexAttribL1i64NV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL2I64NVPROC, glVertexAttribL2i64NV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL3I64NVPROC, glVertexAttribL3i64NV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL4I64NVPROC, glVertexAttribL4i64NV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL1I64VNVPROC, glVertexAttribL1i64vNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL2I64VNVPROC, glVertexAttribL2i64vNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL3I64VNVPROC, glVertexAttribL3i64vNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL4I64VNVPROC, glVertexAttribL4i64vNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL1UI64NVPROC, glVertexAttribL1ui64NV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL2UI64NVPROC, glVertexAttribL2ui64NV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL3UI64NVPROC, glVertexAttribL3ui64NV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL4UI64NVPROC, glVertexAttribL4ui64NV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL1UI64VNVPROC, glVertexAttribL1ui64vNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL2UI64VNVPROC, glVertexAttribL2ui64vNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL3UI64VNVPROC, glVertexAttribL3ui64vNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBL4UI64VNVPROC, glVertexAttribL4ui64vNV )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBLI64VNVPROC, glGetVertexAttribLi64vNV )
VL_GL_FUNCTION( PFNGLGETVERTEXATTRIBLUI64VNVPROC, glGetVertexAttribLui64vNV )
VL_GL_FUNCTION( PFNGLVERTEXATTRIBLFORMATNVPROC, glVertexAttribLFormatNV )
#endif

// GL_AMD_name_gen_delete
#ifdef GL_AMD_name_gen_delete
VL_GL_FUNCTION( PFNGLGENNAMESAMDPROC, glGenNamesAMD )
VL_GL_FUNCTION( PFNGLDELETENAMESAMDPROC, glDeleteNamesAMD )
VL_GL_FUNCTION( PFNGLISNAMEAMDPROC, glIsNameAMD )
#endif

// GL_AMD_debug_output
#ifdef GL_AMD_debug_output
VL_GL_FUNCTION( PFNGLDEBUGMESSAGEENABLEAMDPROC, glDebugMessageEnableAMD )
VL_GL_FUNCTION( PFNGLDEBUGMESSAGEINSERTAMDPROC, glDebugMessageInsertAMD )
VL_GL_FUNCTION( PFNGLDEBUGMESSAGECALLBACKAMDPROC, glDebugMessageCallbackAMD )
VL_GL_FUNCTION( PFNGLGETDEBUGMESSAGELOGAMDPROC, glGetDebugMessageLogAMD )
#endif

// GL_NV_vdpau_interop
#ifdef GL_NV_vdpau_interop
VL_GL_FUNCTION( PFNGLVDPAUINITNVPROC, glVDPAUInitNV )
VL_GL_FUNCTION( PFNGLVDPAUFININVPROC, glVDPAUFiniNV )
VL_GL_FUNCTION( PFNGLVDPAUREGISTERVIDEOSURFACENVPROC, glVDPAURegisterVideoSurfaceNV )
VL_GL_FUNCTION( PFNGLVDPAUREGISTEROUTPUTSURFACENVPROC, glVDPAURegisterOutputSurfaceNV )
VL_GL_FUNCTION( PFNGLVDPAUISSURFACENVPROC, glVDPAUIsSurfaceNV )
VL_GL_FUNCTION( PFNGLVDPAUUNREGISTERSURFACENVPROC, glVDPAUUnregisterSurfaceNV )
VL_GL_FUNCTION( PFNGLVDPAUGETSURFACEIVNVPROC, glVDPAUGetSurfaceivNV )
VL_GL_FUNCTION( PFNGLVDPAUSURFACEACCESSNVPROC, glVDPAUSurfaceAccessNV )
VL_GL_FUNCTION( PFNGLVDPAUMAPSURFACESNVPROC, glVDPAUMapSurfacesNV )
VL_GL_FUNCTION( PFNGLVDPAUUNMAPSURFACESNVPROC, glVDPAUUnmapSurfacesNV )
#endif

// GL_NV_texture_multisample
#ifdef GL_NV_texture_multisample
VL_GL_FUNCTION( PFNGLTEXIMAGE2DMULTISAMPLECOVERAGENVPROC, glTexImage2DMultisampleCoverageNV )
VL_GL_FUNCTION( PFNGLTEXIMAGE3DMULTISAMPLECOVERAGENVPROC, glTexImage3DMultisampleCoverageNV )
VL_GL_FUNCTION( PFNGLTEXTUREIMAGE2DMULTISAMPLENVPROC, glTextureImage2DMultisampleNV )
VL_GL_FUNCTION( PFNGLTEXTUREIMAGE3DMULTISAMPLENVPROC, glTextureImage3DMultisampleNV )
VL_GL_FUNCTION( PFNGLTEXTUREIMAGE2DMULTISAMPLECOVERAGENVPROC, glTextureImage2DMultisampleCoverageNV )
VL_GL_FUNCTION( PFNGLTEXTUREIMAGE3DMULTISAMPLECOVERAGENVPROC, glTextureImage3DMultisampleCoverageNV )
#endif

// GL_AMD_sample_positions
#ifdef GL_AMD_sample_positions
VL_GL_FUNCTION( PFNGLSETMULTISAMPLEFVAMDPROC, glSetMultisamplefvAMD )
#endif

// GL_EXT_x11_sync_object
#ifdef GL_EXT_x11_sync_object
VL_GL_FUNCTION( PFNGLIMPORTSYNCEXTPROC, glImportSyncEXT )
#endif

// GL_AMD_multi_draw_indirect
#ifdef GL_AMD_multi_draw_indirect
VL_GL_FUNCTION( PFNGLMULTIDRAWARRAYSINDIRECTAMDPROC, glMultiDrawArraysIndirectAMD )
VL_GL_FUNCTION( PFNGLMULTIDRAWELEMENTSINDIRECTAMDPROC, glMultiDrawElementsIndirectAMD )
#endif

// *** GLX EXTENSIONS ***

// GLX_VERSION_1_3
#ifdef GLX_VERSION_1_3
VL_GLX_FUNCTION( PFNGLXGETFBCONFIGSPROC, glXGetFBConfigs )
VL_GLX_FUNCTION( PFNGLXCHOOSEFBCONFIGPROC, glXChooseFBConfig )
VL_GLX_FUNCTION( PFNGLXGETFBCONFIGATTRIBPROC, glXGetFBConfigAttrib )
VL_GLX_FUNCTION( PFNGLXGETVISUALFROMFBCONFIGPROC, glXGetVisualFromFBConfig )
VL_GLX_FUNCTION( PFNGLXCREATEWINDOWPROC, glXCreateWindow )
VL_GLX_FUNCTION( PFNGLXDESTROYWINDOWPROC, glXDestroyWindow )
VL_GLX_FUNCTION( PFNGLXCREATEPIXMAPPROC, glXCreatePixmap )
VL_GLX_FUNCTION( PFNGLXDESTROYPIXMAPPROC, glXDestroyPixmap )
VL_GLX_FUNCTION( PFNGLXCREATEPBUFFERPROC, glXCreatePbuffer )
VL_GLX_FUNCTION( PFNGLXDESTROYPBUFFERPROC, glXDestroyPbuffer )
VL_GLX_FUNCTION( PFNGLXQUERYDRAWABLEPROC, glXQueryDrawable )
VL_GLX_FUNCTION( PFNGLXCREATENEWCONTEXTPROC, glXCreateNewContext )
VL_GLX_FUNCTION( PFNGLXMAKECONTEXTCURRENTPROC, glXMakeContextCurrent )
VL_GLX_FUNCTION( PFNGLXGETCURRENTREADDRAWABLEPROC, glXGetCurrentReadDrawable )
VL_GLX_FUNCTION( PFNGLXGETCURRENTDISPLAYPROC, glXGetCurrentDisplay )
VL_GLX_FUNCTION( PFNGLXQUERYCONTEXTPROC, glXQueryContext )
VL_GLX_FUNCTION( PFNGLXSELECTEVENTPROC, glXSelectEvent )
VL_GLX_FUNCTION( PFNGLXGETSELECTEDEVENTPROC, glXGetSelectedEvent )
#endif

// GLX_VERSION_1_4
#ifdef GLX_VERSION_1_4
VL_GLX_FUNCTION( PFNGLXGETPROCADDRESSPROC, glXGetProcAddress )
#endif

// GLX_ARB_get_proc_address
#ifdef GLX_ARB_get_proc_address
VL_GLX_FUNCTION( PFNGLXGETPROCADDRESSARBPROC, glXGetProcAddressARB )
#endif

// GLX_ARB_create_context
#ifdef GLX_ARB_create_context
VL_GLX_FUNCTION( PFNGLXCREATECONTEXTATTRIBSARBPROC, glXCreateContextAttribsARB )
#endif

// GLX_SGI_swap_control
#ifdef GLX_SGI_swap_control
VL_GLX_FUNCTION( PFNGLXSWAPINTERVALSGIPROC, glXSwapIntervalSGI )
#endif

// GLX_SGI_video_sync
#ifdef GLX_SGI_video_sync
VL_GLX_FUNCTION( PFNGLXGETVIDEOSYNCSGIPROC, glXGetVideoSyncSGI )
VL_GLX_FUNCTION( PFNGLXWAITVIDEOSYNCSGIPROC, glXWaitVideoSyncSGI )
#endif

// GLX_SGI_make_current_read
#ifdef GLX_SGI_make_current_read
VL_GLX_FUNCTION( PFNGLXMAKECURRENTREADSGIPROC, glXMakeCurrentReadSGI )
VL_GLX_FUNCTION( PFNGLXGETCURRENTREADDRAWABLESGIPROC, glXGetCurrentReadDrawableSGI )
#endif

// GLX_SGIX_video_source
#ifdef GLX_SGIX_video_source
VL_GLX_FUNCTION( PFNGLXCREATEGLXVIDEOSOURCESGIXPROC, glXCreateGLXVideoSourceSGIX )
VL_GLX_FUNCTION( PFNGLXDESTROYGLXVIDEOSOURCESGIXPROC, glXDestroyGLXVideoSourceSGIX )
#endif

// GLX_EXT_import_context
#ifdef GLX_EXT_import_context
VL_GLX_FUNCTION( PFNGLXGETCURRENTDISPLAYEXTPROC, glXGetCurrentDisplayEXT )
VL_GLX_FUNCTION( PFNGLXQUERYCONTEXTINFOEXTPROC, glXQueryContextInfoEXT )
VL_GLX_FUNCTION( PFNGLXGETCONTEXTIDEXTPROC, glXGetContextIDEXT )
VL_GLX_FUNCTION( PFNGLXIMPORTCONTEXTEXTPROC, glXImportContextEXT )
VL_GLX_FUNCTION( PFNGLXFREECONTEXTEXTPROC, glXFreeContextEXT )
#endif

// GLX_SGIX_fbconfig
#ifdef GLX_SGIX_fbconfig
VL_GLX_FUNCTION( PFNGLXGETFBCONFIGATTRIBSGIXPROC, glXGetFBConfigAttribSGIX )
VL_GLX_FUNCTION( PFNGLXCHOOSEFBCONFIGSGIXPROC, glXChooseFBConfigSGIX )
VL_GLX_FUNCTION( PFNGLXCREATEGLXPIXMAPWITHCONFIGSGIXPROC, glXCreateGLXPixmapWithConfigSGIX )
VL_GLX_FUNCTION( PFNGLXCREATECONTEXTWITHCONFIGSGIXPROC, glXCreateContextWithConfigSGIX )
VL_GLX_FUNCTION( PFNGLXGETVISUALFROMFBCONFIGSGIXPROC, glXGetVisualFromFBConfigSGIX )
VL_GLX_FUNCTION( PFNGLXGETFBCONFIGFROMVISUALSGIXPROC, glXGetFBConfigFromVisualSGIX )
#endif

// GLX_SGIX_pbuffer
#ifdef GLX_SGIX_pbuffer
VL_GLX_FUNCTION( PFNGLXCREATEGLXPBUFFERSGIXPROC, glXCreateGLXPbufferSGIX )
VL_GLX_FUNCTION( PFNGLXDESTROYGLXPBUFFERSGIXPROC, glXDestroyGLXPbufferSGIX )
VL_GLX_FUNCTION( PFNGLXQUERYGLXPBUFFERSGIXPROC, glXQueryGLXPbufferSGIX )
VL_GLX_FUNCTION( PFNGLXSELECTEVENTSGIXPROC, glXSelectEventSGIX )
VL_GLX_FUNCTION( PFNGLXGETSELECTEDEVENTSGIXPROC, glXGetSelectedEventSGIX )
#endif

// GLX_SGI_cushion
#ifdef GLX_SGI_cushion
VL_GLX_FUNCTION( PFNGLXCUSHIONSGIPROC, glXCushionSGI )
#endif

// GLX_SGIX_video_resize
#ifdef GLX_SGIX_video_resize
VL_GLX_FUNCTION( PFNGLXBINDCHANNELTOWINDOWSGIXPROC, glXBindChannelToWindowSGIX )
VL_GLX_FUNCTION( PFNGLXCHANNELRECTSGIXPROC, glXChannelRectSGIX )
VL_GLX_FUNCTION( PFNGLXQUERYCHANNELRECTSGIXPROC, glXQueryChannelRectSGIX )
VL_GLX_FUNCTION( PFNGLXQUERYCHANNELDELTASSGIXPROC, glXQueryChannelDeltasSGIX )
VL_GLX_FUNCTION( PFNGLXCHANNELRECTSYNCSGIXPROC, glXChannelRectSyncSGIX )
#endif

// GLX_SGIX_dmbuffer
#ifdef GLX_SGIX_dmbuffer
VL_GLX_FUNCTION( PFNGLXASSOCIATEDMPBUFFERSGIXPROC, glXAssociateDMPbufferSGIX )
#endif

// GLX_SGIX_swap_group
#ifdef GLX_SGIX_swap_group
VL_GLX_FUNCTION( PFNGLXJOINSWAPGROUPSGIXPROC, glXJoinSwapGroupSGIX )
#endif

// GLX_SGIX_swap_barrier
#ifdef GLX_SGIX_swap_barrier
VL_GLX_FUNCTION( PFNGLXBINDSWAPBARRIERSGIXPROC, glXBindSwapBarrierSGIX )
VL_GLX_FUNCTION( PFNGLXQUERYMAXSWAPBARRIERSSGIXPROC, glXQueryMaxSwapBarriersSGIX )
#endif

// GLX_SUN_get_transparent_index
#ifdef GLX_SUN_get_transparent_index
VL_GLX_FUNCTION( PFNGLXGETTRANSPARENTINDEXSUNPROC, glXGetTransparentIndexSUN )
#endif

// GLX_MESA_copy_sub_buffer
#ifdef GLX_MESA_copy_sub_buffer
VL_GLX_FUNCTION( PFNGLXCOPYSUBBUFFERMESAPROC, glXCopySubBufferMESA )
#endif

// GLX_MESA_pixmap_colormap
#ifdef GLX_MESA_pixmap_colormap
VL_GLX_FUNCTION( PFNGLXCREATEGLXPIXMAPMESAPROC, glXCreateGLXPixmapMESA )
#endif

// GLX_MESA_release_buffers
#ifdef GLX_MESA_release_buffers
VL_GLX_FUNCTION( PFNGLXRELEASEBUFFERSMESAPROC, glXReleaseBuffersMESA )
#endif

// GLX_MESA_set_3dfx_mode
#ifdef GLX_MESA_set_3dfx_mode
VL_GLX_FUNCTION( PFNGLXSET3DFXMODEMESAPROC, glXSet3DfxModeMESA )
#endif

// GLX_OML_sync_control
#ifdef GLX_OML_sync_control
VL_GLX_FUNCTION( PFNGLXGETSYNCVALUESOMLPROC, glXGetSyncValuesOML )
VL_GLX_FUNCTION( PFNGLXGETMSCRATEOMLPROC, glXGetMscRateOML )
VL_GLX_FUNCTION( PFNGLXSWAPBUFFERSMSCOMLPROC, glXSwapBuffersMscOML )
VL_GLX_FUNCTION( PFNGLXWAITFORMSCOMLPROC, glXWaitForMscOML )
VL_GLX_FUNCTION( PFNGLXWAITFORSBCOMLPROC, glXWaitForSbcOML )
#endif

// GLX_SGIX_hyperpipe
#ifdef GLX_SGIX_hyperpipe
VL_GLX_FUNCTION( PFNGLXQUERYHYPERPIPENETWORKSGIXPROC, glXQueryHyperpipeNetworkSGIX )
VL_GLX_FUNCTION( PFNGLXHYPERPIPECONFIGSGIXPROC, glXHyperpipeConfigSGIX )
VL_GLX_FUNCTION( PFNGLXQUERYHYPERPIPECONFIGSGIXPROC, glXQueryHyperpipeConfigSGIX )
VL_GLX_FUNCTION( PFNGLXDESTROYHYPERPIPECONFIGSGIXPROC, glXDestroyHyperpipeConfigSGIX )
VL_GLX_FUNCTION( PFNGLXBINDHYPERPIPESGIXPROC, glXBindHyperpipeSGIX )
VL_GLX_FUNCTION( PFNGLXQUERYHYPERPIPEBESTATTRIBSGIXPROC, glXQueryHyperpipeBestAttribSGIX )
VL_GLX_FUNCTION( PFNGLXHYPERPIPEATTRIBSGIXPROC, glXHyperpipeAttribSGIX )
VL_GLX_FUNCTION( PFNGLXQUERYHYPERPIPEATTRIBSGIXPROC, glXQueryHyperpipeAttribSGIX )
#endif

// GLX_MESA_agp_offset
#ifdef GLX_MESA_agp_offset
VL_GLX_FUNCTION( PFNGLXGETAGPOFFSETMESAPROC, glXGetAGPOffsetMESA )
#endif

// GLX_EXT_texture_from_pixmap
#ifdef GLX_EXT_texture_from_pixmap
VL_GLX_FUNCTION( PFNGLXBINDTEXIMAGEEXTPROC, glXBindTexImageEXT )
VL_GLX_FUNCTION( PFNGLXRELEASETEXIMAGEEXTPROC, glXReleaseTexImageEXT )
#endif

// GLX_NV_present_video
#ifdef GLX_NV_present_video
VL_GLX_FUNCTION( PFNGLXENUMERATEVIDEODEVICESNVPROC, glXEnumerateVideoDevicesNV )
VL_GLX_FUNCTION( PFNGLXBINDVIDEODEVICENVPROC, glXBindVideoDeviceNV )
#endif

// GLX_NV_video_output
#ifdef GLX_NV_video_output
VL_GLX_FUNCTION( PFNGLXGETVIDEODEVICENVPROC, glXGetVideoDeviceNV )
VL_GLX_FUNCTION( PFNGLXRELEASEVIDEODEVICENVPROC, glXReleaseVideoDeviceNV )
VL_GLX_FUNCTION( PFNGLXBINDVIDEOIMAGENVPROC, glXBindVideoImageNV )
VL_GLX_FUNCTION( PFNGLXRELEASEVIDEOIMAGENVPROC, glXReleaseVideoImageNV )
VL_GLX_FUNCTION( PFNGLXSENDPBUFFERTOVIDEONVPROC, glXSendPbufferToVideoNV )
VL_GLX_FUNCTION( PFNGLXGETVIDEOINFONVPROC, glXGetVideoInfoNV )
#endif

// GLX_NV_swap_group
#ifdef GLX_NV_swap_group
VL_GLX_FUNCTION( PFNGLXJOINSWAPGROUPNVPROC, glXJoinSwapGroupNV )
VL_GLX_FUNCTION( PFNGLXBINDSWAPBARRIERNVPROC, glXBindSwapBarrierNV )
VL_GLX_FUNCTION( PFNGLXQUERYSWAPGROUPNVPROC, glXQuerySwapGroupNV )
VL_GLX_FUNCTION( PFNGLXQUERYMAXSWAPGROUPSNVPROC, glXQueryMaxSwapGroupsNV )
VL_GLX_FUNCTION( PFNGLXQUERYFRAMECOUNTNVPROC, glXQueryFrameCountNV )
VL_GLX_FUNCTION( PFNGLXRESETFRAMECOUNTNVPROC, glXResetFrameCountNV )
#endif

// GLX_NV_video_capture
#ifdef GLX_NV_video_capture
VL_GLX_FUNCTION( PFNGLXBINDVIDEOCAPTUREDEVICENVPROC, glXBindVideoCaptureDeviceNV )
VL_GLX_FUNCTION( PFNGLXENUMERATEVIDEOCAPTUREDEVICESNVPROC, glXEnumerateVideoCaptureDevicesNV )
VL_GLX_FUNCTION( PFNGLXLOCKVIDEOCAPTUREDEVICENVPROC, glXLockVideoCaptureDeviceNV )
VL_GLX_FUNCTION( PFNGLXQUERYVIDEOCAPTUREDEVICENVPROC, glXQueryVideoCaptureDeviceNV )
VL_GLX_FUNCTION( PFNGLXRELEASEVIDEOCAPTUREDEVICENVPROC, glXReleaseVideoCaptureDeviceNV )
#endif

// GLX_EXT_swap_control
#ifdef GLX_EXT_swap_control
VL_GLX_FUNCTION( PFNGLXSWAPINTERVALEXTPROC, glXSwapIntervalEXT )
#endif

// GLX_NV_copy_image
#ifdef GLX_NV_copy_image
VL_GLX_FUNCTION( PFNGLXCOPYIMAGESUBDATANVPROC, glXCopyImageSubDataNV )
#endif

// *** WGL EXTENSIONS ***

// WGL_ARB_buffer_region
#ifdef WGL_ARB_buffer_region
VL_WGL_FUNCTION( PFNWGLCREATEBUFFERREGIONARBPROC, wglCreateBufferRegionARB )
VL_WGL_FUNCTION( PFNWGLDELETEBUFFERREGIONARBPROC, wglDeleteBufferRegionARB )
VL_WGL_FUNCTION( PFNWGLSAVEBUFFERREGIONARBPROC, wglSaveBufferRegionARB )
VL_WGL_FUNCTION( PFNWGLRESTOREBUFFERREGIONARBPROC, wglRestoreBufferRegionARB )
#endif

// WGL_ARB_extensions_string
#ifdef WGL_ARB_extensions_string
VL_WGL_FUNCTION( PFNWGLGETEXTENSIONSSTRINGARBPROC, wglGetExtensionsStringARB )
#endif

// WGL_ARB_pixel_format
#ifdef WGL_ARB_pixel_format
VL_WGL_FUNCTION( PFNWGLGETPIXELFORMATATTRIBIVARBPROC, wglGetPixelFormatAttribivARB )
VL_WGL_FUNCTION( PFNWGLGETPIXELFORMATATTRIBFVARBPROC, wglGetPixelFormatAttribfvARB )
VL_WGL_FUNCTION( PFNWGLCHOOSEPIXELFORMATARBPROC, wglChoosePixelFormatARB )
#endif

// WGL_ARB_make_current_read
#ifdef WGL_ARB_make_current_read
VL_WGL_FUNCTION( PFNWGLMAKECONTEXTCURRENTARBPROC, wglMakeContextCurrentARB )
VL_WGL_FUNCTION( PFNWGLGETCURRENTREADDCARBPROC, wglGetCurrentReadDCARB )
#endif

// WGL_ARB_pbuffer
#ifdef WGL_ARB_pbuffer
VL_WGL_FUNCTION( PFNWGLCREATEPBUFFERARBPROC, wglCreatePbufferARB )
VL_WGL_FUNCTION( PFNWGLGETPBUFFERDCARBPROC, wglGetPbufferDCARB )
VL_WGL_FUNCTION( PFNWGLRELEASEPBUFFERDCARBPROC, wglReleasePbufferDCARB )
VL_WGL_FUNCTION( PFNWGLDESTROYPBUFFERARBPROC, wglDestroyPbufferARB )
VL_WGL_FUNCTION( PFNWGLQUERYPBUFFERARBPROC, wglQueryPbufferARB )
#endif

// WGL_ARB_render_texture
#ifdef WGL_ARB_render_texture
VL_WGL_FUNCTION( PFNWGLBINDTEXIMAGEARBPROC, wglBindTexImageARB )
VL_WGL_FUNCTION( PFNWGLRELEASETEXIMAGEARBPROC, wglReleaseTexImageARB )
VL_WGL_FUNCTION( PFNWGLSETPBUFFERATTRIBARBPROC, wglSetPbufferAttribARB )
#endif

// WGL_ARB_create_context
#ifdef WGL_ARB_create_context
VL_WGL_FUNCTION( PFNWGLCREATECONTEXTATTRIBSARBPROC, wglCreateContextAttribsARB )
#endif

// WGL_EXT_display_color_table
#ifdef WGL_EXT_display_color_table
VL_WGL_FUNCTION( PFNWGLCREATEDISPLAYCOLORTABLEEXTPROC, wglCreateDisplayColorTableEXT )
VL_WGL_FUNCTION( PFNWGLLOADDISPLAYCOLORTABLEEXTPROC, wglLoadDisplayColorTableEXT )
VL_WGL_FUNCTION( PFNWGLBINDDISPLAYCOLORTABLEEXTPROC, wglBindDisplayColorTableEXT )
VL_WGL_FUNCTION( PFNWGLDESTROYDISPLAYCOLORTABLEEXTPROC, wglDestroyDisplayColorTableEXT )
#endif

// WGL_EXT_extensions_string
#ifdef WGL_EXT_extensions_string
VL_WGL_FUNCTION( PFNWGLGETEXTENSIONSSTRINGEXTPROC, wglGetExtensionsStringEXT )
#endif

// WGL_EXT_make_current_read
#ifdef WGL_EXT_make_current_read
VL_WGL_FUNCTION( PFNWGLMAKECONTEXTCURRENTEXTPROC, wglMakeContextCurrentEXT )
VL_WGL_FUNCTION( PFNWGLGETCURRENTREADDCEXTPROC, wglGetCurrentReadDCEXT )
#endif

// WGL_EXT_pbuffer
#ifdef WGL_EXT_pbuffer
VL_WGL_FUNCTION( PFNWGLCREATEPBUFFEREXTPROC, wglCreatePbufferEXT )
VL_WGL_FUNCTION( PFNWGLGETPBUFFERDCEXTPROC, wglGetPbufferDCEXT )
VL_WGL_FUNCTION( PFNWGLRELEASEPBUFFERDCEXTPROC, wglReleasePbufferDCEXT )
VL_WGL_FUNCTION( PFNWGLDESTROYPBUFFEREXTPROC, wglDestroyPbufferEXT )
VL_WGL_FUNCTION( PFNWGLQUERYPBUFFEREXTPROC, wglQueryPbufferEXT )
#endif

// WGL_EXT_pixel_format
#ifdef WGL_EXT_pixel_format
VL_WGL_FUNCTION( PFNWGLGETPIXELFORMATATTRIBIVEXTPROC, wglGetPixelFormatAttribivEXT )
VL_WGL_FUNCTION( PFNWGLGETPIXELFORMATATTRIBFVEXTPROC, wglGetPixelFormatAttribfvEXT )
VL_WGL_FUNCTION( PFNWGLCHOOSEPIXELFORMATEXTPROC, wglChoosePixelFormatEXT )
#endif

// WGL_EXT_swap_control
#ifdef WGL_EXT_swap_control
VL_WGL_FUNCTION( PFNWGLSWAPINTERVALEXTPROC, wglSwapIntervalEXT )
VL_WGL_FUNCTION( PFNWGLGETSWAPINTERVALEXTPROC, wglGetSwapIntervalEXT )
#endif

// WGL_NV_vertex_array_range
#ifdef WGL_NV_vertex_array_range
VL_WGL_FUNCTION( PFNWGLALLOCATEMEMORYNVPROC, wglAllocateMemoryNV )
VL_WGL_FUNCTION( PFNWGLFREEMEMORYNVPROC, wglFreeMemoryNV )
#endif

// WGL_OML_sync_control
#ifdef WGL_OML_sync_control
VL_WGL_FUNCTION( PFNWGLGETSYNCVALUESOMLPROC, wglGetSyncValuesOML )
VL_WGL_FUNCTION( PFNWGLGETMSCRATEOMLPROC, wglGetMscRateOML )
VL_WGL_FUNCTION( PFNWGLSWAPBUFFERSMSCOMLPROC, wglSwapBuffersMscOML )
VL_WGL_FUNCTION( PFNWGLSWAPLAYERBUFFERSMSCOMLPROC, wglSwapLayerBuffersMscOML )
VL_WGL_FUNCTION( PFNWGLWAITFORMSCOMLPROC, wglWaitForMscOML )
VL_WGL_FUNCTION( PFNWGLWAITFORSBCOMLPROC, wglWaitForSbcOML )
#endif

// WGL_I3D_digital_video_control
#ifdef WGL_I3D_digital_video_control
VL_WGL_FUNCTION( PFNWGLGETDIGITALVIDEOPARAMETERSI3DPROC, wglGetDigitalVideoParametersI3D )
VL_WGL_FUNCTION( PFNWGLSETDIGITALVIDEOPARAMETERSI3DPROC, wglSetDigitalVideoParametersI3D )
#endif

// WGL_I3D_gamma
#ifdef WGL_I3D_gamma
VL_WGL_FUNCTION( PFNWGLGETGAMMATABLEPARAMETERSI3DPROC, wglGetGammaTableParametersI3D )
VL_WGL_FUNCTION( PFNWGLSETGAMMATABLEPARAMETERSI3DPROC, wglSetGammaTableParametersI3D )
VL_WGL_FUNCTION( PFNWGLGETGAMMATABLEI3DPROC, wglGetGammaTableI3D )
VL_WGL_FUNCTION( PFNWGLSETGAMMATABLEI3DPROC, wglSetGammaTableI3D )
#endif

// WGL_I3D_genlock
#ifdef WGL_I3D_genlock
VL_WGL_FUNCTION( PFNWGLENABLEGENLOCKI3DPROC, wglEnableGenlockI3D )
VL_WGL_FUNCTION( PFNWGLDISABLEGENLOCKI3DPROC, wglDisableGenlockI3D )
VL_WGL_FUNCTION( PFNWGLISENABLEDGENLOCKI3DPROC, wglIsEnabledGenlockI3D )
VL_WGL_FUNCTION( PFNWGLGENLOCKSOURCEI3DPROC, wglGenlockSourceI3D )
VL_WGL_FUNCTION( PFNWGLGETGENLOCKSOURCEI3DPROC, wglGetGenlockSourceI3D )
VL_WGL_FUNCTION( PFNWGLGENLOCKSOURCEEDGEI3DPROC, wglGenlockSourceEdgeI3D )
VL_WGL_FUNCTION( PFNWGLGETGENLOCKSOURCEEDGEI3DPROC, wglGetGenlockSourceEdgeI3D )
VL_WGL_FUNCTION( PFNWGLGENLOCKSAMPLERATEI3DPROC, wglGenlockSampleRateI3D )
VL_WGL_FUNCTION( PFNWGLGETGENLOCKSAMPLERATEI3DPROC, wglGetGenlockSampleRateI3D )
VL_WGL_FUNCTION( PFNWGLGENLOCKSOURCEDELAYI3DPROC, wglGenlockSourceDelayI3D )
VL_WGL_FUNCTION( PFNWGLGETGENLOCKSOURCEDELAYI3DPROC, wglGetGenlockSourceDelayI3D )
VL_WGL_FUNCTION( PFNWGLQUERYGENLOCKMAXSOURCEDELAYI3DPROC, wglQueryGenlockMaxSourceDelayI3D )
#endif

// WGL_I3D_image_buffer
#ifdef WGL_I3D_image_buffer
VL_WGL_FUNCTION( PFNWGLCREATEIMAGEBUFFERI3DPROC, wglCreateImageBufferI3D )
VL_WGL_FUNCTION( PFNWGLDESTROYIMAGEBUFFERI3DPROC, wglDestroyImageBufferI3D )
VL_WGL_FUNCTION( PFNWGLASSOCIATEIMAGEBUFFEREVENTSI3DPROC, wglAssociateImageBufferEventsI3D )
VL_WGL_FUNCTION( PFNWGLRELEASEIMAGEBUFFEREVENTSI3DPROC, wglReleaseImageBufferEventsI3D )
#endif

// WGL_I3D_swap_frame_lock
#ifdef WGL_I3D_swap_frame_lock
VL_WGL_FUNCTION( PFNWGLENABLEFRAMELOCKI3DPROC, wglEnableFrameLockI3D )
VL_WGL_FUNCTION( PFNWGLDISABLEFRAMELOCKI3DPROC, wglDisableFrameLockI3D )
VL_WGL_FUNCTION( PFNWGLISENABLEDFRAMELOCKI3DPROC, wglIsEnabledFrameLockI3D )
VL_WGL_FUNCTION( PFNWGLQUERYFRAMELOCKMASTERI3DPROC, wglQueryFrameLockMasterI3D )
#endif

// WGL_I3D_swap_frame_usage
#ifdef WGL_I3D_swap_frame_usage
VL_WGL_FUNCTION( PFNWGLGETFRAMEUSAGEI3DPROC, wglGetFrameUsageI3D )
VL_WGL_FUNCTION( PFNWGLBEGINFRAMETRACKINGI3DPROC, wglBeginFrameTrackingI3D )
VL_WGL_FUNCTION( PFNWGLENDFRAMETRACKINGI3DPROC, wglEndFrameTrackingI3D )
VL_WGL_FUNCTION( PFNWGLQUERYFRAMETRACKINGI3DPROC, wglQueryFrameTrackingI3D )
#endif

// WGL_3DL_stereo_control
#ifdef WGL_3DL_stereo_control
VL_WGL_FUNCTION( PFNWGLSETSTEREOEMITTERSTATE3DLPROC, wglSetStereoEmitterState3DL )
#endif

// WGL_NV_present_video
#ifdef WGL_NV_present_video
VL_WGL_FUNCTION( PFNWGLENUMERATEVIDEODEVICESNVPROC, wglEnumerateVideoDevicesNV )
VL_WGL_FUNCTION( PFNWGLBINDVIDEODEVICENVPROC, wglBindVideoDeviceNV )
VL_WGL_FUNCTION( PFNWGLQUERYCURRENTCONTEXTNVPROC, wglQueryCurrentContextNV )
#endif

// WGL_NV_video_output
#ifdef WGL_NV_video_output
VL_WGL_FUNCTION( PFNWGLGETVIDEODEVICENVPROC, wglGetVideoDeviceNV )
VL_WGL_FUNCTION( PFNWGLRELEASEVIDEODEVICENVPROC, wglReleaseVideoDeviceNV )
VL_WGL_FUNCTION( PFNWGLBINDVIDEOIMAGENVPROC, wglBindVideoImageNV )
VL_WGL_FUNCTION( PFNWGLRELEASEVIDEOIMAGENVPROC, wglReleaseVideoImageNV )
VL_WGL_FUNCTION( PFNWGLSENDPBUFFERTOVIDEONVPROC, wglSendPbufferToVideoNV )
VL_WGL_FUNCTION( PFNWGLGETVIDEOINFONVPROC, wglGetVideoInfoNV )
#endif

// WGL_NV_swap_group
#ifdef WGL_NV_swap_group
VL_WGL_FUNCTION( PFNWGLJOINSWAPGROUPNVPROC, wglJoinSwapGroupNV )
VL_WGL_FUNCTION( PFNWGLBINDSWAPBARRIERNVPROC, wglBindSwapBarrierNV )
VL_WGL_FUNCTION( PFNWGLQUERYSWAPGROUPNVPROC, wglQuerySwapGroupNV )
VL_WGL_FUNCTION( PFNWGLQUERYMAXSWAPGROUPSNVPROC, wglQueryMaxSwapGroupsNV )
VL_WGL_FUNCTION( PFNWGLQUERYFRAMECOUNTNVPROC, wglQueryFrameCountNV )
VL_WGL_FUNCTION( PFNWGLRESETFRAMECOUNTNVPROC, wglResetFrameCountNV )
#endif

// WGL_NV_gpu_affinity
#ifdef WGL_NV_gpu_affinity
VL_WGL_FUNCTION( PFNWGLENUMGPUSNVPROC, wglEnumGpusNV )
VL_WGL_FUNCTION( PFNWGLENUMGPUDEVICESNVPROC, wglEnumGpuDevicesNV )
VL_WGL_FUNCTION( PFNWGLCREATEAFFINITYDCNVPROC, wglCreateAffinityDCNV )
VL_WGL_FUNCTION( PFNWGLENUMGPUSFROMAFFINITYDCNVPROC, wglEnumGpusFromAffinityDCNV )
VL_WGL_FUNCTION( PFNWGLDELETEDCNVPROC, wglDeleteDCNV )
#endif

// WGL_AMD_gpu_association
#ifdef WGL_AMD_gpu_association
VL_WGL_FUNCTION( PFNWGLGETGPUIDSAMDPROC, wglGetGPUIDsAMD )
VL_WGL_FUNCTION( PFNWGLGETGPUINFOAMDPROC, wglGetGPUInfoAMD )
VL_WGL_FUNCTION( PFNWGLGETCONTEXTGPUIDAMDPROC, wglGetContextGPUIDAMD )
VL_WGL_FUNCTION( PFNWGLCREATEASSOCIATEDCONTEXTAMDPROC, wglCreateAssociatedContextAMD )
VL_WGL_FUNCTION( PFNWGLCREATEASSOCIATEDCONTEXTATTRIBSAMDPROC, wglCreateAssociatedContextAttribsAMD )
VL_WGL_FUNCTION( PFNWGLDELETEASSOCIATEDCONTEXTAMDPROC, wglDeleteAssociatedContextAMD )
VL_WGL_FUNCTION( PFNWGLMAKEASSOCIATEDCONTEXTCURRENTAMDPROC, wglMakeAssociatedContextCurrentAMD )
VL_WGL_FUNCTION( PFNWGLGETCURRENTASSOCIATEDCONTEXTAMDPROC, wglGetCurrentAssociatedContextAMD )
VL_WGL_FUNCTION( PFNWGLBLITCONTEXTFRAMEBUFFERAMDPROC, wglBlitContextFramebufferAMD )
#endif

// WGL_NV_video_capture
#ifdef WGL_NV_video_capture
VL_WGL_FUNCTION( PFNWGLBINDVIDEOCAPTUREDEVICENVPROC, wglBindVideoCaptureDeviceNV )
VL_WGL_FUNCTION( PFNWGLENUMERATEVIDEOCAPTUREDEVICESNVPROC, wglEnumerateVideoCaptureDevicesNV )
VL_WGL_FUNCTION( PFNWGLLOCKVIDEOCAPTUREDEVICENVPROC, wglLockVideoCaptureDeviceNV )
VL_WGL_FUNCTION( PFNWGLQUERYVIDEOCAPTUREDEVICENVPROC, wglQueryVideoCaptureDeviceNV )
VL_WGL_FUNCTION( PFNWGLRELEASEVIDEOCAPTUREDEVICENVPROC, wglReleaseVideoCaptureDeviceNV )
#endif

// WGL_NV_copy_image
#ifdef WGL_NV_copy_image
VL_WGL_FUNCTION( PFNWGLCOPYIMAGESUBDATANVPROC, wglCopyImageSubDataNV )
#endif

// WGL_NV_DX_interop
#ifdef WGL_NV_DX_interop
VL_WGL_FUNCTION( PFNWGLDXSETRESOURCESHAREHANDLENVPROC, wglDXSetResourceShareHandleNV )
VL_WGL_FUNCTION( PFNWGLDXOPENDEVICENVPROC, wglDXOpenDeviceNV )
VL_WGL_FUNCTION( PFNWGLDXCLOSEDEVICENVPROC, wglDXCloseDeviceNV )
VL_WGL_FUNCTION( PFNWGLDXREGISTEROBJECTNVPROC, wglDXRegisterObjectNV )
VL_WGL_FUNCTION( PFNWGLDXUNREGISTEROBJECTNVPROC, wglDXUnregisterObjectNV )
VL_WGL_FUNCTION( PFNWGLDXOBJECTACCESSNVPROC, wglDXObjectAccessNV )
VL_WGL_FUNCTION( PFNWGLDXLOCKOBJECTSNVPROC, wglDXLockObjectsNV )
VL_WGL_FUNCTION( PFNWGLDXUNLOCKOBJECTSNVPROC, wglDXUnlockObjectsNV )
#endif
